/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 30 "core/cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "shm_init.h"
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_core.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"
#include "async_task.h"

#include "kemi.h"
#include "ppcfg.h"
#include "pvapi.h"
#include "config.h"
#include "daemonize.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)

	#define IF_AUTO_BIND_IPV6(x) x

#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLOCKLIST
	#define IF_DST_BLOCKLIST(x) x
#else
	#define IF_DST_BLOCKLIST(x) warn("dst blocklist support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif

#ifdef USE_RAW_SOCKS
	#define IF_RAW_SOCKS(x) x
#else
	#define IF_RAW_SOCKS(x) warn("raw socket support not compiled in")
#endif


extern int yylex();
/* safer than using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp = NULL;
static int i_tmp = 0;
static struct socket_id* lst_tmp = NULL;
static struct name_lst* nl_tmp = NULL;
static int rt = 0;  /* Type of route block for find_export */
static str* str_tmp = NULL;
static str s_tmp = STR_NULL;
static struct ip_addr* ip_tmp = NULL;
static struct avp_spec* s_attr = NULL;
static select_t sel;
static select_t* sel_ptr = NULL;
static pv_spec_t* pv_spec = NULL;
static struct action *mod_func_action = NULL;
static struct lvalue* lval_tmp = NULL;
static struct rvalue* rval_tmp = NULL;
static struct rval_expr* rve_tmp = NULL;
static socket_attrs_t tmp_sa;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);
static int mod_f_params_pre_fixup(struct action* a);
static void free_mod_func_action(struct action* a);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;
extern char *routename;
extern char *default_routename;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		(x)->rname = (routename!=0)?routename:((default_routename!=0)?default_routename:"DEFAULT");\
		}\
	}while(0)



#line 235 "core/cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CORE_CFG_TAB_H_INCLUDED
# define YY_YY_CORE_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    FORWARD = 258,
    FORWARD_TCP = 259,
    FORWARD_TLS = 260,
    FORWARD_SCTP = 261,
    FORWARD_UDP = 262,
    EXIT = 263,
    DROP = 264,
    RETURN = 265,
    RETURN_MODE = 266,
    BREAK = 267,
    LOG_TOK = 268,
    ERROR = 269,
    ROUTE = 270,
    ROUTE_REQUEST = 271,
    ROUTE_FAILURE = 272,
    ROUTE_ONREPLY = 273,
    ROUTE_REPLY = 274,
    ROUTE_BRANCH = 275,
    ROUTE_SEND = 276,
    ROUTE_EVENT = 277,
    EXEC = 278,
    SET_HOST = 279,
    SET_HOSTPORT = 280,
    SET_HOSTPORTTRANS = 281,
    PREFIX = 282,
    STRIP = 283,
    STRIP_TAIL = 284,
    SET_USERPHONE = 285,
    APPEND_BRANCH = 286,
    REMOVE_BRANCH = 287,
    CLEAR_BRANCHES = 288,
    SET_USER = 289,
    SET_USERPASS = 290,
    SET_PORT = 291,
    SET_URI = 292,
    REVERT_URI = 293,
    FORCE_RPORT = 294,
    ADD_LOCAL_RPORT = 295,
    LOCAL_RPORT = 296,
    FORCE_TCP_ALIAS = 297,
    UDP_MTU = 298,
    UDP_MTU_TRY_PROTO = 299,
    UDP_RECEIVER_MODE = 300,
    UDP4_RAW = 301,
    UDP4_RAW_MTU = 302,
    UDP4_RAW_TTL = 303,
    IF = 304,
    ELSE = 305,
    SET_ADV_ADDRESS = 306,
    SET_ADV_PORT = 307,
    FORCE_SEND_SOCKET = 308,
    SET_FWD_NO_CONNECT = 309,
    SET_RPL_NO_CONNECT = 310,
    SET_FWD_CLOSE = 311,
    SET_RPL_CLOSE = 312,
    SWITCH = 313,
    CASE = 314,
    DEFAULT = 315,
    WHILE = 316,
    CFG_SELECT = 317,
    CFG_RESET = 318,
    URIHOST = 319,
    URIPORT = 320,
    MAX_LEN = 321,
    SETFLAG = 322,
    RESETFLAG = 323,
    ISFLAGSET = 324,
    SETAVPFLAG = 325,
    RESETAVPFLAG = 326,
    ISAVPFLAGSET = 327,
    METHOD = 328,
    URI = 329,
    FROM_URI = 330,
    TO_URI = 331,
    SRCIP = 332,
    SRCPORT = 333,
    DSTIP = 334,
    DSTPORT = 335,
    TOIP = 336,
    TOPORT = 337,
    SNDIP = 338,
    SNDPORT = 339,
    SNDPROTO = 340,
    SNDAF = 341,
    PROTO = 342,
    AF = 343,
    MYSELF = 344,
    MSGLEN = 345,
    UDP = 346,
    TCP = 347,
    TLS = 348,
    SCTP = 349,
    WS = 350,
    WSS = 351,
    DEBUG_V = 352,
    FORK = 353,
    FORK_DELAY = 354,
    MODINIT_DELAY = 355,
    LOGSTDERROR = 356,
    LOGFACILITY = 357,
    LOGNAME = 358,
    LOGCOLOR = 359,
    LOGPREFIX = 360,
    LOGPREFIXMODE = 361,
    LOGENGINETYPE = 362,
    LOGENGINEDATA = 363,
    XAVPVIAPARAMS = 364,
    XAVPVIAFIELDS = 365,
    XAVPVIAREPLYPARAMS = 366,
    LISTEN = 367,
    ADVERTISE = 368,
    VIRTUAL = 369,
    STRNAME = 370,
    ALIAS = 371,
    SR_AUTO_ALIASES = 372,
    DOMAIN = 373,
    SR_AUTO_DOMAINS = 374,
    DNS = 375,
    REV_DNS = 376,
    DNS_TRY_IPV6 = 377,
    DNS_TRY_NAPTR = 378,
    DNS_SRV_LB = 379,
    DNS_UDP_PREF = 380,
    DNS_TCP_PREF = 381,
    DNS_TLS_PREF = 382,
    DNS_SCTP_PREF = 383,
    DNS_RETR_TIME = 384,
    DNS_SLOW_QUERY_MS = 385,
    DNS_RETR_NO = 386,
    DNS_SERVERS_NO = 387,
    DNS_USE_SEARCH = 388,
    DNS_SEARCH_FMATCH = 389,
    DNS_NAPTR_IGNORE_RFC = 390,
    DNS_CACHE_INIT = 391,
    DNS_USE_CACHE = 392,
    DNS_USE_FAILOVER = 393,
    DNS_CACHE_FLAGS = 394,
    DNS_CACHE_NEG_TTL = 395,
    DNS_CACHE_MIN_TTL = 396,
    DNS_CACHE_MAX_TTL = 397,
    DNS_CACHE_MEM = 398,
    DNS_CACHE_GC_INT = 399,
    DNS_CACHE_DEL_NONEXP = 400,
    DNS_CACHE_REC_PREF = 401,
    AUTO_BIND_IPV6 = 402,
    BIND_IPV6_LINK_LOCAL = 403,
    IPV6_HEX_STYLE = 404,
    DST_BLST_INIT = 405,
    USE_DST_BLST = 406,
    DST_BLST_MEM = 407,
    DST_BLST_TTL = 408,
    DST_BLST_GC_INT = 409,
    DST_BLST_UDP_IMASK = 410,
    DST_BLST_TCP_IMASK = 411,
    DST_BLST_TLS_IMASK = 412,
    DST_BLST_SCTP_IMASK = 413,
    IP_FREE_BIND = 414,
    PORT = 415,
    STAT = 416,
    STATS_NAMESEP = 417,
    CHILDREN = 418,
    SOCKET = 419,
    BIND = 420,
    WORKERS = 421,
    SOCKET_WORKERS = 422,
    ASYNC_WORKERS = 423,
    ASYNC_USLEEP = 424,
    ASYNC_NONBLOCK = 425,
    ASYNC_WORKERS_GROUP = 426,
    CHECK_VIA = 427,
    PHONE2TEL = 428,
    MEMLOG = 429,
    MEMDBG = 430,
    MEMSUM = 431,
    MEMSAFETY = 432,
    MEMADDSIZE = 433,
    MEMJOIN = 434,
    MEMSTATUSMODE = 435,
    SIP_PARSER_LOG_ONELINE = 436,
    SIP_PARSER_LOG = 437,
    SIP_PARSER_MODE = 438,
    CORELOG = 439,
    SIP_WARNING = 440,
    SERVER_SIGNATURE = 441,
    SERVER_HEADER = 442,
    USER_AGENT_HEADER = 443,
    REPLY_TO_VIA = 444,
    LOADMODULE = 445,
    LOADMODULEX = 446,
    LOADPATH = 447,
    MODPARAM = 448,
    MODPARAMX = 449,
    CFGENGINE = 450,
    MAXBUFFER = 451,
    MAXSNDBUFFER = 452,
    SQL_BUFFER_SIZE = 453,
    MSG_RECV_MAX_SIZE = 454,
    TCP_MSG_READ_TIMEOUT = 455,
    TCP_MSG_DATA_TIMEOUT = 456,
    TCP_ACCEPT_IPLIMIT = 457,
    TCP_CHECK_TIMER = 458,
    USER = 459,
    GROUP = 460,
    CHROOT = 461,
    WDIR = 462,
    RUNDIR = 463,
    MHOMED = 464,
    DISABLE_TCP = 465,
    TCP_ACCEPT_ALIASES = 466,
    TCP_ACCEPT_UNIQUE = 467,
    TCP_CONNECTION_MATCH = 468,
    TCP_CHILDREN = 469,
    TCP_CONNECT_TIMEOUT = 470,
    TCP_SEND_TIMEOUT = 471,
    TCP_CON_LIFETIME = 472,
    TCP_POLL_METHOD = 473,
    TCP_MAX_CONNECTIONS = 474,
    TLS_MAX_CONNECTIONS = 475,
    TCP_NO_CONNECT = 476,
    TCP_SOURCE_IPV4 = 477,
    TCP_SOURCE_IPV6 = 478,
    TCP_OPT_FD_CACHE = 479,
    TCP_OPT_BUF_WRITE = 480,
    TCP_OPT_CONN_WQ_MAX = 481,
    TCP_OPT_WQ_MAX = 482,
    TCP_OPT_RD_BUF = 483,
    TCP_OPT_WQ_BLK = 484,
    TCP_OPT_DEFER_ACCEPT = 485,
    TCP_OPT_DELAYED_ACK = 486,
    TCP_OPT_SYNCNT = 487,
    TCP_OPT_LINGER2 = 488,
    TCP_OPT_KEEPALIVE = 489,
    TCP_OPT_KEEPIDLE = 490,
    TCP_OPT_KEEPINTVL = 491,
    TCP_OPT_KEEPCNT = 492,
    TCP_OPT_CRLF_PING = 493,
    TCP_OPT_ACCEPT_NO_CL = 494,
    TCP_OPT_ACCEPT_HEP3 = 495,
    TCP_OPT_ACCEPT_HAPROXY = 496,
    TCP_OPT_CLOSE_RST = 497,
    TCP_CLONE_RCVBUF = 498,
    TCP_REUSE_PORT = 499,
    TCP_WAIT_DATA = 500,
    TCP_SCRIPT_MODE = 501,
    DISABLE_TLS = 502,
    ENABLE_TLS = 503,
    TLS_THREADS_MODE = 504,
    TLSLOG = 505,
    TLS_PORT_NO = 506,
    TLS_METHOD = 507,
    TLS_HANDSHAKE_TIMEOUT = 508,
    TLS_SEND_TIMEOUT = 509,
    SSLv23 = 510,
    SSLv2 = 511,
    SSLv3 = 512,
    TLSv1 = 513,
    TLS_VERIFY = 514,
    TLS_REQUIRE_CERTIFICATE = 515,
    TLS_CERTIFICATE = 516,
    TLS_PRIVATE_KEY = 517,
    TLS_CA_LIST = 518,
    DISABLE_SCTP = 519,
    ENABLE_SCTP = 520,
    SCTP_CHILDREN = 521,
    ADVERTISED_ADDRESS = 522,
    ADVERTISED_PORT = 523,
    DISABLE_CORE = 524,
    OPEN_FD_LIMIT = 525,
    SHM_MEM_SZ = 526,
    SHM_FORCE_ALLOC = 527,
    MLOCK_PAGES = 528,
    REAL_TIME = 529,
    RT_PRIO = 530,
    RT_POLICY = 531,
    RT_TIMER1_PRIO = 532,
    RT_TIMER1_POLICY = 533,
    RT_TIMER2_PRIO = 534,
    RT_TIMER2_POLICY = 535,
    MCAST_LOOPBACK = 536,
    MCAST_TTL = 537,
    MCAST = 538,
    TOS = 539,
    PMTU_DISCOVERY = 540,
    KILL_TIMEOUT = 541,
    MAX_WLOOPS = 542,
    PVBUFSIZE = 543,
    PVBUFSLOTS = 544,
    PVCACHELIMIT = 545,
    PVCACHEACTION = 546,
    HTTP_REPLY_PARSE = 547,
    VERSION_TABLE_CFG = 548,
    VERBOSE_STARTUP = 549,
    ROUTE_LOCKS_SIZE = 550,
    WAIT_WORKER1_MODE = 551,
    WAIT_WORKER1_TIME = 552,
    WAIT_WORKER1_USLEEP = 553,
    CFG_DESCRIPTION = 554,
    SERVER_ID = 555,
    KEMI = 556,
    REQUEST_ROUTE_CALLBACK = 557,
    ONSEND_ROUTE_CALLBACK = 558,
    REPLY_ROUTE_CALLBACK = 559,
    EVENT_ROUTE_CALLBACK = 560,
    RECEIVED_ROUTE_CALLBACK = 561,
    RECEIVED_ROUTE_MODE = 562,
    PRE_ROUTING_CALLBACK = 563,
    MAX_RECURSIVE_LEVEL = 564,
    MAX_BRANCHES_PARAM = 565,
    LATENCY_CFG_LOG = 566,
    LATENCY_LOG = 567,
    LATENCY_LIMIT_DB = 568,
    LATENCY_LIMIT_ACTION = 569,
    LATENCY_LIMIT_CFG = 570,
    RPC_EXEC_DELTA_CFG = 571,
    MSG_TIME = 572,
    ONSEND_RT_REPLY = 573,
    URI_HOST_EXTRA_CHARS = 574,
    HDR_NAME_EXTRA_CHARS = 575,
    FLAGS_DECL = 576,
    AVPFLAGS_DECL = 577,
    ATTR_MARK = 578,
    SELECT_MARK = 579,
    ATTR_FROM = 580,
    ATTR_TO = 581,
    ATTR_FROMURI = 582,
    ATTR_TOURI = 583,
    ATTR_FROMUSER = 584,
    ATTR_TOUSER = 585,
    ATTR_FROMDOMAIN = 586,
    ATTR_TODOMAIN = 587,
    ATTR_GLOBAL = 588,
    ADDEQ = 589,
    SUBST = 590,
    SUBSTDEF = 591,
    SUBSTDEFS = 592,
    EQUAL = 593,
    LOG_OR = 594,
    LOG_AND = 595,
    BIN_OR = 596,
    BIN_AND = 597,
    BIN_XOR = 598,
    BIN_LSHIFT = 599,
    BIN_RSHIFT = 600,
    EQUAL_T = 601,
    DIFF = 602,
    MATCH = 603,
    INTEQ = 604,
    INTDIFF = 605,
    STREQ = 606,
    STRDIFF = 607,
    GT = 608,
    LT = 609,
    GTE = 610,
    LTE = 611,
    PLUS = 612,
    MINUS = 613,
    STAR = 614,
    SLASH = 615,
    MODULO = 616,
    NOT = 617,
    UNARY = 618,
    BIN_NOT = 619,
    DEFINED = 620,
    INTCAST = 621,
    STRCAST = 622,
    DOT = 623,
    STRLEN = 624,
    STREMPTY = 625,
    SELVAL = 626,
    NUMBER = 627,
    ID = 628,
    NUM_ID = 629,
    STRING = 630,
    IPV6ADDR = 631,
    PVAR = 632,
    AVP_OR_PVAR = 633,
    EVENT_RT_NAME = 634,
    COMMA = 635,
    SEMICOLON = 636,
    RPAREN = 637,
    LPAREN = 638,
    LBRACE = 639,
    RBRACE = 640,
    LBRACK = 641,
    RBRACK = 642,
    CR = 643,
    COLON = 644
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 199 "core/cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct case_stms* case_stms;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct name_lst* name_l;
	struct avp_spec* attr;
	struct _pv_spec* pvar;
	struct lvalue* lval;
	struct rvalue* rval;
	struct rval_expr* rv_expr;
	select_t* select;

#line 684 "core/cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CORE_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 701 "core/cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  534
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   13110

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  390
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  108
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1015
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1919

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   644

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   668,   668,   671,   672,   673,   676,   677,   678,   679,
     680,   681,   681,   682,   682,   683,   684,   684,   685,   685,
     686,   686,   687,   688,   691,   708,   717,   732,   733,   739,
     740,   744,   745,   746,   747,   748,   751,   752,   753,   754,
     755,   756,   757,   760,   761,   762,   763,   764,   765,   769,
     770,   773,   774,   775,   776,   777,   781,   782,   783,   784,
     785,   789,   790,   793,   794,   797,   798,   800,   801,   804,
     807,   813,   814,   818,   819,   822,   823,   826,   832,   838,
     843,   848,   852,   853,   857,   858,   863,   869,   870,   871,
     872,   873,   876,   877,   880,   881,   882,   883,   884,   885,
     886,   887,   888,   891,   892,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   914,
     915,   918,   919,   922,   923,   924,   925,   926,   927,   928,
     929,   930,   931,   932,   933,   934,   935,   936,   937,   938,
     939,   941,   942,   943,   944,   945,   946,   947,   948,   949,
     950,   951,   952,   953,   954,   955,   956,   957,   958,   959,
     960,   961,   962,   963,   964,   965,   966,   967,   968,   969,
     970,   971,   972,   973,   974,   975,   976,   977,   978,   979,
     980,   988,   989,   990,   991,   992,   993,   996,   997,  1000,
    1001,  1004,  1005,  1006,  1007,  1010,  1011,  1014,  1015,  1018,
    1019,  1022,  1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,  1046,  1047,  1047,  1056,  1057,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,
    1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
    1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,
    1088,  1089,  1090,  1091,  1092,  1093,  1094,  1097,  1098,  1105,
    1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,
    1122,  1123,  1124,  1125,  1126,  1127,  1134,  1135,  1142,  1143,
    1150,  1151,  1158,  1159,  1166,  1167,  1174,  1175,  1182,  1183,
    1193,  1194,  1208,  1222,  1223,  1230,  1231,  1238,  1239,  1246,
    1247,  1256,  1257,  1266,  1267,  1274,  1275,  1282,  1283,  1290,
    1291,  1298,  1299,  1306,  1307,  1314,  1315,  1322,  1323,  1330,
    1331,  1338,  1339,  1346,  1347,  1354,  1355,  1362,  1363,  1370,
    1371,  1378,  1379,  1386,  1387,  1394,  1395,  1402,  1403,  1410,
    1411,  1418,  1420,  1427,  1428,  1439,  1440,  1447,  1448,  1455,
    1456,  1463,  1464,  1471,  1472,  1479,  1480,  1487,  1488,  1495,
    1496,  1503,  1510,  1517,  1524,  1531,  1538,  1539,  1546,  1547,
    1554,  1555,  1562,  1563,  1570,  1571,  1578,  1579,  1586,  1587,
    1594,  1595,  1602,  1603,  1610,  1611,  1612,  1613,  1616,  1617,
    1620,  1621,  1622,  1623,  1624,  1625,  1626,  1627,  1639,  1652,
    1664,  1677,  1690,  1703,  1717,  1730,  1743,  1757,  1771,  1784,
    1798,  1811,  1825,  1827,  1838,  1839,  1850,  1851,  1852,  1853,
    1854,  1855,  1861,  1862,  1872,  1873,  1874,  1875,  1876,  1877,
    1891,  1892,  1899,  1900,  1901,  1902,  1903,  1904,  1905,  1906,
    1907,  1908,  1909,  1910,  1911,  1912,  1913,  1914,  1915,  1916,
    1923,  1924,  1931,  1932,  1939,  1946,  1947,  1948,  1975,  1976,
    1977,  1978,  1979,  1980,  1981,  1982,  1983,  1984,  1985,  1986,
    1987,  1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,
    1997,  1998,  1999,  2000,  2001,  2002,  2003,  2004,  2005,  2006,
    2013,  2014,  2023,  2024,  2033,  2034,  2043,  2044,  2053,  2054,
    2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,  2071,  2072,
    2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,  2081,  2082,
    2083,  2084,  2085,  2086,  2087,  2088,  2090,  2091,  2092,  2093,
    2095,  2097,  2098,  2099,  2102,  2103,  2106,  2107,  2108,  2111,
    2112,  2115,  2116,  2117,  2125,  2130,  2135,  2140,  2145,  2148,
    2153,  2161,  2167,  2173,  2179,  2180,  2186,  2192,  2198,  2199,
    2209,  2210,  2220,  2221,  2230,  2239,  2240,  2249,  2258,  2267,
    2268,  2274,  2275,  2281,  2285,  2286,  2289,  2318,  2333,  2334,
    2338,  2349,  2350,  2354,  2355,  2359,  2366,  2382,  2383,  2386,
    2389,  2396,  2412,  2416,  2417,  2422,  2422,  2429,  2430,  2432,
    2431,  2454,  2459,  2462,  2469,  2485,  2488,  2491,  2498,  2514,
    2517,  2520,  2537,  2540,  2541,  2542,  2543,  2544,  2545,  2567,
    2568,  2569,  2570,  2573,  2574,  2575,  2576,  2579,  2580,  2586,
    2587,  2588,  2589,  2590,  2591,  2592,  2595,  2596,  2597,  2598,
    2605,  2606,  2607,  2614,  2615,  2616,  2620,  2621,  2622,  2623,
    2624,  2629,  2630,  2633,  2634,  2635,  2641,  2643,  2645,  2646,
    2648,  2650,  2652,  2654,  2656,  2657,  2659,  2660,  2661,  2662,
    2664,  2666,  2668,  2670,  2672,  2674,  2675,  2711,  2713,  2715,
    2717,  2720,  2722,  2724,  2726,  2730,  2731,  2742,  2743,  2747,
    2748,  2763,  2778,  2779,  2782,  2783,  2784,  2798,  2799,  2814,
    2829,  2831,  2838,  2880,  2881,  2884,  2885,  2886,  2889,  2890,
    2891,  2892,  2893,  2894,  2895,  2896,  2899,  2907,  2917,  2934,
    2941,  2948,  2955,  2962,  2967,  2972,  2973,  2974,  2975,  2976,
    2979,  2988,  2995,  3020,  3036,  3037,  3042,  3061,  3070,  3082,
    3097,  3098,  3101,  3101,  3111,  3112,  3113,  3114,  3115,  3116,
    3117,  3118,  3119,  3122,  3125,  3126,  3129,  3136,  3139,  3146,
    3152,  3153,  3162,  3163,  3164,  3167,  3168,  3180,  3204,  3215,
    3246,  3250,  3260,  3274,  3286,  3287,  3289,  3290,  3291,  3305,
    3306,  3307,  3308,  3309,  3310,  3311,  3315,  3316,  3317,  3330,
    3336,  3337,  3338,  3339,  3340,  3341,  3342,  3343,  3344,  3345,
    3346,  3347,  3348,  3349,  3350,  3368,  3369,  3370,  3371,  3372,
    3373,  3374,  3382,  3383,  3384,  3385,  3386,  3387,  3388,  3389,
    3390,  3391,  3392,  3394,  3396,  3397,  3398,  3399,  3400,  3401,
    3404,  3422,  3423,  3424,  3427,  3428,  3429,  3430,  3431,  3432,
    3433,  3434,  3435,  3436,  3437,  3438,  3439,  3440,  3441,  3442,
    3443,  3444,  3445,  3446,  3447,  3448,  3449,  3450,  3451,  3452,
    3453,  3454,  3455,  3456,  3457,  3458,  3459,  3460,  3461,  3469,
    3477,  3485,  3493,  3501,  3509,  3517,  3525,  3533,  3534,  3536,
    3544,  3552,  3560,  3569,  3578,  3587,  3595,  3604,  3612,  3613,
    3615,  3618,  3619,  3620,  3621,  3628,  3635,  3636,  3642,  3649,
    3650,  3656,  3663,  3664,  3670,  3673,  3676,  3677,  3678,  3681,
    3682,  3683,  3692,  3701,  3702,  3703,  3704,  3705,  3706,  3707,
    3708,  3709,  3710,  3711,  3712,  3713,  3714,  3715,  3716,  3717,
    3718,  3722,  3726,  3727,  3728,  3729,  3730,  3731,  3732,  3733,
    3734,  3735,  3736,  3737,  3738,  3739,  3740,  3741,  3742,  3743,
    3744,  3745,  3746,  3747,  3748,  3749,  3750,  3751,  3752,  3753,
    3761,  3769,  3777,  3778,  3780,  3782,  3793,  3794,  3795,  3811,
    3812,  3813,  3817,  3820,  3821,  3824,  3827,  3830,  3833,  3836,
    3839,  3842,  3845,  3848,  3851,  3852,  3853,  3856,  3857,  3858,
    3858,  3891,  3893,  3895,  3896,  3899,  3916,  3920,  3924,  3928,
    3933,  3937,  3942,  3946,  3950,  3954
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FORWARD", "FORWARD_TCP", "FORWARD_TLS",
  "FORWARD_SCTP", "FORWARD_UDP", "EXIT", "DROP", "RETURN", "RETURN_MODE",
  "BREAK", "LOG_TOK", "ERROR", "ROUTE", "ROUTE_REQUEST", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_REPLY", "ROUTE_BRANCH", "ROUTE_SEND",
  "ROUTE_EVENT", "EXEC", "SET_HOST", "SET_HOSTPORT", "SET_HOSTPORTTRANS",
  "PREFIX", "STRIP", "STRIP_TAIL", "SET_USERPHONE", "APPEND_BRANCH",
  "REMOVE_BRANCH", "CLEAR_BRANCHES", "SET_USER", "SET_USERPASS",
  "SET_PORT", "SET_URI", "REVERT_URI", "FORCE_RPORT", "ADD_LOCAL_RPORT",
  "LOCAL_RPORT", "FORCE_TCP_ALIAS", "UDP_MTU", "UDP_MTU_TRY_PROTO",
  "UDP_RECEIVER_MODE", "UDP4_RAW", "UDP4_RAW_MTU", "UDP4_RAW_TTL", "IF",
  "ELSE", "SET_ADV_ADDRESS", "SET_ADV_PORT", "FORCE_SEND_SOCKET",
  "SET_FWD_NO_CONNECT", "SET_RPL_NO_CONNECT", "SET_FWD_CLOSE",
  "SET_RPL_CLOSE", "SWITCH", "CASE", "DEFAULT", "WHILE", "CFG_SELECT",
  "CFG_RESET", "URIHOST", "URIPORT", "MAX_LEN", "SETFLAG", "RESETFLAG",
  "ISFLAGSET", "SETAVPFLAG", "RESETAVPFLAG", "ISAVPFLAGSET", "METHOD",
  "URI", "FROM_URI", "TO_URI", "SRCIP", "SRCPORT", "DSTIP", "DSTPORT",
  "TOIP", "TOPORT", "SNDIP", "SNDPORT", "SNDPROTO", "SNDAF", "PROTO", "AF",
  "MYSELF", "MSGLEN", "UDP", "TCP", "TLS", "SCTP", "WS", "WSS", "DEBUG_V",
  "FORK", "FORK_DELAY", "MODINIT_DELAY", "LOGSTDERROR", "LOGFACILITY",
  "LOGNAME", "LOGCOLOR", "LOGPREFIX", "LOGPREFIXMODE", "LOGENGINETYPE",
  "LOGENGINEDATA", "XAVPVIAPARAMS", "XAVPVIAFIELDS", "XAVPVIAREPLYPARAMS",
  "LISTEN", "ADVERTISE", "VIRTUAL", "STRNAME", "ALIAS", "SR_AUTO_ALIASES",
  "DOMAIN", "SR_AUTO_DOMAINS", "DNS", "REV_DNS", "DNS_TRY_IPV6",
  "DNS_TRY_NAPTR", "DNS_SRV_LB", "DNS_UDP_PREF", "DNS_TCP_PREF",
  "DNS_TLS_PREF", "DNS_SCTP_PREF", "DNS_RETR_TIME", "DNS_SLOW_QUERY_MS",
  "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH", "DNS_SEARCH_FMATCH",
  "DNS_NAPTR_IGNORE_RFC", "DNS_CACHE_INIT", "DNS_USE_CACHE",
  "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS", "DNS_CACHE_NEG_TTL",
  "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL", "DNS_CACHE_MEM",
  "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP", "DNS_CACHE_REC_PREF",
  "AUTO_BIND_IPV6", "BIND_IPV6_LINK_LOCAL", "IPV6_HEX_STYLE",
  "DST_BLST_INIT", "USE_DST_BLST", "DST_BLST_MEM", "DST_BLST_TTL",
  "DST_BLST_GC_INT", "DST_BLST_UDP_IMASK", "DST_BLST_TCP_IMASK",
  "DST_BLST_TLS_IMASK", "DST_BLST_SCTP_IMASK", "IP_FREE_BIND", "PORT",
  "STAT", "STATS_NAMESEP", "CHILDREN", "SOCKET", "BIND", "WORKERS",
  "SOCKET_WORKERS", "ASYNC_WORKERS", "ASYNC_USLEEP", "ASYNC_NONBLOCK",
  "ASYNC_WORKERS_GROUP", "CHECK_VIA", "PHONE2TEL", "MEMLOG", "MEMDBG",
  "MEMSUM", "MEMSAFETY", "MEMADDSIZE", "MEMJOIN", "MEMSTATUSMODE",
  "SIP_PARSER_LOG_ONELINE", "SIP_PARSER_LOG", "SIP_PARSER_MODE", "CORELOG",
  "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER", "USER_AGENT_HEADER",
  "REPLY_TO_VIA", "LOADMODULE", "LOADMODULEX", "LOADPATH", "MODPARAM",
  "MODPARAMX", "CFGENGINE", "MAXBUFFER", "MAXSNDBUFFER", "SQL_BUFFER_SIZE",
  "MSG_RECV_MAX_SIZE", "TCP_MSG_READ_TIMEOUT", "TCP_MSG_DATA_TIMEOUT",
  "TCP_ACCEPT_IPLIMIT", "TCP_CHECK_TIMER", "USER", "GROUP", "CHROOT",
  "WDIR", "RUNDIR", "MHOMED", "DISABLE_TCP", "TCP_ACCEPT_ALIASES",
  "TCP_ACCEPT_UNIQUE", "TCP_CONNECTION_MATCH", "TCP_CHILDREN",
  "TCP_CONNECT_TIMEOUT", "TCP_SEND_TIMEOUT", "TCP_CON_LIFETIME",
  "TCP_POLL_METHOD", "TCP_MAX_CONNECTIONS", "TLS_MAX_CONNECTIONS",
  "TCP_NO_CONNECT", "TCP_SOURCE_IPV4", "TCP_SOURCE_IPV6",
  "TCP_OPT_FD_CACHE", "TCP_OPT_BUF_WRITE", "TCP_OPT_CONN_WQ_MAX",
  "TCP_OPT_WQ_MAX", "TCP_OPT_RD_BUF", "TCP_OPT_WQ_BLK",
  "TCP_OPT_DEFER_ACCEPT", "TCP_OPT_DELAYED_ACK", "TCP_OPT_SYNCNT",
  "TCP_OPT_LINGER2", "TCP_OPT_KEEPALIVE", "TCP_OPT_KEEPIDLE",
  "TCP_OPT_KEEPINTVL", "TCP_OPT_KEEPCNT", "TCP_OPT_CRLF_PING",
  "TCP_OPT_ACCEPT_NO_CL", "TCP_OPT_ACCEPT_HEP3", "TCP_OPT_ACCEPT_HAPROXY",
  "TCP_OPT_CLOSE_RST", "TCP_CLONE_RCVBUF", "TCP_REUSE_PORT",
  "TCP_WAIT_DATA", "TCP_SCRIPT_MODE", "DISABLE_TLS", "ENABLE_TLS",
  "TLS_THREADS_MODE", "TLSLOG", "TLS_PORT_NO", "TLS_METHOD",
  "TLS_HANDSHAKE_TIMEOUT", "TLS_SEND_TIMEOUT", "SSLv23", "SSLv2", "SSLv3",
  "TLSv1", "TLS_VERIFY", "TLS_REQUIRE_CERTIFICATE", "TLS_CERTIFICATE",
  "TLS_PRIVATE_KEY", "TLS_CA_LIST", "DISABLE_SCTP", "ENABLE_SCTP",
  "SCTP_CHILDREN", "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE",
  "OPEN_FD_LIMIT", "SHM_MEM_SZ", "SHM_FORCE_ALLOC", "MLOCK_PAGES",
  "REAL_TIME", "RT_PRIO", "RT_POLICY", "RT_TIMER1_PRIO",
  "RT_TIMER1_POLICY", "RT_TIMER2_PRIO", "RT_TIMER2_POLICY",
  "MCAST_LOOPBACK", "MCAST_TTL", "MCAST", "TOS", "PMTU_DISCOVERY",
  "KILL_TIMEOUT", "MAX_WLOOPS", "PVBUFSIZE", "PVBUFSLOTS", "PVCACHELIMIT",
  "PVCACHEACTION", "HTTP_REPLY_PARSE", "VERSION_TABLE_CFG",
  "VERBOSE_STARTUP", "ROUTE_LOCKS_SIZE", "WAIT_WORKER1_MODE",
  "WAIT_WORKER1_TIME", "WAIT_WORKER1_USLEEP", "CFG_DESCRIPTION",
  "SERVER_ID", "KEMI", "REQUEST_ROUTE_CALLBACK", "ONSEND_ROUTE_CALLBACK",
  "REPLY_ROUTE_CALLBACK", "EVENT_ROUTE_CALLBACK",
  "RECEIVED_ROUTE_CALLBACK", "RECEIVED_ROUTE_MODE", "PRE_ROUTING_CALLBACK",
  "MAX_RECURSIVE_LEVEL", "MAX_BRANCHES_PARAM", "LATENCY_CFG_LOG",
  "LATENCY_LOG", "LATENCY_LIMIT_DB", "LATENCY_LIMIT_ACTION",
  "LATENCY_LIMIT_CFG", "RPC_EXEC_DELTA_CFG", "MSG_TIME", "ONSEND_RT_REPLY",
  "URI_HOST_EXTRA_CHARS", "HDR_NAME_EXTRA_CHARS", "FLAGS_DECL",
  "AVPFLAGS_DECL", "ATTR_MARK", "SELECT_MARK", "ATTR_FROM", "ATTR_TO",
  "ATTR_FROMURI", "ATTR_TOURI", "ATTR_FROMUSER", "ATTR_TOUSER",
  "ATTR_FROMDOMAIN", "ATTR_TODOMAIN", "ATTR_GLOBAL", "ADDEQ", "SUBST",
  "SUBSTDEF", "SUBSTDEFS", "EQUAL", "LOG_OR", "LOG_AND", "BIN_OR",
  "BIN_AND", "BIN_XOR", "BIN_LSHIFT", "BIN_RSHIFT", "EQUAL_T", "DIFF",
  "MATCH", "INTEQ", "INTDIFF", "STREQ", "STRDIFF", "GT", "LT", "GTE",
  "LTE", "PLUS", "MINUS", "STAR", "SLASH", "MODULO", "NOT", "UNARY",
  "BIN_NOT", "DEFINED", "INTCAST", "STRCAST", "DOT", "STRLEN", "STREMPTY",
  "SELVAL", "NUMBER", "ID", "NUM_ID", "STRING", "IPV6ADDR", "PVAR",
  "AVP_OR_PVAR", "EVENT_RT_NAME", "COMMA", "SEMICOLON", "RPAREN", "LPAREN",
  "LBRACE", "RBRACE", "LBRACK", "RBRACK", "CR", "COLON", "$accept", "cfg",
  "statements", "statement", "$@1", "$@2", "$@3", "$@4", "$@5",
  "listen_id", "listen_id_lst", "listen_id2", "proto", "eqproto", "xproto",
  "port", "phostport", "listen_phostport", "id_lst", "intno", "flags_decl",
  "flag_list", "flag_spec", "flag_name", "avpflags_decl", "avpflag_list",
  "avpflag_spec", "socket_lattr", "socket_lattrs", "assign_stm", "$@6",
  "cfg_var_id", "cfg_var_idn", "cfg_var", "module_stm", "ip", "ipv4",
  "ipv6addr", "ipv6", "route_name", "route_main", "route_stm",
  "failure_route_main", "failure_route_stm", "route_reply_main",
  "onreply_route_stm", "$@7", "$@8", "branch_route_main",
  "branch_route_stm", "send_route_main", "send_route_stm",
  "event_route_main", "event_route_stm", "preprocess_stm", "equalop",
  "cmpop", "strop", "rve_equalop", "rve_cmpop", "uri_type",
  "eint_op_onsend", "eint_op", "eip_op_onsend", "eip_op", "exp_elem",
  "ipnet", "host", "host_if_id", "host_or_if", "fcmd", "stm", "actions",
  "action", "if_cmd", "ct_rval", "single_case", "case_stms", "switch_cmd",
  "while_cmd", "select_param", "select_params", "select_id", "$@9",
  "attr_class_spec", "attr_name_spec", "attr_spec", "attr_mark", "attr_id",
  "attr_id_num_idx", "attr_id_no_idx", "attr_id_ass", "attr_id_any",
  "attr_id_any_str", "pvar", "avp_pvar", "assign_op", "lval", "rval",
  "rve_un_op", "rval_expr", "assign_action", "avpflag_oper", "cmd", "$@10",
  "func_params", "func_param", "ret_cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644
};
# endif

#define YYPACT_NINF -1333

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1333)))

#define YYTABLE_NINF -1000

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2556,  -318,  -309,    23,    49,  -249,  -237,  -211,  -203,  -197,
    -193,  -184,  -181, -1333,  -172,  -151,  -144,  -138,  -134,  -123,
     -95,   -90,   -87,   -79,   -68,   -59,   -40,   -36,   -22,   -18,
      16,    26,   411,   453,   508,   529,    30,    32,   270,   552,
     766,   848,   896,   919,   920,   943,   956,   982,   983,   999,
    1000,  1001,  1013,  1019,  1025,  1036,  1037,  1039,  1050,  1053,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1065,  1073,
    1075,  1076,  1080,   537,   550,   555,   562, -1333,   563,   587,
     603,   604,   621,   633,   634,   638,   643,   657,   675,   681,
     685,   727,   763,   812,   838,   854,   855,   859,   862,   869,
     871,    27,    94,   158,    51,    71,   208,   885,   886,   889,
     894,   897,   910,   918,   925,   928,   959,   979,   981,   990,
     991,  1017,  1020,  1032,  1033,  1041,  1042,  1051,  1063,  1071,
    1074,  1078,  1084,  1090,  1097,  1101,  1102,  1081,  1082,  1091,
    1092,  1104,  1108,  1112,  1114,  1115,  1118,  1121,  1122,  1123,
    1124,  1131,  1132,  1141,  1142,  1143,  1147,  1152,  1155,  1160,
    1175,  1177,  1186,  1189,  1190,  1192,  1193,  1198,  1201,  1203,
    1206,  1207,  1208,  1210,  1211,  1213,  1240,  1243,  1244,  1246,
    1247,  1249,  1250,  1251,  1253,  1254,  1255,  1281,  1283,  1290,
    1291,  1297,  1098,  1298,  1299,  1300,  1313,  1314,  1317,  1318,
    1320,  1321,  1322,  1323,  1324,  1325,  1326,    -5,  1327,  1329,
    1330,  1331,  1332,  1333,  1334,  1337,  1355,  1356,  1402,  1406,
    1496,   124,   128,    78,   145,   169, -1333, -1333, -1333,   487,
    1579, -1333,   224,   330,   475,   353,   513, -1333, -1333, -1333,
    -325, -1333, -1333,   368, -1333, -1333, -1333,    36, -1333,  -162,
   -1333,   188,   207,   231,   942,   313,   345,   354,   355,   347,
     356,   357,   358,   359,   189,   191,   378,   216,   489,   221,
     222,   249,   259,   264,    46,    87,   499,    92,   692,   695,
     698, -1333,   741, -1333,   746, -1333,   749, -1333,  -312, -1333,
    -312, -1333,  -312, -1333,  -312, -1333,   771, -1333,   776, -1333,
     777, -1333,   784, -1333,   808, -1333,   819, -1333,   841, -1333,
     843, -1333,   847, -1333,   861, -1333,   904, -1333,   921, -1333,
     962, -1333,   980, -1333,   987, -1333,  1463, -1333,  1464, -1333,
    1465, -1333,  1506, -1333,  1509, -1333,   611, -1333,  1510, -1333,
    1511, -1333,  1512, -1333,  1513, -1333,  1515, -1333,  1530, -1333,
    1531, -1333,  1532, -1333,  1533,   352,   703,   280,   706,  1568,
     708,   742,   743,   750,   283,   752,   754,   374,   375,   376,
     382,   405,   448,   480,   481,   490,   497,   533,   755,   756,
     284,   291,   757, -1333, -1333,  1172, -1333, -1333,  1534, -1333,
     296, -1333, -1333,  1535, -1333,  1536, -1333,   298, -1333,   758,
     759,   760,   761,   764,   765,   767,   768,   253,   256,   257,
     268,   271,   773,   774,   775,   779,   780,   781,   544,   576,
     610,   272,   782,   783,   787,   792,    39,   793,   794, -1333,
    1540, -1333,  1541, -1333,  1545, -1333,  1546,   796,   797,   798,
     799,   800,   801,   802,   803,   806,   807,   809,   810,   811,
     816,   818,   619,   639,   822,   823,   824,   826,   827,  1176,
     829,   830,   831,   832,   302,   303,   304,   833,   834,   839,
      25,   840,   842,   844,   850,   853,   867,   872,   875,   877,
     878,   879,   880,   881,   882,   888,   275,    15, -1333,  1547,
     893,   895,   903,   907,   911,   912,   913,   305,   926,   927,
     932,   934,   935,   936,  1217,   673,  1548,  1559,   674,   683,
     937,   938,   939,   944,   946,   950,   306,   307, -1333, -1333,
   -1333, -1333,   804,   745, -1333, -1333, -1333,  1527, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333,  -318, -1333,    52,    73,   751,
   -1333,    55,  1550, -1333,    61,  1552, -1333,    66,  1553, -1333,
      40,  1564, -1333,   -21,  1561, -1333, -1333, -1333, -1333, -1333,
   -1333,  1551, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,  1567, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333,  1583, -1333, -1333, -1333,
   -1333,  1258,  1577, -1333,  1565,  1566,  1549,    34, -1333, -1333,
   -1333, -1333, -1333,  -226, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333,  1572, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,  -208,  -189,
   -1333, -1333,  1578,  1581, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333,  1583, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333,  1619,  1621,  1624,  1625,  1626,  1627, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333,  -142,  1604,  -142, -1333,  -162, -1333, 12729,
   -1333,  -162, 12729, -1333,  -162, 12729, -1333,  -162, 12729, -1333,
    1602, -1333, -1333, -1333,  1644,  1596, 12729,    74, -1333,  1612,
    1605,   836,  1599,   366,  1200, -1333,  1554, -1333,  1631,   288,
     349,  1292,  1633, -1333,  1635, -1333,  1636,  1637,   312,   314,
     316,   317,   320,   322, -1333, -1333, -1333,  1600,    89,    91,
      97,   101,   102, 11471, 11853, 11941, -1333,   103,   105,   106,
    1613,   109,   121,   122,   123,   130,   149,   154,   157,  1630,
     159,   160,   164,   174,  1632,  1641,  1642,  1646,  1647, 12029,
     175,   181,   187,  1648,  1656,  1665,  1670,  6781, 12029,   197,
     198,   201,   202,   204, -1333, -1333, -1333, -1333,   205, -1333,
   -1333, -1333,    75,  3760, -1333, -1333, -1333, -1333,  1179, -1333,
   -1333, -1333, -1333, -1333,  1716,  1674,   206, -1333,  1675,  1671,
    3836,  1672,  4219,  1681,  4291,  1691,   277,  1689,  4363, -1333,
    1696,  1714,  1258, -1333, -1333, -1333, -1333, -1333, -1333,  1694,
   -1333, -1333, -1333, -1333, -1333, -1333,   -28,  1695,  1971, -1333,
   -1333, -1333, -1333, -1333,  1749,  1758,  1759,  1763,  1764, -1333,
   -1333,  1272,  1721,  1729,  1740,  1745, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,  1742, -1333,
       9, -1333,    41, -1333,   155, -1333,   200, -1333,   237,  1002,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333,  1125, -1333,  1125, -1333,   701, -1333, -1333,  1567, -1333,
   -1333,  6871,  6961,  7345,  1744,  1746,  1747, -1333,  5833, 12659,
   -1333,  1014, -1333,   989, -1333,  1021, -1333, -1333, -1333,  1179,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333,  7435,  3673,  6217,
    3673,  6307,  3673, -1333,   281, -1333,   323, -1333,  7525,  1753,
   -1333,   325, -1333,   326, -1333,   331, -1333,   333, -1333,   951,
   -1333,   952, -1333,  1768, -1333,     8,  1770, -1333,   336, -1333,
     337, -1333,   338, -1333,   339,  1772,  1773,  1774,   245,   997,
    7909, 12117, -1333,   150, -1333,   953, -1333,   135,  1775,  1777,
    1786,  1787, -1333,  1918, 12117, -1333,   340, -1333,   341, -1333,
     414, -1333,   632, -1333,   652, -1333,  1748, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333,  1805, -1333,  1754, -1333, 12029, -1333, -1333,   240,
   -1333,  1790, -1333,  1791, -1333,  1799, -1333,  1808, -1333,  1898,
    1899,   -21, -1333, 12729,  1827, -1333,  -276, -1333,  1825,  1829,
    1258, -1333,  2207,   954,   343,   143,   955, -1333, -1333, -1333,
   -1333,  -290,   -81, 12729,  1820,   535, -1333,   582, -1333,   614,
     605,  1821,   720,   725,   726,   648,  1830,   737,   762,   805,
    1107,  1840,   828,   846,   900,  1120,  1842,   923,   996,  1010,
    1158, -1333, -1333, -1333, -1333, -1333, -1333, -1333,  7999,  5641,
    5737, -1333,  1420,  1853, -1333, -1333, -1333, -1333, -1333, -1333,
    8089,  8473,  8563,  1845, -1333,  1890,  1891,  1893,  1902,  2287,
    1859,  1860,  4435, -1333,  8653, -1333, -1333, -1333, -1333, -1333,
    9037,  9127, -1333,  2927,  1861, -1333, -1333,  9217,  9601,  9691,
    9781, 12029, 12029, 12029, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, 10165, 10255, 10345, 10729, 10819,
   10909, 11293, -1333, -1333,  1864,  1874,  1873,  1900,  1876,  1901,
      48,  2557,  1903,  1904,  1905,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1921, -1333,  1945, -1333,  1946, -1333,
    1947,  1948,  1949,  1950,  1952,  1953,  1954,  1955, -1333, -1333,
   -1333,  1957,  1958, -1333,  1959,  1962, 12729,  2230, -1333,  1968,
    1969,  1970,  1973,  1974,  1892,  1895,  1975, -1333, -1333, -1333,
   -1333,    11, -1333,  1976,  1979,  1980,  1981,  1982,  1983,  1984,
    1985,  1986,  1987, 12029,  1988,  1966,  3673,  1028, -1333,  1179,
   -1333,  1990, -1333, 12729, 12729, 12729, 12729,  1996,  1997,  2035,
    4511,  2006, -1333,  2261,   141,  2010,  2011,  2012, -1333, -1333,
   -1333, -1333, -1333,  2013,  2014, -1333, -1333,  2022,  2023,  2024,
    2025,  2026,  4894, -1333,   -10, -1333,  2039, -1333,  2040, -1333,
     217,   229,  2041, -1333, -1333,    -7, -1333,  2044, -1333,  2050,
   -1333,  2051, -1333, -1333,    -1, -1333,  2052, -1333,  2053, -1333,
    2055, -1333, -1333,   731, -1333,  2056, -1333,  2057, -1333,  2058,
   -1333, -1333,   753, -1333,  2059, -1333,  2061, -1333,  2062, -1333,
   -1333,  2037,  1588, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333,  1588, -1333, -1333,  1588, -1333, -1333, -1333,  2049,
   -1333,  2068,  2027,  2913,  2060,  2975,  2063,  3146, -1333, -1333,
   -1333, -1333, -1333, -1333,  2109,  1588, -1333,  1588, -1333,  1066,
   -1333,  2181,  1583,  1965,  2077, -1333,  -225,  1588,  -328, -1333,
    3695, -1333,  3743, -1333,  3094, -1333,  3762,  1209,  3163,  1256,
   -1333,   -98, -1333,   -98, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333,  1588, -1333,  1066, -1333,  2064, -1333, -1333,  2065, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,  4966,
   12587, -1333, -1333, -1333, -1333, -1333,   478,  1258, -1333,  2086,
    6397,  2054, -1333, -1333,   108, -1333, 12499, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333,  3673,  1035, -1333, -1333, -1333,
    -142, -1333, -1333,   292,  5038,  5110,  5186,  5569, -1333, -1333,
    -294, -1333,  2066, -1333, -1333,  2069,  2074,  2075,  1258,  -276,
    1258, -1333, -1333, -1333, -1333, -1333, -1333,  2090,  2091,  2092,
    2093, -1333, -1333, -1333, -1333,  2094,  2095,  2096,  2097,  2098,
    2099,  2101,  2102,  2103,  2106,  2110,  2112,  2113,  2114,  2115,
    2117,  2118,  2119,  2120,  2121,  2123,   -63,  1853, -1333, -1333,
   -1333, -1333, -1333, 12029,    17,  2122,  2124,  2125, -1333, -1333,
   -1333, -1333,  2126, -1333,  2127, 11383,  2128,  3673, 12729, -1333,
   -1333,  2129,  3019, 12029, -1333,  2130,  2131,  2132, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333,  2327,  2393, -1333,  2154, -1333,
    2155, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1333,  2158,  2159, -1333,  3601,
   -1333,  1583, -1333, -1333, -1333, -1333,  -276, 12729,  2160,  2161,
    3017,  3089, -1333, -1333, -1333, -1333, -1333, -1333, -1333,  2135,
    2146,  -276, -1333, -1333, 12029, -1333,  3161, 12729, 12729, -1333,
    3544,  2405, -1333, -1333,  3074,  3616,  3688, -1333, -1333
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   550,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   226,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   549,    22,    23,     0,
       0,     4,     0,     0,     0,     0,     0,     8,     9,     6,
       0,   547,    10,     0,    15,     7,   548,     0,   607,     0,
     608,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   129,     0,   131,     0,   133,     0,   135,     0,   137,
       0,   139,     0,   141,     0,   143,     0,   145,     0,   147,
       0,   149,     0,   151,     0,   153,     0,   155,     0,   157,
       0,   159,     0,   161,     0,   163,     0,   165,     0,   169,
       0,   167,     0,   171,     0,   173,     0,   175,     0,   177,
       0,   179,     0,   183,     0,   181,     0,   185,     0,   187,
       0,   189,     0,   191,     0,   193,     0,   195,     0,   197,
       0,   199,     0,   201,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   564,   561,     0,   568,   565,     0,   570,
       0,   569,   575,     0,   579,     0,   581,     0,   580,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   319,
       0,   321,     0,   323,     0,   325,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   470,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    66,    72,
      71,    65,    67,    69,    74,    77,    73,    75,   624,   623,
     626,   625,   628,   627,     1,     5,     3,     0,     0,     0,
      12,     0,     0,    14,     0,     0,    17,     0,     0,    19,
       0,     0,    21,     0,     0,   605,   498,   497,   590,   591,
     592,     0,   536,   535,   538,   537,   532,   531,   540,    31,
      32,    33,    34,    35,   539,   534,   533,   542,     0,    63,
     541,   544,   543,   546,   545,    95,    94,    97,    96,    99,
      98,   101,   100,   103,   102,   105,   104,   107,   106,   109,
     108,   111,   110,   113,   112,   115,   114,   117,   116,   119,
     118,   121,   120,   123,   122,   422,   706,   704,   705,    25,
     587,     0,     0,    30,    56,     0,    61,   407,    24,   584,
     588,   585,   707,    26,   424,   423,   428,   427,   426,   425,
     430,   429,   125,   124,   127,   126,   128,   130,   132,   134,
     136,   138,   140,   142,   144,   146,   148,   150,   152,   154,
     156,   158,   160,   162,   164,   168,   166,   170,   172,   174,
     176,   178,   182,   180,   184,   186,   188,   190,   192,   194,
     196,   198,   200,   203,   202,   205,   204,   225,   224,   223,
     222,     0,   229,   228,   231,   230,   233,   232,   235,   234,
     237,   236,   239,   238,   241,   240,   243,   242,   245,   244,
     247,   246,   249,   248,   251,   250,   253,   252,   255,   254,
     257,   256,   259,   258,   261,   260,   263,   262,   265,   264,
     396,   395,   398,   397,   400,   399,   406,   405,     0,     0,
     572,   571,     0,     0,   583,   582,   207,   206,   209,   208,
     211,   210,   213,   212,   215,   214,   217,   216,   219,   218,
     221,   220,   270,   269,   268,   273,   272,   271,   276,   275,
     274,   279,   278,   277,   282,   281,   280,   284,   283,   286,
     285,   288,   287,   290,   289,   292,   291,   294,   293,   296,
     295,   298,   297,   300,   299,   303,   301,   302,   305,   304,
     307,   306,   309,   308,   311,     0,   310,   313,   312,   315,
     314,   317,   316,   318,   320,   322,   324,   327,   326,   329,
     328,   331,   330,   333,   332,   335,   334,   337,   336,   339,
     338,   341,   340,   343,   342,   345,   344,   347,   346,   349,
     348,   351,   350,   353,   352,   355,   354,   357,   356,   359,
     358,   361,   360,   363,   362,   365,   364,   367,   366,   369,
     368,   374,   370,   371,   372,   373,   386,   385,   388,   387,
     376,   375,   378,   377,   380,   379,   382,   381,   384,   383,
     390,   389,   392,   391,   394,   393,   432,   431,   434,   433,
     436,   435,   438,   437,   440,   439,   442,   441,   444,   443,
     446,   445,   448,   447,   450,   449,   452,   451,   454,   453,
     456,   455,   458,   457,   460,   459,   462,   461,   465,   463,
     464,   468,   466,   467,   469,   472,   471,   474,   473,   476,
     475,   478,   477,   480,   479,   482,   481,   484,   483,   267,
     266,   486,   485,   488,   487,   490,   489,   492,   491,   494,
     493,   496,   495,     0,     0,     0,     0,     0,     0,   512,
     511,   513,   514,   518,   517,   516,   515,   520,   519,   522,
     521,   524,   523,   526,   525,   528,   527,   530,   529,   402,
     401,   404,   403,     0,     0,     0,   597,     0,   598,     0,
     602,     0,     0,   615,     0,     0,   619,     0,     0,   622,
       0,   552,   553,   551,     0,     0,     0,     0,    64,     0,
      27,     0,     0,     0,     0,    62,     0,   408,     0,     0,
       0,     0,     0,   562,     0,   566,     0,     0,     0,     0,
       0,     0,     0,     0,    68,    70,    76,     0,     0,     0,
       0,     0,     0,  1011,  1008,  1012,  1015,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   964,   966,   968,   971,     0,     0,
       0,     0,     0,   985,   987,   989,   991,     0,     0,     0,
       0,     0,     0,     0,   841,   842,   843,   766,     0,   778,
     779,   724,     0,     0,   716,   719,   720,   721,     0,   770,
     771,   781,   782,   783,     0,     0,     0,   712,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   611,
       0,     0,     0,    29,   589,    60,    50,    49,    57,    58,
      43,    44,    45,    46,    47,    48,   418,     0,   409,   711,
     706,   709,   710,   708,     0,     0,     0,     0,     0,    91,
      93,     0,     0,     0,     0,     0,   500,   499,   502,   501,
     504,   503,   506,   505,   508,   507,   510,   509,     0,   854,
       0,   876,     0,   887,     0,   898,     0,   865,     0,     0,
     650,   651,   652,   663,   656,   664,   657,   662,   654,   661,
     653,     0,   655,     0,   658,     0,   659,   752,   798,   796,
     797,     0,     0,     0,     0,     0,     0,   785,     0,     0,
     784,     0,   660,     0,   665,     0,   791,   790,   789,     0,
     772,   774,   773,   786,   787,   788,   799,     0,  1010,     0,
    1007,     0,  1014,   902,     0,   919,     0,   923,     0,     0,
     927,     0,   946,     0,   949,     0,   930,     0,   936,     0,
     933,     0,   939,     0,   942,     0,     0,   955,     0,   958,
       0,   952,     0,   961,     0,     0,     0,     0,     0,     0,
       0,     0,   977,     0,   980,     0,   983,     0,     0,     0,
       0,     0,   744,     0,     0,   994,     0,   997,     0,   906,
       0,   909,     0,   912,     0,  1001,     0,   725,   718,   717,
     595,   715,   754,   755,   756,   757,   758,   759,   760,   761,
     762,   763,     0,   764,   767,   780,     0,   723,   917,     0,
     722,     0,   600,     0,   613,     0,   617,     0,   558,   554,
     555,     0,   606,     0,     0,    28,     0,   419,     0,     0,
       0,   410,     0,     0,     0,     0,     0,   227,    92,   563,
     567,     0,     0,     0,     0,     0,   699,     0,   844,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   669,   629,   630,   638,   631,   632,   637,     0,     0,
       0,   694,     0,     0,   839,   820,   823,   801,   824,   802,
       0,     0,     0,     0,  1009,   772,   773,   787,   788,     0,
       0,     0,     0,   673,     0,   678,   633,   634,   635,   636,
       0,     0,   690,     0,   767,   822,   800,     0,     0,     0,
       0,     0,     0,     0,   639,   640,   645,   641,   642,   643,
     644,   646,   647,   648,   649,     0,     0,     0,     0,     0,
       0,     0,  1006,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   938,     0,   941,     0,   944,
       0,     0,     0,     0,     0,     0,     0,     0,   963,   965,
     967,     0,     0,   970,     0,     0,     0,   726,   713,     0,
       0,     0,     0,     0,    51,     0,     0,   984,   986,   988,
     990,     0,   746,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1002,     0,     0,   840,     0,   777,     0,
     775,     0,   776,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    59,   420,   411,     0,     0,     0,    90,    89,
      84,    83,    82,    81,     0,    88,    87,     0,     0,     0,
       0,     0,     0,   855,     0,   853,     0,   846,     0,   847,
       0,     0,     0,   845,   877,     0,   875,     0,   868,     0,
     869,     0,   867,   888,     0,   886,     0,   879,     0,   880,
       0,   878,   899,     0,   897,     0,   890,     0,   891,     0,
     889,   866,     0,   864,     0,   857,     0,   858,     0,   856,
     668,     0,   666,   684,    36,    37,    38,    39,    40,    41,
      42,   682,   683,   681,   679,   680,   693,   691,   692,   747,
     751,   753,     0,     0,     0,     0,     0,     0,   795,   817,
     794,   793,   792,   672,     0,   670,   677,   675,   676,   674,
     689,     0,    63,     0,   697,   685,   687,   686,     0,   835,
     816,   834,   815,   830,   808,   831,   809,   810,   811,   812,
     825,   803,   826,   804,   827,   805,   828,   806,   829,   807,
     833,   814,   832,   813,   903,     0,   900,   920,     0,   924,
     922,   921,   925,   928,   926,   947,   945,   950,   948,   931,
     929,   937,   935,   934,   932,   943,   940,   956,   954,   959,
     957,   953,   951,   962,   960,   972,   969,   974,   973,     0,
       0,   976,   975,   979,   978,   982,     0,     0,   981,     0,
       0,     0,   743,   741,     0,   995,     0,   998,   996,   904,
     905,   907,   908,   910,   911,  1005,     0,  1004,   765,   769,
       0,   916,   767,     0,     0,     0,     0,     0,   556,   557,
       0,   610,     0,   421,   413,     0,     0,     0,     0,     0,
       0,   573,   574,   576,   578,   577,   596,     0,     0,     0,
       0,   703,   701,   702,   700,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   836,   818,
     837,   819,   838,     0,     0,     0,     0,     0,   714,   727,
      55,    52,    53,   745,     0,     0,     0,   728,   734,   742,
     740,    63,     0,     0,  1000,     0,     0,     0,   601,   614,
     618,   621,   559,   560,   586,   414,   412,    85,     0,    79,
      80,   851,   852,   849,   850,   848,   873,   874,   871,   872,
     870,   884,   885,   882,   883,   881,   895,   896,   893,   894,
     892,   862,   863,   860,   861,   859,     0,     0,   750,     0,
     698,   696,   695,   768,   901,   918,     0,   737,     0,     0,
       0,     0,   992,   993,  1003,   915,   914,   913,   416,     0,
       0,     0,   749,   748,     0,    54,     0,   738,   732,   739,
       0,   415,    86,    78,     0,     0,     0,   417,   821
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1333, -1333, -1333,  2317, -1333, -1333, -1333, -1333, -1333,  -468,
    1426,  1537,  -248,  1162, -1333, -1332, -1333, -1333,   515,  -256,
   -1333,  1570, -1333,  -221, -1333,  1571, -1333,  1404, -1333, -1333,
   -1333, -1333,  1229, -1333, -1333, -1157,  2139,  1963,  2142,   457,
   -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333, -1333,
   -1333, -1333, -1333, -1333, -1333, -1168, -1333, -1131, -1333, -1333,
    1194, -1333, -1333, -1333,  1195, -1333, -1333,   269,  -745, -1333,
    -373, -1277,  -929,  -442, -1333,   744,   856, -1333, -1333, -1333,
     785, -1333, -1333, -1333, -1333,  1064, -1184,  -424,  -984, -1333,
    -898, -1333, -1333, -1333,  -670,  -941, -1333, -1333, -1333, -1333,
    -159,  -987, -1333, -1333, -1333, -1333,   772, -1333
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   229,   230,   231,   232,   233,   234,   235,   236,   623,
    1011,   624,   625,  1621,  1137,  1128,  1506,   626,   627,  1210,
     237,   521,   522,   523,   238,   526,   527,  1150,  1151,   239,
     359,   240,  1004,   241,   242,   628,   629,   630,   631,   561,
     539,   540,   542,   543,   243,   244,  1006,  1120,   545,   546,
     548,   549,   551,   552,   245,  1387,  1421,  1388,  1450,  1451,
    1211,  1212,  1213,  1214,  1215,  1216,  1655,  1360,   632,   633,
    1217,  1497,  1093,  1094,  1095,  1826,  1733,  1734,  1096,  1097,
    1630,  1631,  1218,  1393,  1312,  1313,  1314,  1219,  1220,  1221,
    1222,  1101,  1223,  1531,  1224,  1225,  1316,  1104,  1226,  1227,
    1409,  1105,  1106,  1107,  1296,  1746,  1747,  1108
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     580,   525,   887,   586,  1542,  1099,   574,  1512,  1099,  1476,
    1354,  1099,  1729,  1359,  1099,  1364,   921,  1369,  1880,  1374,
     246,  1379,  1099,  1389,   248,  1390,   886,  1392,   383,   247,
     578,   281,   649,   283,   650,  1424,   651,   556,   652,  1001,
     807,   999,  1361,   553,   579,  1420,   578,   615,  1103,  1295,
     250,  1103,   392,   986,  1103,  1777,   990,  1103,  1786,  1749,
     579,   554,   993,  1110,  1791,  1103,  1112,   996,   578,  1114,
    1730,  1731,   394,  1355,   988,  1119,  1297,  1118,  1842,   528,
    1414,  1843,   579,  1126,  1423,  1557,  1337,  1338,   634,   251,
    1169,  1100,  1171,   638,  1100,   386,  1127,  1100,  1173,   684,
    1100,   252,  1175,  1177,  1233,  1362,  1235,  1237,  1100,  1099,
    1240,   707,   709,   711,   713,   715,   717,   719,   721,   723,
     725,   727,  1242,  1244,  1246,   518,  1099,   253,  1099,   524,
    1099,  1248,  1019,  1570,  1099,   254,  1503,   569,   570,   571,
     572,   255,  1020,  1571,  1552,   256,   530,  1016,  1017,  1018,
    1250,  1499,  1103,  1010,   257,  1252,  1366,   258,  1254,   389,
    1257,  1259,   790,   792,   794,  1261,   259,  1730,  1731,  1103,
     532,  1103,  1022,  1103,  1023,  1263,  1272,  1103,   569,   570,
     571,   572,  1274,   569,   570,   571,   572,   260,  1276,   562,
     595,  1024,   597,  1025,   261,  1100,   848,   850,  1285,  1287,
     262,  1371,  1289,  1291,   263,  1293,  1295,  1318,   564,   396,
     558,   559,  1100,   560,  1100,   264,  1100,   601,  1781,  1367,
    1100,  1410,   605,   607,  1405,  1099,   569,   570,   571,   572,
    1783,   519,   566,   520,   569,   570,   571,   572,  1376,   537,
     538,  1527,  1410,   265,  1410,  1405,  1491,  1405,   266,   960,
     609,   267,   964,   966,   762,  1764,  1765,   765,   768,   268,
     611,  1447,  1448,  1449,  1372,   613,  1654,  1408,  1103,   771,
     269,   285,   774,   795,  1141,  1143,   918,   578,  1328,   270,
    1412,   687,  1454,  1410,   700,   732,  1405,  1099,  1408,  1139,
    1408,   579,   734,  1836,  1559,   578,  1560,   740,   271,   744,
    1099,  1377,   272,   874,   876,   878,   939,   979,   981,   579,
    1406,  1100,  1876,  1156,   575,  1158,   273,  1160,  1162,  1102,
     274,  1164,  1102,  1166,  1457,  1102,  1463,  1465,  1102,  1408,
    1103,  1406,  1467,  1406,  1469,  1530,  1102,  1480,  1482,  1484,
    1486,  1513,  1515,  1103,  1550,  1752,   577,   541,   585,  1099,
    1142,  1002,  1003,   683,   275,   581,   583,   587,   589,   591,
     593,  1339,  1778,   504,   276,  1787,   578,  1125,   282,  1099,
     284,  1792,  1406,  1100,   547,   706,   708,   710,  1532,   599,
     579,   805,  1356,   712,  1357,   620,  1100,   922,   923,  1881,
    1477,  1358,  1103,   620,  1821,   622,  1732,   616,   617,   618,
     619,   620,   384,   622,  1540,   573,   714,  -603,   557,   249,
     385,   622,  1103,   805,  1356,   620,  1363,   620,   616,   617,
     618,   619,   620,  1102,  1562,   622,  -620,   622,  1099,   621,
    1690,  -999,   622,  -604,   393,  1100,  -593,  1849,   987,  -599,
    1102,   991,  1102,  1819,  1102,  -612,   573,   994,  1102,   716,
    -616,   573,   997,   529,   395,  1100,  1298,  -594,  -609,   616,
     617,   618,   619,   620,   616,   617,   618,   619,   620,   387,
     621,  1103,  1170,   622,  1172,   621,  1392,   388,   622,  1820,
    1174,   718,   720,  1392,  1176,  1178,  1234,   534,  1236,  1238,
     603,   722,  1241,  1829,   573,   544,   390,   519,   724,   520,
     636,   519,   573,   520,  1243,  1245,  1247,   616,   617,   618,
     619,   620,  1099,  1249,  1100,   616,   617,   618,   619,   620,
     531,   622,   616,   617,   618,   619,   620,   805,  1356,   622,
    1368,   620,  1251,   391,   726,   550,   622,  1253,  1407,  1102,
    1255,   622,  1258,  1260,   533,   789,   397,  1262,  1136,  1099,
    1099,  1099,  1099,   287,  1905,  1103,  1099,  1264,  1273,  1407,
     563,  1407,   596,  1087,  1275,  1098,   598,  1719,  1098,  1913,
    1277,  1098,   805,  1356,  1098,  1373,   620,   791,  1099,   565,
    1286,  1288,  1098,   398,  1290,  1292,   622,  1294,  -999,  1319,
    1782,   602,  1103,  1103,  1103,  1103,   606,   608,  1100,  1103,
    1407,  1102,  1784,   567,  1754,  1755,  1756,  1757,   286,   805,
    1356,   793,  1378,   620,  1102,  1528,  1092,  1492,  1090,  1092,
     847,  1103,  1092,   622,   610,  1092,   763,  1493,   764,   766,
     769,   767,   770,  1092,   612,  1100,  1100,  1100,  1100,   614,
     849,   772,  1100,   773,   775,   796,   776,   797,   919,  1329,
     920,  1301,  1330,  1455,  1010,   688,  1456,  1882,   701,   733,
    1140,   617,   618,  1102,  1100,   519,   735,   520,  1301,  1098,
    1301,   741,  1301,   745,   959,   963,  1301,   875,   877,   879,
     940,   980,   982,  1102,   965,   576,  1098,  1157,  1098,  1159,
    1098,  1161,  1163,   640,  1098,  1165,   642,  1167,  1458,   644,
    1464,  1466,  1391,   578,   685,   578,  1468,   689,  1470,   692,
     578,  1481,  1483,  1485,  1487,  1514,  1516,   579,  1551,   579,
    1092,  1140,   617,   618,   579,  1126,   582,   584,   588,   590,
     592,   594,   578,   578,   578,  1099,  1099,  1092,  1127,  1092,
     578,  1092,  1102,   694,   696,  1092,   579,   579,   579,   277,
     600,   698,   555,   702,   579,   704,   728,   730,   736,   746,
     748,   750,   752,   578,   525,   754,   756,   289,   758,   760,
    1099,  1099,  1099,  1099,   777,   779,   781,   579,  1103,  1103,
     783,   785,   787,   798,   800,  1098,  1517,   519,   802,   520,
     635,   278,   639,   804,   809,   811,  1796,   817,   819,   821,
     823,   825,   827,   829,   831,  1500,   578,   833,   835,  1504,
     837,   839,   841,  1103,  1103,  1103,  1103,   843,  1801,   845,
     579,  1100,  1100,   851,   853,   855,  1102,   857,   859,  1498,
     866,   868,   870,   872,   880,   882,  1092,  1126,   578,   578,
     884,   888,  1498,   890,  1099,   892,   279,  1098,   578,   291,
    1127,   894,   579,   579,   896,   578,  1100,  1100,  1100,  1100,
    1098,   604,   579,  1102,  1102,  1102,  1102,   280,   898,   579,
    1102,   637,  1545,   900,  1546,   355,   902,  1553,   904,   906,
     908,   910,   912,   914,  1228,  1230,  1232,  1103,   356,   916,
     288,   578,  1102,   357,   925,  1529,   927,   293,  1092,  1891,
     358,   360,   578,  1099,   929,   579,  1099,  1099,   931,  1098,
    1271,  1092,   933,   935,   937,  1564,   579,  1565,  1283,  1284,
     295,   297,  1099,  1099,  1099,   361,  1099,   941,   943,  1098,
    1100,  1099,  1099,   945,   578,   947,   949,   951,   967,   969,
     971,   362,   363,   568,   299,   973,  1103,   975,   579,  1103,
    1103,   977,  1471,  1473,  1501,  1548,  1555,   301,  1906,   364,
    1092,  1910,  1566,  1570,  1567,  1103,  1103,  1103,   578,  1103,
    1301,   365,   366,  1571,  1103,  1103,   367,   578,  1915,  1916,
    1092,   368,   579,   303,   305,  1572,   673,  1573,  1098,  1100,
    1415,   579,  1100,  1100,  1568,   369,  1569,   578,  1494,  1478,
     307,   309,   311,  1381,  1519,   519,  1570,   520,  1100,  1100,
    1100,   579,  1100,   370,   313,  1413,  1571,  1100,  1100,   371,
     315,  1495,  1422,   372,  1521,   519,   317,   520,  1581,  1505,
    1582,   578,   578,   569,   570,   571,   572,   319,   321,  1092,
     323,   578,  1395,  1397,  1399,   579,   579,  1382,  1383,  1102,
    1102,   325,  1385,  1386,   327,   579,   329,   331,   333,   335,
     337,   339,   341,   343,   641,   373,   345,   643,  1426,  1518,
     645,  1520,  1098,  1522,   347,   686,   349,   351,   690,  1461,
     693,   353,   429,   431,  1102,  1102,  1102,  1102,   569,   570,
     571,   572,   433,   435,  1547,  1558,  1561,  1554,  1301,   488,
    1575,   374,  1576,  1797,   290,  1577,  1579,  1578,  1580,  1098,
    1098,  1098,  1098,   646,   695,   697,  1098,  1584,   647,  1585,
    1301,   648,   699,  1092,   703,  1802,   705,   729,   731,   737,
     747,   749,   751,   753,   984,   989,   755,   757,  1098,   759,
     761,  1015,  1586,   653,  1587,   778,   780,   782,   654,   655,
     375,   784,   786,   788,   799,   801,   656,  1526,  1102,   803,
    1092,  1092,  1092,  1092,   805,   810,   812,  1092,   818,   820,
     822,   824,   826,   828,   830,   832,   376,   861,   834,   836,
     657,   838,   840,   842,   983,  1588,   292,  1589,   844,  1092,
     846,   658,   377,   378,   852,   854,   856,   379,   858,   860,
     380,   867,   869,   871,   873,   881,   883,   381,  1593,   382,
    1594,   885,   889,   659,   891,   660,   893,  1102,  1123,   661,
    1102,  1102,   895,   399,   400,   897,  1595,   401,  1596,  1612,
    1622,  1625,   402,   662,   294,   403,  1102,  1102,  1102,   899,
    1102,  1633,  1635,  1637,   901,  1102,  1102,   903,   404,   905,
     907,   909,   911,   913,   915,  1645,   405,   296,   298,  1822,
     917,  1647,  1649,   406,  1657,   926,   407,   928,  1660,  1662,
    1664,  1666,  1667,  1668,  1669,   930,   663,  1301,  1498,   932,
    1597,   300,  1598,   934,   936,   938,  1671,  1673,  1675,  1677,
    1679,  1681,  1683,   664,   302,  1098,  1098,   408,   942,   944,
    1848,   573,  1850,  1602,   946,  1603,   948,   950,   952,   968,
     970,   972,  1301,  1301,  1301,  1301,   974,   409,   976,   410,
     304,   306,   978,  1472,  1474,  1502,  1549,  1556,   411,   412,
    1098,  1098,  1098,  1098,   665,  1382,  1383,   308,   310,   312,
    1385,  1386,  1416,  1417,  1418,  1419,  1092,  1092,  1382,  1383,
    1384,   314,   666,  1385,  1386,   413,   573,   316,   414,   667,
    1382,  1383,  1384,   318,  1745,  1385,  1386,  1382,  1383,  1384,
     415,   416,  1385,  1386,   320,   322,  1604,   324,  1605,   417,
     418,  1092,  1092,  1092,  1092,  1144,  1145,  1146,   326,   419,
    1606,   328,  1607,   330,   332,   334,   336,   338,   340,   342,
     344,   420,  1815,   346,  1098,  1144,  1145,  1146,  1750,   421,
    1751,   348,   422,   350,   352,  1833,   423,  1834,   354,   430,
     432,  1626,   424,  1445,  1446,  1447,  1448,  1449,   425,   434,
     436,   862,   863,   864,   865,   426,   489,  1147,  1148,   427,
     428,  1365,   437,  1370,  1037,  1375,   438,  1380,  1109,  1301,
     439,  1111,   440,   441,  1113,  1092,   442,  1147,  1148,   443,
     444,   445,   446,  1098,  1301,  1570,  1098,  1098,  1301,   447,
     448,  1382,  1383,  1301,  1301,  1571,  1385,  1386,  1570,   449,
     450,   451,  1098,  1098,  1098,   452,  1098,  1590,  1571,  1591,
     453,  1098,  1098,   454,  1180,  1181,  1182,  1183,   455,  1185,
    1599,  1187,  1600,  1189,  1302,  1303,  1304,  1305,  1306,  1307,
    1308,  1309,  1310,   456,  1092,   457,  1570,  1092,  1092,   953,
     954,   955,   956,   957,   458,   958,  1571,   459,   460,  1835,
     461,   462,  1837,  1092,  1092,  1092,   463,  1092,  1608,   464,
    1609,   465,  1092,  1092,   466,   467,   468,   738,   469,   470,
    1877,   471,  1311,  1432,  1433,  1434,  1435,  1436,  1437,  1438,
    1439,  1440,  1441,  1442,  1443,  1444,  1445,  1446,  1447,  1448,
    1449,  1827,   616,   617,   618,   619,   620,  1832,   472,    -2,
     535,   473,   474,   621,   475,   476,   622,   477,   478,   479,
       2,   480,   481,   482,   -11,   -11,   -13,     3,     4,   -16,
     -18,   -20,  1434,  1435,  1436,  1437,  1438,  1439,  1440,  1441,
    1442,  1443,  1444,  1445,  1446,  1447,  1448,  1449,     5,   483,
       6,   484,     7,     8,     9,    10,    11,    12,   485,   486,
     616,   617,   618,   619,   620,   487,   490,   491,   492,    13,
     569,   570,   571,   572,   622,  1130,  1131,  1132,  1133,  1134,
    1135,   493,   494,  1149,  1879,   495,   496,  1347,   497,   498,
     499,   500,   501,   502,   503,   505,  1827,   506,   507,   508,
     509,   510,   511,  1149,  1745,   512,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,  1656,   513,   514,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
     515,    75,    76,    77,   516,  1914,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   517,   668,   669,   670,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   671,   206,
     207,   672,   674,   675,   676,   677,   208,   678,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   679,   680,   681,   682,   691,   985,   573,   739,
     742,   743,   813,   814,   223,   224,   225,   815,   816,   924,
     961,   616,   617,   618,   619,   620,   616,   617,   618,   619,
     620,   962,   621,  1005,   992,   622,   995,   998,  1007,  1008,
     622,  1441,  1442,  1443,  1444,  1445,  1446,  1447,  1448,  1449,
    1000,  1009,   226,   620,  1013,  1014,  1021,  1028,  1026,  1029,
     227,  1027,  1030,  1031,  1032,  1033,  1295,   228,  -699,  -699,
    -699,  -699,  -699,  -699,  -699,  -699,  1035,  -699,  -699,  -699,
    -699,  1115,  1116,  1117,  1121,  1122,  1124,  1168,  -699,  -699,
    -699,  -699,  -699,  -699,  -699,  -699,  1239,  -699,  -699,  -699,
    -699,  -699,  -699,  -699,  -699,  -699,  1138,  -699,  1152,  -699,
    1153,  1154,  1155,  1256,  -699,  1265,  -699,  -699,  -699,  -699,
    -699,  -699,  -699,  -699,  1266,  1267,  -699,  -699,  -699,  1268,
    1269,  1278,  -699,  -699,  -699,  -699,  -699,  -699,  1295,  1279,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  1280,  -667,
    -667,  -667,  -667,  1281,  1315,  1317,  1320,  1331,  1321,  1323,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  1325,  -667,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  1327,  -667,
    1333,  -667,  1334,  1336,  1340,  1341,  -667,  1342,  -667,  -667,
    -667,  -667,  -667,  -667,  -667,  -667,  1343,  1344,  -667,  -667,
    -667,  1345,  1346,  1349,  -667,  -667,  -667,  -667,  -667,  -667,
    1391,  1350,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    1351,  -671,  -671,  -671,  -671,  1352,  1353,  1400,  1462,  1401,
    1402,  1523,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    1525,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    1475,  -671,  1479,  -671,  1488,  1489,  1490,  1507,  -671,  1508,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  1509,  1510,
    -671,  -671,  -671,  1524,  1533,  1534,  -671,  -671,  -671,  -671,
    -671,  -671,  1391,  1535,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  1536,  -688,  -688,  -688,  -688,  1537,  1538,  1541,
    1543,  1544,  1563,  1574,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  1583,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  1592,  -688,  1601,  -688,  1629,  1638,  -770,  -771,
    -688,  -782,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -783,  1640,  -688,  -688,  -688,  1641,  1684,  1658,  -688,  -688,
    -688,  -688,  -688,  -688,  1685,  1686,  1688,  1427,  1428,  1429,
    1430,  1431,  1432,  1433,  1434,  1435,  1436,  1437,  1438,  1439,
    1440,  1441,  1442,  1443,  1444,  1445,  1446,  1447,  1448,  1449,
    1720,  1726,  1687,  1689,  1727,  1692,  1693,  1694,  -699,  1695,
    1696,  1697,  1698,  1699,  1700,  1701,  1702,  1703,   569,   570,
     571,   572,  1511,  1704,  -699,  -699,  -699,  -699,  -699,  -699,
    -699,  -699,  -699,  -699,  -699,  -699,  -699,  -699,  -699,  -699,
    -699,  -699,  -699,  -699,  -699,  -699,  -699,  1705,  1706,  1707,
    1708,  1709,  1710,  -699,  1711,  1712,  1713,  1714,  -699,  1715,
    1716,  1717,  -699,  -699,  1718,  -699,  -699,  -699,  -999,  -699,
    1721,  1722,  1723,  1749,  -699,  1724,  1725,  1728,  1735,  1736,
    -667,  1311,  1737,  1738,  1739,  1740,  1741,  1742,  1743,  1744,
    1753,  1758,  1759,  1760,  1762,  1763,  -667,  -667,  -667,  -667,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,
    -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  -667,  1766,
    1767,  1768,  1769,  1770,  1771,  1772,  1773,  1774,  1775,  1808,
    -667,  1779,  1780,  1785,  -667,  -667,  1788,  -667,  -667,  -667,
    -999,  -667,  1789,  1790,  1793,  1794,  -667,  1795,  1798,  1799,
    1800,  1803,  -671,  1804,  1805,  1806,  1807,  1814,  1844,  1816,
    1817,  1898,  1810,  1828,  1845,  1812,  1846,  1847,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,  -671,
    -671,  1823,  1851,  1852,  1853,  1854,  1855,  1856,  1857,  1858,
    1859,  1860,  -671,  1861,  1862,  1863,  -671,  -671,  1864,  -671,
    -671,  -671,  1865,  -671,  1866,  1867,  1868,  1869,  -671,  1870,
    1871,  1872,  1873,  1874,  -688,  1875,  1884,  1885,  1899,  1883,
    1911,  1892,  1895,  1896,  1897,  1886,  1887,  1890,  1912,  1917,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,  -688,
    -688,  -688,  -688,  1900,  1901,  1902,  1903,   536,  1335,  1907,
    1908,  1129,  1624,  1034,  -688,  1348,  1036,     1,  -688,  -688,
    1539,  -688,  -688,  -688,   806,  -688,   573,     2,   808,  1889,
    -688,   -11,   -11,   -13,     3,     4,   -16,   -18,   -20,   616,
     617,   618,   619,   620,     0,  1012,  1627,  1628,  1748,     0,
    1830,     0,  1878,   622,     0,     5,     0,     6,     0,     7,
       8,     9,    10,    11,    12,  1894,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    13,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1427,  1428,  1429,  1430,
    1431,  1432,  1433,  1434,  1435,  1436,  1437,  1438,  1439,  1440,
    1441,  1442,  1443,  1444,  1445,  1446,  1447,  1448,  1449,     0,
       0,     0,     0,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,  1639,
       0,     0,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,     0,    75,    76,
      77,     0,     0,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,     0,     0,     0,     0,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,     0,   206,   207,     0,     0,
       0,     0,     0,   208,     0,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   223,   224,   225,     0,     0,  1427,  1428,  1429,  1430,
    1431,  1432,  1433,  1434,  1435,  1436,  1437,  1438,  1439,  1440,
    1441,  1442,  1443,  1444,  1445,  1446,  1447,  1448,  1449,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1650,   226,
    1038,  1039,  1040,  1041,  1042,     0,     0,   227,     0,  1691,
    1047,  1048,  1049,     0,   228,     0,     0,     0,     0,     0,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,
       0,  1068,     0,     0,     0,     0,     0,     0,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,     0,     0,     0,     0,  1079,
    1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,
    1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,  1191,  1192,  1193,  1194,  1651,  1196,  1909,     0,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,
    1047,  1048,  1049,     0,     0,     0,     0,     0,     0,     0,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,
       0,  1068,     0,     0,     0,     0,  1069,     0,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,  1077,  -731,  -731,  1078,  1079,
    1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,
    1299,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
       0,  1046,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,  1069,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  -733,  -733,
    1078,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,  1299,     0,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,  1045,     0,  1046,  1047,  1048,  1049,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,     0,  1067,     0,  1068,     0,     0,     0,     0,
    1069,     0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
    -735,  -735,  1078,  1079,  1080,     0,     0,     0,  1081,  1082,
    1083,  1084,  1085,  1086,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1087,  1197,  1427,  1428,  1429,  1430,  1431,  1432,  1433,  1434,
    1435,  1436,  1437,  1438,  1439,  1440,  1441,  1442,  1443,  1444,
    1445,  1446,  1447,  1448,  1449,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1198,     0,     0,     0,  1199,
       0,  1200,  1201,  1202,  1203,  1809,  1204,  1205,  1206,  1652,
    1653,     0,  1207,   620,  1089,  1090,     0,     0,     0,     0,
    1270,  1209,     0,   622,  1427,  1428,  1429,  1430,  1431,  1432,
    1433,  1434,  1435,  1436,  1437,  1438,  1439,  1440,  1441,  1442,
    1443,  1444,  1445,  1446,  1447,  1448,  1449,     0,     0,     0,
    1087,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1811,  1427,  1428,
    1429,  1430,  1431,  1432,  1433,  1434,  1435,  1436,  1437,  1438,
    1439,  1440,  1441,  1442,  1443,  1444,  1445,  1446,  1447,  1448,
    1449,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1088,     0,     0,     0,  1089,  1090,     0,     0,  1091,     0,
       0,  1893,  -731,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1087,  1427,  1428,  1429,  1430,  1431,  1432,  1433,
    1434,  1435,  1436,  1437,  1438,  1439,  1440,  1441,  1442,  1443,
    1444,  1445,  1446,  1447,  1448,  1449,  1430,  1431,  1432,  1433,
    1434,  1435,  1436,  1437,  1438,  1439,  1440,  1441,  1442,  1443,
    1444,  1445,  1446,  1447,  1448,  1449,  1918,     0,     0,     0,
       0,     0,  1088,     0,     0,     0,  1089,  1090,     0,     0,
    1091,     0,     0,     0,  -733,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1087,  1427,  1428,  1429,  1430,  1431,
    1432,  1433,  1434,  1435,  1436,  1437,  1438,  1439,  1440,  1441,
    1442,  1443,  1444,  1445,  1446,  1447,  1448,  1449,  1433,  1434,
    1435,  1436,  1437,  1438,  1439,  1440,  1441,  1442,  1443,  1444,
    1445,  1446,  1447,  1448,  1449,     0,  1813,     0,     0,     0,
       0,     0,     0,     0,  1088,     0,     0,     0,  1089,  1090,
       0,     0,  1091,     0,     0,  1299,  -735,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,
       0,     0,     0,     0,     0,     0,     0,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,  1066,     0,  1067,     0,  1068,     0,
       0,     0,     0,  1069,     0,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  -729,  -729,  1078,  1079,  1080,     0,     0,
       0,  1081,  1082,  1083,  1084,  1085,  1086,  1299,     0,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,
    1048,  1049,     0,     0,     0,     0,     0,     0,     0,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,     0,
    1068,     0,     0,     0,     0,  1069,     0,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,  -736,  -736,  1078,  1079,  1080,
       0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,  1299,
       0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,
    1046,  1047,  1048,  1049,     0,     0,     0,     0,     0,     0,
       0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,
    1067,     0,  1068,     0,     0,     0,     0,  1069,     0,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  -730,  -730,  1078,
    1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,
    1086,  1299,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,     0,  1046,  1047,  1048,  1049,     0,     0,     0,     0,
       0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,
    1066,     0,  1067,     0,  1068,     0,     0,     0,     0,  1069,
       0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,     0,
       0,  1078,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,
    1084,  1085,  1086,     0,     0,     0,     0,  1299,     0,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,
    1048,  1049,     0,     0,     0,     0,     0,     0,     0,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1087,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,     0,
    1068,     0,     0,     0,     0,  1069,     0,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,     0,     0,  1078,  1079,  1080,
       0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,     0,
       0,     0,     0,     0,     0,     0,     0,  1088,     0,     0,
       0,  1089,  1090,     0,     0,  1091,     0,     0,     0,  -729,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1087,
    1427,  1428,  1429,  1430,  1431,  1432,  1433,  1434,  1435,  1436,
    1437,  1438,  1439,  1440,  1441,  1442,  1443,  1444,  1445,  1446,
    1447,  1448,  1449,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1904,     0,     0,     0,     0,     0,     0,     0,  1088,
       0,     0,     0,  1089,  1090,     0,     0,  1091,     0,     0,
       0,  -736,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1087,  1427,  1428,  1429,  1430,  1431,  1432,  1433,  1434,
    1435,  1436,  1437,  1438,  1439,  1440,  1441,  1442,  1443,  1444,
    1445,  1446,  1447,  1448,  1449,  1428,  1429,  1430,  1431,  1432,
    1433,  1434,  1435,  1436,  1437,  1438,  1439,  1440,  1441,  1442,
    1443,  1444,  1445,  1446,  1447,  1448,  1449,     0,     0,     0,
       0,  1088,     0,     0,     0,  1089,  1090,     0,     0,  1091,
       0,     0,     0,  -730,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1087,  1429,  1430,  1431,  1432,  1433,  1434,
    1435,  1436,  1437,  1438,  1439,  1440,  1441,  1442,  1443,  1444,
    1445,  1446,  1447,  1448,  1449,  1431,  1432,  1433,  1434,  1435,
    1436,  1437,  1438,  1439,  1440,  1441,  1442,  1443,  1444,  1445,
    1446,  1447,  1448,  1449,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1088,     0,     0,     0,  1089,  1090,     0,
       0,  1091,     0,     0,     0,  1300,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1087,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1088,
       0,     0,     0,  1089,  1090,     0,     0,  1091,     0,     0,
    1299,  1322,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
       0,  1046,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,  1069,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,     0,     0,
    1078,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,  1299,     0,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,  1045,     0,  1046,  1047,  1048,  1049,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,     0,  1067,     0,  1068,     0,     0,     0,     0,
    1069,     0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
       0,     0,  1078,  1079,  1080,     0,     0,     0,  1081,  1082,
    1083,  1084,  1085,  1086,  1299,     0,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,     0,
       0,     0,     0,     0,     0,     0,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,     0,  1067,     0,  1068,     0,     0,
       0,     0,  1069,     0,  1070,  1071,  1072,  1073,  1074,  1075,
    1076,  1077,     0,     0,  1078,  1079,  1080,     0,     0,     0,
    1081,  1082,  1083,  1084,  1085,  1086,  1299,     0,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,
    1049,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
    1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,     0,  1068,
       0,     0,     0,     0,  1069,     0,  1070,  1071,  1072,  1073,
    1074,  1075,  1076,  1077,     0,     0,  1078,  1079,  1080,     0,
       0,     0,  1081,  1082,  1083,  1084,  1085,  1086,     0,     0,
       0,     0,  1299,     0,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,  1045,     0,  1046,  1047,  1048,  1049,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,  1087,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,     0,  1067,     0,  1068,     0,     0,     0,     0,
    1069,     0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
       0,     0,  1078,  1079,  1080,     0,     0,     0,  1081,  1082,
    1083,  1084,  1085,  1086,     0,     0,     0,     0,     0,     0,
       0,     0,  1088,     0,     0,     0,  1089,  1090,     0,     0,
    1091,     0,     0,     0,  1324,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1087,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1088,     0,     0,     0,  1089,  1090,
       0,     0,  1091,     0,     0,     0,  1326,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1087,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1088,     0,     0,     0,
    1089,  1090,     0,     0,  1091,     0,     0,     0,  1332,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1087,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1088,     0,
       0,     0,  1089,  1090,     0,     0,  1091,     0,     0,     0,
    1642,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1087,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1088,     0,     0,     0,  1089,  1090,
       0,     0,  1091,     0,     0,  1299,  1761,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,
       0,     0,     0,     0,     0,     0,     0,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,  1066,     0,  1067,     0,  1068,     0,
       0,     0,     0,  1069,     0,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,     0,     0,  1078,  1079,  1080,     0,     0,
       0,  1081,  1082,  1083,  1084,  1085,  1086,  1299,     0,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,
    1048,  1049,     0,     0,     0,     0,     0,     0,     0,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,     0,
    1068,     0,     0,     0,     0,  1069,     0,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,     0,     0,  1078,  1079,  1080,
       0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,  1299,
       0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,
    1046,  1047,  1048,  1049,     0,     0,     0,     0,     0,     0,
       0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,
    1067,     0,  1068,     0,     0,     0,     0,  1069,     0,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,     0,     0,  1078,
    1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,
    1086,  1299,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,     0,  1046,  1047,  1048,  1049,     0,     0,     0,     0,
       0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,
    1066,     0,  1067,     0,  1068,     0,     0,     0,     0,  1069,
       0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,     0,
       0,  1078,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,
    1084,  1085,  1086,     0,     0,     0,     0,  1299,     0,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,
    1048,  1049,     0,     0,     0,     0,     0,     0,     0,  1050,
    1051,  1052,  1053,  1054,  1055,  1056,  1057,  1087,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,     0,
    1068,     0,     0,     0,     0,  1069,     0,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1077,     0,     0,  1078,  1079,  1080,
       0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,     0,
       0,     0,     0,     0,     0,     0,     0,  1088,     0,     0,
       0,  1089,  1090,     0,     0,  1091,     0,     0,     0,  1776,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1087,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1088,
       0,     0,     0,  1089,  1090,     0,     0,  1091,     0,     0,
       0,  1818,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1087,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1088,     0,     0,     0,  1089,  1090,     0,     0,  1091,
       0,     0,     0,  1838,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1087,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1088,     0,     0,     0,  1089,  1090,     0,
       0,  1091,     0,     0,     0,  1839,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1087,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1088,
       0,     0,     0,  1089,  1090,     0,     0,  1091,     0,     0,
    1299,  1840,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
       0,  1046,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,  1069,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,     0,     0,
    1078,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,  1613,     0,  1038,  1039,  1040,  1041,  1042,     0,
       0,     0,     0,     0,  1047,  1048,  1049,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,     0,  1067,     0,  1068,     0,     0,     0,     0,
       0,     0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,
       0,     0,     0,  1079,  1080,     0,     0,     0,  1081,  1082,
    1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1614,  1615,  1616,  1617,  1618,  1619,  1623,     0,
    1038,  1039,  1040,  1041,  1042,     0,     0,     0,     0,     0,
    1047,  1048,  1049,     0,     0,     0,     0,     0,     0,     0,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,
       0,  1068,     0,     0,     0,     0,     0,     0,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,     0,     0,     0,     0,  1079,
    1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,
    1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,  1614,  1615,
    1616,  1617,  1618,  1619,  1403,     0,  1038,  1039,  1040,  1041,
    1042,     0,     0,     0,     0,     0,  1047,  1048,  1049,     0,
       0,     0,     0,     0,     0,     0,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,     0,  1067,     0,  1068,     0,     0,
       0,     0,     0,     0,  1070,  1071,  1072,  1073,  1074,  1075,
    1076,     0,  1087,     0,     0,  1079,  1080,     0,     0,     0,
    1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,
    1193,  1194,  1195,  1196,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1088,     0,     0,     0,  1089,  1090,     0,     0,
    1091,     0,     0,     0,  1841,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1087,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1198,
    1620,     0,     0,  1199,     0,  1200,  1201,  1202,  1203,     0,
    1204,  1205,  1206,   579,  1088,     0,  1207,     0,  1089,  1090,
       0,     0,     0,     0,  1270,  1209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1087,  1197,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1198,  1620,     0,     0,  1199,
       0,  1200,  1201,  1202,  1203,     0,  1204,  1205,  1206,   579,
    1088,     0,  1207,     0,  1089,  1090,     0,     0,     0,     0,
    1270,  1209,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1087,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1198,     0,     0,     0,  1199,     0,  1200,  1201,  1202,
    1203,     0,  1204,  1205,  1206,   579,  1088,     0,  1207,     0,
    1089,  1090,     0,     0,     0,  1404,  1270,  1209,  1403,     0,
    1038,  1039,  1040,  1041,  1042,     0,     0,     0,     0,     0,
    1047,  1048,  1049,     0,     0,     0,     0,     0,     0,     0,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,
       0,  1068,     0,     0,     0,     0,     0,     0,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,     0,     0,     0,     0,  1079,
    1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,
    1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,  1403,     0,
    1038,  1039,  1040,  1041,  1042,     0,     0,     0,     0,     0,
    1047,  1048,  1049,     0,     0,     0,     0,     0,     0,     0,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,
       0,  1068,     0,     0,     0,     0,     0,     0,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,     0,     0,     0,     0,  1079,
    1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,
    1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,  1824,     0,
    1038,  1039,  1040,  1041,  1042,     0,     0,     0,     0,     0,
    1047,  1048,  1049,     0,     0,     0,     0,     0,     0,     0,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,
       0,  1068,     0,     0,     0,     0,     0,     0,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,     0,     0,     0,     0,  1079,
    1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,
    1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1087,  1197,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1198,     0,     0,     0,  1199,
       0,  1200,  1201,  1202,  1203,     0,  1204,  1205,  1206,   579,
    1088,     0,  1207,     0,  1089,  1090,     0,     0,     0,  1452,
    1270,  1209,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1087,  1197,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1198,     0,     0,     0,  1199,
       0,  1200,  1201,  1202,  1203,     0,  1204,  1205,  1206,   579,
    1088,     0,  1207,     0,  1089,  1090,     0,     0,     0,  1453,
    1270,  1209,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1087,  1197,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1198,     0,  1825,     0,  1199,
       0,  1200,  1201,  1202,  1203,     0,  1204,  1205,  1206,   579,
    1088,     0,  1207,     0,  1089,  1090,     0,     0,     0,     0,
    1270,  1209,  1282,     0,  1038,  1039,  1040,  1041,  1042,     0,
       0,     0,     0,     0,  1047,  1048,  1049,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,     0,  1067,     0,  1068,     0,     0,     0,     0,
       0,     0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,
       0,     0,     0,  1079,  1080,     0,     0,     0,  1081,  1082,
    1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1394,     0,  1038,  1039,  1040,  1041,  1042,     0,
       0,     0,     0,     0,  1047,  1048,  1049,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,     0,  1067,     0,  1068,     0,     0,     0,     0,
       0,     0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,
       0,     0,     0,  1079,  1080,     0,     0,     0,  1081,  1082,
    1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1396,     0,  1038,  1039,  1040,  1041,  1042,     0,
       0,     0,     0,     0,  1047,  1048,  1049,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,     0,  1067,     0,  1068,     0,     0,     0,     0,
       0,     0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,
       0,     0,     0,  1079,  1080,     0,     0,     0,  1081,  1082,
    1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1087,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1198,
       0,     0,     0,  1199,     0,  1200,  1201,  1202,  1203,     0,
    1204,  1205,  1206,   579,  1088,     0,  1207,     0,  1089,  1090,
       0,     0,     0,     0,  1270,  1209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1087,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1198,
       0,     0,     0,  1199,     0,  1200,  1201,  1202,  1203,     0,
    1204,  1205,  1206,   579,  1088,     0,  1207,     0,  1089,  1090,
       0,     0,     0,     0,  1270,  1209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1087,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1198,
       0,     0,     0,  1199,     0,  1200,  1201,  1202,  1203,     0,
    1204,  1205,  1206,   579,  1088,     0,  1207,     0,  1089,  1090,
       0,     0,     0,     0,  1270,  1209,  1398,     0,  1038,  1039,
    1040,  1041,  1042,     0,     0,     0,     0,     0,  1047,  1048,
    1049,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
    1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,     0,  1068,
       0,     0,     0,     0,     0,     0,  1070,  1071,  1072,  1073,
    1074,  1075,  1076,     0,     0,     0,     0,  1079,  1080,     0,
       0,     0,  1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
    1191,  1192,  1193,  1194,  1195,  1196,  1425,     0,  1038,  1039,
    1040,  1041,  1042,     0,     0,     0,     0,     0,  1047,  1048,
    1049,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
    1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,     0,  1068,
       0,     0,     0,     0,     0,     0,  1070,  1071,  1072,  1073,
    1074,  1075,  1076,     0,     0,     0,     0,  1079,  1080,     0,
       0,     0,  1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
    1191,  1192,  1193,  1194,  1195,  1196,  1459,     0,  1038,  1039,
    1040,  1041,  1042,     0,     0,     0,     0,     0,  1047,  1048,
    1049,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
    1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,     0,  1068,
       0,     0,     0,     0,     0,     0,  1070,  1071,  1072,  1073,
    1074,  1075,  1076,     0,     0,     0,     0,  1079,  1080,     0,
       0,     0,  1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
    1191,  1192,  1193,  1194,  1195,  1196,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1087,  1197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1198,     0,     0,     0,  1199,     0,  1200,
    1201,  1202,  1203,     0,  1204,  1205,  1206,   579,  1088,     0,
    1207,     0,  1089,  1090,     0,     0,     0,     0,  1270,  1209,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1087,  1197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1198,     0,     0,     0,  1199,     0,  1200,
    1201,  1202,  1203,     0,  1204,  1205,  1206,   579,  1088,     0,
    1207,     0,  1089,  1090,     0,     0,     0,     0,  1270,  1209,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1087,  1197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1198,     0,     0,     0,  1199,     0,  1200,
    1201,  1202,  1203,     0,  1204,  1205,  1206,   579,  1460,     0,
    1207,     0,  1089,  1090,     0,     0,     0,     0,  1270,  1209,
    1403,     0,  1038,  1039,  1040,  1041,  1042,     0,     0,     0,
       0,     0,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,     0,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,     0,     0,
       0,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,
    1610,     0,  1038,  1039,  1040,  1041,  1042,     0,     0,     0,
       0,     0,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,     0,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,     0,     0,
       0,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,
    1632,     0,  1038,  1039,  1040,  1041,  1042,     0,     0,     0,
       0,     0,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,     0,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,     0,     0,
       0,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1087,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1198,     0,     0,
       0,  1199,     0,  1200,  1201,  1202,  1203,     0,  1204,  1205,
    1206,   579,  1088,     0,  1207,     0,  1089,  1090,     0,     0,
       0,     0,  1270,  1209,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1087,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1198,     0,     0,
       0,  1199,     0,  1200,  1201,  1202,  1203,     0,  1204,  1205,
    1206,   579,  1611,     0,  1207,     0,  1089,  1090,     0,     0,
       0,     0,  1270,  1209,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1087,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1198,     0,     0,
       0,  1199,     0,  1200,  1201,  1202,  1203,     0,  1204,  1205,
    1206,   579,  1088,     0,  1207,     0,  1089,  1090,     0,     0,
       0,     0,  1270,  1209,  1634,     0,  1038,  1039,  1040,  1041,
    1042,     0,     0,     0,     0,     0,  1047,  1048,  1049,     0,
       0,     0,     0,     0,     0,     0,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,     0,  1067,     0,  1068,     0,     0,
       0,     0,     0,     0,  1070,  1071,  1072,  1073,  1074,  1075,
    1076,     0,     0,     0,     0,  1079,  1080,     0,     0,     0,
    1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,
    1193,  1194,  1195,  1196,  1636,     0,  1038,  1039,  1040,  1041,
    1042,     0,     0,     0,     0,     0,  1047,  1048,  1049,     0,
       0,     0,     0,     0,     0,     0,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,     0,  1067,     0,  1068,     0,     0,
       0,     0,     0,     0,  1070,  1071,  1072,  1073,  1074,  1075,
    1076,     0,     0,     0,     0,  1079,  1080,     0,     0,     0,
    1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,
    1193,  1194,  1195,  1196,  1643,     0,  1038,  1039,  1040,  1041,
    1042,     0,     0,     0,     0,     0,  1047,  1048,  1049,     0,
       0,     0,     0,     0,     0,     0,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,     0,  1067,     0,  1068,     0,     0,
       0,     0,     0,     0,  1070,  1071,  1072,  1073,  1074,  1075,
    1076,     0,     0,     0,     0,  1079,  1080,     0,     0,     0,
    1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,
    1193,  1194,  1644,  1196,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1087,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1198,     0,     0,     0,  1199,     0,  1200,  1201,  1202,
    1203,     0,  1204,  1205,  1206,   579,  1088,     0,  1207,     0,
    1089,  1090,     0,     0,     0,     0,  1270,  1209,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1087,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1198,     0,     0,     0,  1199,     0,  1200,  1201,  1202,
    1203,     0,  1204,  1205,  1206,   579,  1088,     0,  1207,     0,
    1089,  1090,     0,     0,     0,     0,  1270,  1209,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1087,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1198,     0,     0,     0,  1199,     0,  1200,  1201,  1202,
    1203,     0,  1204,  1205,  1206,   579,  1088,     0,  1207,     0,
    1089,  1090,     0,     0,     0,     0,  1270,  1209,  1646,     0,
    1038,  1039,  1040,  1041,  1042,     0,     0,     0,     0,     0,
    1047,  1048,  1049,     0,     0,     0,     0,     0,     0,     0,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,
       0,  1068,     0,     0,     0,     0,     0,     0,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,     0,     0,     0,     0,  1079,
    1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,
    1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,  1648,     0,
    1038,  1039,  1040,  1041,  1042,     0,     0,     0,     0,     0,
    1047,  1048,  1049,     0,     0,     0,     0,     0,     0,     0,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,
       0,  1068,     0,     0,     0,     0,     0,     0,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,     0,     0,     0,     0,  1079,
    1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,
    1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,  1659,     0,
    1038,  1039,  1040,  1041,  1042,     0,     0,     0,     0,     0,
    1047,  1048,  1049,     0,     0,     0,     0,     0,     0,     0,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,
       0,  1068,     0,     0,     0,     0,     0,     0,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,     0,     0,     0,     0,  1079,
    1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,
    1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,
    1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1087,  1197,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1198,     0,     0,     0,  1199,
       0,  1200,  1201,  1202,  1203,     0,  1204,  1205,  1206,   579,
    1088,     0,  1207,     0,  1089,  1090,     0,     0,     0,     0,
    1270,  1209,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1087,  1197,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1198,     0,     0,     0,  1199,
       0,  1200,  1201,  1202,  1203,     0,  1204,  1205,  1206,   579,
    1088,     0,  1207,     0,  1089,  1090,     0,     0,     0,     0,
    1270,  1209,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1087,  1197,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1198,     0,     0,     0,  1199,
       0,  1200,  1201,  1202,  1203,     0,  1204,  1205,  1206,   579,
    1088,     0,  1207,     0,  1089,  1090,     0,     0,     0,     0,
    1270,  1209,  1661,     0,  1038,  1039,  1040,  1041,  1042,     0,
       0,     0,     0,     0,  1047,  1048,  1049,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,     0,  1067,     0,  1068,     0,     0,     0,     0,
       0,     0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,
       0,     0,     0,  1079,  1080,     0,     0,     0,  1081,  1082,
    1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1663,     0,  1038,  1039,  1040,  1041,  1042,     0,
       0,     0,     0,     0,  1047,  1048,  1049,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,     0,  1067,     0,  1068,     0,     0,     0,     0,
       0,     0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,
       0,     0,     0,  1079,  1080,     0,     0,     0,  1081,  1082,
    1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1665,     0,  1038,  1039,  1040,  1041,  1042,     0,
       0,     0,     0,     0,  1047,  1048,  1049,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,     0,  1067,     0,  1068,     0,     0,     0,     0,
       0,     0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,
       0,     0,     0,  1079,  1080,     0,     0,     0,  1081,  1082,
    1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1087,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1198,
       0,     0,     0,  1199,     0,  1200,  1201,  1202,  1203,     0,
    1204,  1205,  1206,   579,  1088,     0,  1207,     0,  1089,  1090,
       0,     0,     0,     0,  1270,  1209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1087,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1198,
       0,     0,     0,  1199,     0,  1200,  1201,  1202,  1203,     0,
    1204,  1205,  1206,   579,  1088,     0,  1207,     0,  1089,  1090,
       0,     0,     0,     0,  1270,  1209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1087,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1198,
       0,     0,     0,  1199,     0,  1200,  1201,  1202,  1203,     0,
    1204,  1205,  1206,   579,  1088,     0,  1207,     0,  1089,  1090,
       0,     0,     0,     0,  1270,  1209,  1670,     0,  1038,  1039,
    1040,  1041,  1042,     0,     0,     0,     0,     0,  1047,  1048,
    1049,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
    1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,     0,  1068,
       0,     0,     0,     0,     0,     0,  1070,  1071,  1072,  1073,
    1074,  1075,  1076,     0,     0,     0,     0,  1079,  1080,     0,
       0,     0,  1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
    1191,  1192,  1193,  1194,  1195,  1196,  1672,     0,  1038,  1039,
    1040,  1041,  1042,     0,     0,     0,     0,     0,  1047,  1048,
    1049,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
    1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,     0,  1068,
       0,     0,     0,     0,     0,     0,  1070,  1071,  1072,  1073,
    1074,  1075,  1076,     0,     0,     0,     0,  1079,  1080,     0,
       0,     0,  1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
    1191,  1192,  1193,  1194,  1195,  1196,  1674,     0,  1038,  1039,
    1040,  1041,  1042,     0,     0,     0,     0,     0,  1047,  1048,
    1049,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
    1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,     0,  1068,
       0,     0,     0,     0,     0,     0,  1070,  1071,  1072,  1073,
    1074,  1075,  1076,     0,     0,     0,     0,  1079,  1080,     0,
       0,     0,  1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,
    1181,  1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,
    1191,  1192,  1193,  1194,  1195,  1196,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1087,  1197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1198,     0,     0,     0,  1199,     0,  1200,
    1201,  1202,  1203,     0,  1204,  1205,  1206,   579,  1088,     0,
    1207,     0,  1089,  1090,     0,     0,     0,     0,  1270,  1209,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1087,  1197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1198,     0,     0,     0,  1199,     0,  1200,
    1201,  1202,  1203,     0,  1204,  1205,  1206,   579,  1088,     0,
    1207,     0,  1089,  1090,     0,     0,     0,     0,  1270,  1209,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1087,  1197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1198,     0,     0,     0,  1199,     0,  1200,
    1201,  1202,  1203,     0,  1204,  1205,  1206,   579,  1088,     0,
    1207,     0,  1089,  1090,     0,     0,     0,     0,  1270,  1209,
    1676,     0,  1038,  1039,  1040,  1041,  1042,     0,     0,     0,
       0,     0,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,     0,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,     0,     0,
       0,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,
    1678,     0,  1038,  1039,  1040,  1041,  1042,     0,     0,     0,
       0,     0,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,     0,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,     0,     0,
       0,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,
    1680,     0,  1038,  1039,  1040,  1041,  1042,     0,     0,     0,
       0,     0,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,     0,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,     0,     0,
       0,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1087,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1198,     0,     0,
       0,  1199,     0,  1200,  1201,  1202,  1203,     0,  1204,  1205,
    1206,   579,  1088,     0,  1207,     0,  1089,  1090,     0,     0,
       0,     0,  1270,  1209,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1087,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1198,     0,     0,
       0,  1199,     0,  1200,  1201,  1202,  1203,     0,  1204,  1205,
    1206,   579,  1088,     0,  1207,     0,  1089,  1090,     0,     0,
       0,     0,  1270,  1209,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1087,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1198,     0,     0,
       0,  1199,     0,  1200,  1201,  1202,  1203,     0,  1204,  1205,
    1206,   579,  1088,     0,  1207,     0,  1089,  1090,     0,     0,
       0,     0,  1270,  1209,  1682,     0,  1038,  1039,  1040,  1041,
    1042,     0,     0,     0,     0,     0,  1047,  1048,  1049,     0,
       0,     0,     0,     0,     0,     0,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,     0,  1067,     0,  1068,     0,     0,
       0,     0,     0,     0,  1070,  1071,  1072,  1073,  1074,  1075,
    1076,     0,     0,     0,     0,  1079,  1080,     0,     0,     0,
    1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,
    1193,  1194,  1195,  1196,  1888,     0,  1038,  1039,  1040,  1041,
    1042,     0,     0,     0,     0,     0,  1047,  1048,  1049,     0,
       0,     0,     0,     0,     0,     0,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,     0,  1067,     0,  1068,     0,     0,
       0,     0,     0,     0,  1070,  1071,  1072,  1073,  1074,  1075,
    1076,     0,     0,     0,     0,  1079,  1080,     0,     0,     0,
    1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,
    1193,  1194,  1195,  1196,  1038,  1039,  1040,  1041,  1042,     0,
       0,     0,     0,     0,  1047,  1048,  1049,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,     0,  1067,     0,  1068,     0,     0,     0,     0,
       0,     0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,
       0,     0,     0,  1079,  1080,     0,     0,     0,  1081,  1082,
    1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1087,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1198,     0,     0,     0,  1199,     0,  1200,  1201,  1202,
    1203,     0,  1204,  1205,  1206,   579,  1088,     0,  1207,     0,
    1089,  1090,     0,     0,     0,     0,  1270,  1209,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1087,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1198,     0,     0,     0,  1199,     0,  1200,  1201,  1202,
    1203,     0,  1204,  1205,  1206,   579,  1088,     0,  1207,     0,
    1089,  1090,     0,     0,     0,     0,  1270,  1209,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1087,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1198,
       0,     0,     0,  1199,     0,  1200,  1201,  1202,  1203,     0,
    1204,  1205,  1206,   579,  1088,     0,  1207,     0,  1089,  1090,
       0,     0,     0,     0,  1208,  1209,  1038,  1039,  1040,  1041,
    1042,     0,     0,     0,     0,     0,  1047,  1048,  1049,     0,
       0,     0,     0,     0,     0,     0,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,     0,  1067,     0,  1068,     0,     0,
       0,     0,     0,     0,  1070,  1071,  1072,  1073,  1074,  1075,
    1076,     0,     0,     0,     0,  1079,  1080,     0,     0,     0,
    1081,  1082,  1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,
    1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,
    1193,  1194,  1195,  1196,  1038,  1039,  1040,  1041,  1042,     0,
       0,     0,     0,     0,  1047,  1048,  1049,     0,     0,     0,
       0,     0,     0,     0,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,     0,  1067,     0,  1068,     0,     0,     0,     0,
       0,     0,  1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,
       0,     0,     0,  1079,  1080,     0,     0,     0,  1081,  1082,
    1083,  1084,  1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1038,  1039,  1040,  1041,  1042,     0,     0,     0,
       0,     0,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,     0,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,     0,     0,
       0,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,
    1047,  1048,  1049,     0,     0,     0,     0,     0,     0,     0,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,
       0,  1068,     0,     0,     0,     0,  1069,     0,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,  1077,  1087,  1197,  1078,  1079,
    1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1198,     0,     0,     0,  1199,     0,  1200,  1201,  1202,
    1203,     0,  1204,  1205,  1206,   579,  1088,     0,  1207,     0,
    1089,  1090,     0,     0,     0,     0,  1229,  1209,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1087,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1198,
       0,     0,     0,  1199,     0,  1200,  1201,  1202,  1203,     0,
    1204,  1205,  1206,   579,  1088,     0,  1207,     0,  1089,  1090,
       0,     0,     0,     0,  1231,  1209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1087,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1198,     0,     0,
       0,  1199,     0,  1200,  1201,  1202,  1203,     0,  1204,  1205,
    1206,   579,  1088,     0,  1207,     0,  1089,  1090,     0,     0,
       0,     0,  1270,  1209,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1087,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1427,  1428,  1429,  1430,
    1431,  1432,  1433,  1434,  1435,  1436,  1437,  1438,  1439,  1440,
    1441,  1442,  1443,  1444,  1445,  1446,  1447,  1448,  1449,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1088,     0,     0,     0,  1089,  1090,     0,     0,  1091,     0,
       0,  1496,  1038,  1039,  1040,  1041,  1042,     0,     0,     0,
       0,     0,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,     0,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,     0,     0,     0,
       0,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1196,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,
    1047,  1048,  1049,     0,     0,     0,     0,     0,     0,     0,
    1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,     0,  1067,
       0,  1068,     0,     0,     0,     0,  1069,     0,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,  1077,     0,     0,  1078,  1079,
    1080,     0,     0,     0,  1081,  1082,  1083,  1084,  1085,  1086,
    1411,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
       0,  1046,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,  1069,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,     0,     0,
    1078,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
       0,  1046,  1047,  1048,  1049,     0,     0,     0,     0,     0,
       0,     0,  1050,  1051,  1052,  1053,  1054,  1055,  1056,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
       0,  1067,     0,  1068,     0,     0,     0,     0,  1069,     0,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,     0,     0,
    1078,  1079,  1080,     0,     0,     0,  1081,  1082,  1083,  1084,
    1085,  1086,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1087,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1198,     0,     0,
       0,  1199,     0,  1200,  1201,  1202,  1203,     0,  1204,  1205,
    1206,  1831,  1088,     0,  1207,     0,  1089,  1090,     0,     0,
       0,     0,  1270,  1209,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1087,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1088,     0,     0,     0,  1089,  1090,     0,     0,  1091,     0,
       0,  1496,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1087,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1088,     0,     0,     0,  1089,  1090,     0,     0,
    1091,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1087,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1088,     0,     0,     0,  1089,  1090,     0,     0,
    1091
};

static const yytype_int16 yycheck[] =
{
     256,   222,   470,   259,  1336,   989,   254,  1284,   992,     1,
       1,   995,     1,  1170,   998,  1172,     1,  1174,     1,  1176,
     338,  1178,  1006,  1191,     1,  1193,     1,  1195,     1,   338,
     358,     1,   288,     1,   290,  1219,   292,     1,   294,    60,
       1,     1,     1,   368,   372,  1213,   358,     1,   989,     1,
       1,   992,     1,     1,   995,    65,     1,   998,    65,   387,
     372,   386,     1,   992,    65,  1006,   995,     1,   358,   998,
      59,    60,     1,    64,     1,     1,     1,  1006,   372,     1,
    1211,   375,   372,   359,  1215,   375,   114,   115,     1,   338,
       1,   989,     1,     1,   992,     1,   372,   995,     1,   355,
     998,   338,     1,     1,     1,    64,     1,     1,  1006,  1093,
       1,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     1,     1,     1,     1,  1110,   338,  1112,     1,
    1114,     1,   358,   358,  1118,   338,     1,    91,    92,    93,
      94,   338,   368,   368,     1,   338,     1,   113,   114,   115,
       1,     1,  1093,   621,   338,     1,     1,   338,     1,     1,
       1,     1,   418,   419,   420,     1,   338,    59,    60,  1110,
       1,  1112,   380,  1114,   382,     1,     1,  1118,    91,    92,
      93,    94,     1,    91,    92,    93,    94,   338,     1,     1,
       1,   380,     1,   382,   338,  1093,   452,   453,     1,     1,
     338,     1,     1,     1,   338,     1,     1,     1,     1,     1,
     372,   373,  1110,   375,  1112,   338,  1114,     1,     1,    64,
    1118,  1208,     1,     1,  1208,  1209,    91,    92,    93,    94,
       1,   373,     1,   375,    91,    92,    93,    94,     1,    15,
      16,     1,  1229,   338,  1231,  1229,     1,  1231,   338,   505,
       1,   338,   508,   509,     1,   114,   115,     1,     1,   338,
       1,   359,   360,   361,    64,     1,  1423,  1208,  1209,     1,
     338,     1,     1,     1,  1019,  1020,     1,   358,     1,   338,
    1209,     1,     1,  1270,     1,     1,  1270,  1271,  1229,     1,
    1231,   372,     1,     1,   375,   358,   377,     1,   338,     1,
    1284,    64,   338,     1,     1,     1,     1,     1,     1,   372,
    1208,  1209,   375,     1,     1,     1,   338,     1,     1,   989,
     338,     1,   992,     1,     1,   995,     1,     1,   998,  1270,
    1271,  1229,     1,  1231,     1,  1319,  1006,     1,     1,     1,
       1,     1,     1,  1284,     1,  1529,     1,    17,     1,  1333,
       1,   372,   373,     1,   338,     1,     1,     1,     1,     1,
       1,   389,   372,   368,   338,   372,   358,     1,   338,  1353,
     338,   372,  1270,  1271,    21,     1,     1,     1,  1319,     1,
     372,   372,   373,     1,   375,   376,  1284,   372,   373,   372,
     382,   382,  1333,   376,  1726,   386,   385,   372,   373,   374,
     375,   376,   375,   386,  1333,   359,     1,   384,   372,   386,
     383,   386,  1353,   372,   373,   376,   375,   376,   372,   373,
     374,   375,   376,  1093,  1353,   386,   386,   386,  1412,   383,
     382,   383,   386,   384,   383,  1333,   384,  1769,   386,   384,
    1110,   386,  1112,  1720,  1114,   384,   359,   386,  1118,     1,
     384,   359,   386,   375,   383,  1353,   381,   384,   384,   372,
     373,   374,   375,   376,   372,   373,   374,   375,   376,   375,
     383,  1412,   383,   386,   383,   383,  1644,   383,   386,     1,
     383,     1,     1,  1651,   383,   383,   383,     0,   383,   383,
       1,     1,   383,   385,   359,    20,   338,   373,     1,   375,
       1,   373,   359,   375,   383,   383,   383,   372,   373,   374,
     375,   376,  1496,   383,  1412,   372,   373,   374,   375,   376,
     375,   386,   372,   373,   374,   375,   376,   372,   373,   386,
     375,   376,   383,   375,     1,    22,   386,   383,  1208,  1209,
     383,   386,   383,   383,   375,     1,   338,   383,  1016,  1533,
    1534,  1535,  1536,     1,  1886,  1496,  1540,   383,   383,  1229,
     372,  1231,   373,   323,   383,   989,   375,  1496,   992,  1901,
     383,   995,   372,   373,   998,   375,   376,     1,  1562,   372,
     383,   383,  1006,   375,   383,   383,   386,   383,   383,   383,
     373,   375,  1533,  1534,  1535,  1536,   375,   375,  1496,  1540,
    1270,  1271,   373,   372,  1533,  1534,  1535,  1536,   338,   372,
     373,     1,   375,   376,  1284,   375,   989,   372,   378,   992,
       1,  1562,   995,   386,   375,   998,   373,   382,   375,   373,
     373,   375,   375,  1006,   375,  1533,  1534,  1535,  1536,   375,
       1,   373,  1540,   375,   373,   373,   375,   375,   373,   372,
     375,  1093,   375,   372,  1122,   375,   375,  1814,   375,   375,
     372,   373,   374,  1333,  1562,   373,   375,   375,  1110,  1093,
    1112,   375,  1114,   375,     1,     1,  1118,   375,   375,   375,
     375,   375,   375,  1353,     1,   372,  1110,   375,  1112,   375,
    1114,   375,   375,     1,  1118,   375,     1,   375,   375,     1,
     375,   375,     1,   358,     1,   358,   375,     1,   375,     1,
     358,   375,   375,   375,   375,   375,   375,   372,   375,   372,
    1093,   372,   373,   374,   372,   359,   372,   372,   372,   372,
     372,   372,   358,   358,   358,  1719,  1720,  1110,   372,  1112,
     358,  1114,  1412,     1,     1,  1118,   372,   372,   372,   338,
     372,     1,   384,     1,   372,     1,     1,     1,     1,     1,
       1,     1,     1,   358,   985,     1,     1,     1,     1,     1,
    1754,  1755,  1756,  1757,     1,     1,     1,   372,  1719,  1720,
       1,     1,     1,     1,     1,  1209,   372,   373,     1,   375,
     275,   338,   277,     1,     1,     1,    65,     1,     1,     1,
       1,     1,     1,     1,     1,  1273,   358,     1,     1,  1277,
       1,     1,     1,  1754,  1755,  1756,  1757,     1,    65,     1,
     372,  1719,  1720,     1,     1,     1,  1496,     1,     1,  1271,
       1,     1,     1,     1,     1,     1,  1209,   359,   358,   358,
       1,     1,  1284,     1,  1828,     1,   338,  1271,   358,     1,
     372,     1,   372,   372,     1,   358,  1754,  1755,  1756,  1757,
    1284,   372,   372,  1533,  1534,  1535,  1536,   338,     1,   372,
    1540,   372,  1340,     1,  1342,   338,     1,  1345,     1,     1,
       1,     1,     1,     1,  1043,  1044,  1045,  1828,   338,     1,
     338,   358,  1562,   338,     1,  1319,     1,     1,  1271,  1828,
     338,   338,   358,  1887,     1,   372,  1890,  1891,     1,  1333,
    1069,  1284,     1,     1,     1,   380,   372,   382,  1077,  1078,
       1,     1,  1906,  1907,  1908,   338,  1910,     1,     1,  1353,
    1828,  1915,  1916,     1,   358,     1,     1,     1,     1,     1,
       1,   338,   338,     1,     1,     1,  1887,     1,   372,  1890,
    1891,     1,     1,     1,     1,     1,     1,     1,  1887,   338,
    1333,  1890,   380,   358,   382,  1906,  1907,  1908,   358,  1910,
    1412,   338,   338,   368,  1915,  1916,   338,   358,  1907,  1908,
    1353,   338,   372,     1,     1,   380,   375,   382,  1412,  1887,
       1,   372,  1890,  1891,   380,   338,   382,   358,     1,  1255,
       1,     1,     1,     1,   372,   373,   358,   375,  1906,  1907,
    1908,   372,  1910,   338,     1,     1,   368,  1915,  1916,   338,
       1,  1269,     1,   338,   372,   373,     1,   375,   380,  1277,
     382,   358,   358,    91,    92,    93,    94,     1,     1,  1412,
       1,   358,  1201,  1202,  1203,   372,   372,   346,   347,  1719,
    1720,     1,   351,   352,     1,   372,     1,     1,     1,     1,
       1,     1,     1,     1,   372,   338,     1,   372,  1227,  1290,
     372,  1292,  1496,  1294,     1,   372,     1,     1,   372,  1238,
     372,     1,     1,     1,  1754,  1755,  1756,  1757,    91,    92,
      93,    94,     1,     1,  1342,  1351,  1352,  1345,  1540,     1,
     380,   338,   382,   372,   338,   380,   380,   382,   382,  1533,
    1534,  1535,  1536,   372,   372,   372,  1540,   380,   372,   382,
    1562,   372,   372,  1496,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   389,   384,   372,   372,  1562,   372,
     372,   626,   380,   372,   382,   372,   372,   372,   372,   372,
     338,   372,   372,   372,   372,   372,   372,  1316,  1828,   372,
    1533,  1534,  1535,  1536,   372,   372,   372,  1540,   372,   372,
     372,   372,   372,   372,   372,   372,   338,     1,   372,   372,
     372,   372,   372,   372,   380,   380,   338,   382,   372,  1562,
     372,   372,   338,   338,   372,   372,   372,   338,   372,   372,
     338,   372,   372,   372,   372,   372,   372,   338,   380,   338,
     382,   372,   372,   372,   372,   372,   372,  1887,   382,   372,
    1890,  1891,   372,   338,   338,   372,   380,   338,   382,  1388,
    1389,  1390,   338,   372,   338,   338,  1906,  1907,  1908,   372,
    1910,  1400,  1401,  1402,   372,  1915,  1916,   372,   338,   372,
     372,   372,   372,   372,   372,  1414,   338,   338,   338,  1727,
     372,  1420,  1421,   338,  1423,   372,   338,   372,  1427,  1428,
    1429,  1430,  1431,  1432,  1433,   372,   372,  1719,  1720,   372,
     380,   338,   382,   372,   372,   372,  1445,  1446,  1447,  1448,
    1449,  1450,  1451,   372,   338,  1719,  1720,   338,   372,   372,
    1768,   359,  1770,   380,   372,   382,   372,   372,   372,   372,
     372,   372,  1754,  1755,  1756,  1757,   372,   338,   372,   338,
     338,   338,   372,   372,   372,   372,   372,   372,   338,   338,
    1754,  1755,  1756,  1757,   372,   346,   347,   338,   338,   338,
     351,   352,   353,   354,   355,   356,  1719,  1720,   346,   347,
     348,   338,   372,   351,   352,   338,   359,   338,   338,   372,
     346,   347,   348,   338,  1523,   351,   352,   346,   347,   348,
     338,   338,   351,   352,   338,   338,   380,   338,   382,   338,
     338,  1754,  1755,  1756,  1757,   113,   114,   115,   338,   338,
     380,   338,   382,   338,   338,   338,   338,   338,   338,   338,
     338,   338,  1658,   338,  1828,   113,   114,   115,   380,   338,
     382,   338,   338,   338,   338,   380,   338,   382,   338,   338,
     338,     1,   338,   357,   358,   359,   360,   361,   338,   338,
     338,   255,   256,   257,   258,   338,   338,   165,   166,   338,
     338,  1172,   338,  1174,   987,  1176,   338,  1178,   991,  1891,
     338,   994,   338,   338,   997,  1828,   338,   165,   166,   338,
     338,   338,   338,  1887,  1906,   358,  1890,  1891,  1910,   338,
     338,   346,   347,  1915,  1916,   368,   351,   352,   358,   338,
     338,   338,  1906,  1907,  1908,   338,  1910,   380,   368,   382,
     338,  1915,  1916,   338,    74,    75,    76,    77,   338,    79,
     380,    81,   382,    83,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   338,  1887,   338,   358,  1890,  1891,   302,
     303,   304,   305,   306,   338,   308,   368,   338,   338,  1750,
     338,   338,  1753,  1906,  1907,  1908,   338,  1910,   380,   338,
     382,   338,  1915,  1916,   338,   338,   338,   375,   338,   338,
    1806,   338,   373,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,  1730,   372,   373,   374,   375,   376,  1736,   338,     0,
       1,   338,   338,   383,   338,   338,   386,   338,   338,   338,
      11,   338,   338,   338,    15,    16,    17,    18,    19,    20,
      21,    22,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,    39,   338,
      41,   338,    43,    44,    45,    46,    47,    48,   338,   338,
     372,   373,   374,   375,   376,   338,   338,   338,   338,    60,
      91,    92,    93,    94,   386,    91,    92,    93,    94,    95,
      96,   338,   338,   381,  1813,   338,   338,   385,   338,   338,
     338,   338,   338,   338,   338,   338,  1825,   338,   338,   338,
     338,   338,   338,   381,  1833,   338,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,  1423,   338,   338,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     338,   162,   163,   164,   338,  1904,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   338,   372,   372,   372,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   372,   300,
     301,   372,   372,   372,   372,   372,   307,   372,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   372,   372,   372,   372,   338,   380,   359,   375,
     375,   375,   372,   372,   335,   336,   337,   372,   372,   372,
     372,   372,   373,   374,   375,   376,   372,   373,   374,   375,
     376,   372,   383,   372,   384,   386,   384,   384,   387,   372,
     386,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     386,   368,   373,   376,   389,   389,   384,   338,   380,   338,
     381,   380,   338,   338,   338,   338,     1,   388,     3,     4,
       5,     6,     7,     8,     9,    10,   372,    12,    13,    14,
      15,   379,   338,   387,   372,   380,   387,   387,    23,    24,
      25,    26,    27,    28,    29,    30,   383,    32,    33,    34,
      35,    36,    37,    38,    39,    40,   375,    42,   375,    44,
     375,   375,   375,   383,    49,   383,    51,    52,    53,    54,
      55,    56,    57,    58,   383,   383,    61,    62,    63,   383,
     383,   383,    67,    68,    69,    70,    71,    72,     1,   383,
       3,     4,     5,     6,     7,     8,     9,    10,   383,    12,
      13,    14,    15,   383,   338,   381,   381,   368,   387,   387,
      23,    24,    25,    26,    27,    28,    29,    30,   387,    32,
      33,    34,    35,    36,    37,    38,    39,    40,   387,    42,
     384,    44,   368,   389,   389,   114,    49,   338,    51,    52,
      53,    54,    55,    56,    57,    58,   338,   338,    61,    62,
      63,   338,   338,   382,    67,    68,    69,    70,    71,    72,
       1,   382,     3,     4,     5,     6,     7,     8,     9,    10,
     380,    12,    13,    14,    15,   380,   384,   383,   375,   383,
     383,   383,    23,    24,    25,    26,    27,    28,    29,    30,
     386,    32,    33,    34,    35,    36,    37,    38,    39,    40,
     382,    42,   382,    44,   382,   382,   382,   382,    49,   382,
      51,    52,    53,    54,    55,    56,    57,    58,   382,   382,
      61,    62,    63,   368,   384,   384,    67,    68,    69,    70,
      71,    72,     1,   384,     3,     4,     5,     6,     7,     8,
       9,    10,   384,    12,    13,    14,    15,   299,   299,   372,
     375,   372,   382,   382,    23,    24,    25,    26,    27,    28,
      29,    30,   382,    32,    33,    34,    35,    36,    37,    38,
      39,    40,   382,    42,   382,    44,   373,   382,   338,   338,
      49,   338,    51,    52,    53,    54,    55,    56,    57,    58,
     338,   382,    61,    62,    63,   385,   382,   386,    67,    68,
      69,    70,    71,    72,   380,   382,   380,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
      50,   389,   382,   382,   389,   382,   382,   382,   323,   382,
     382,   382,   382,   382,   382,   382,   382,   382,    91,    92,
      93,    94,   384,   382,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   382,   382,   382,
     382,   382,   382,   368,   382,   382,   382,   382,   373,   382,
     382,   382,   377,   378,   382,   380,   381,   382,   383,   384,
     382,   382,   382,   387,   389,   382,   382,   382,   382,   380,
     323,   373,   382,   382,   382,   382,   382,   382,   382,   382,
     380,   375,   375,   338,   368,   114,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   389,
     389,   389,   389,   389,   382,   382,   382,   382,   382,   382,
     373,   372,   372,   372,   377,   378,   372,   380,   381,   382,
     383,   384,   372,   372,   372,   372,   389,   372,   372,   372,
     372,   372,   323,   372,   372,   386,   368,   360,   372,   375,
     375,   114,   382,   389,   375,   382,   372,   372,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   385,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   373,   382,   382,   382,   377,   378,   382,   380,
     381,   382,   382,   384,   382,   382,   382,   382,   389,   382,
     382,   382,   382,   382,   323,   382,   382,   382,   115,   387,
     375,   382,   382,   382,   382,   389,   389,   389,   372,   114,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   389,   389,   387,   387,   230,  1122,   389,
     389,  1014,  1390,   983,   373,  1151,   985,     1,   377,   378,
    1331,   380,   381,   382,   425,   384,   359,    11,   426,  1825,
     389,    15,    16,    17,    18,    19,    20,    21,    22,   372,
     373,   374,   375,   376,    -1,   622,  1392,  1392,  1524,    -1,
    1734,    -1,  1807,   386,    -1,    39,    -1,    41,    -1,    43,
      44,    45,    46,    47,    48,  1833,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,    -1,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   382,
      -1,    -1,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,    -1,   162,   163,
     164,    -1,    -1,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,    -1,    -1,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,    -1,   300,   301,    -1,    -1,
      -1,    -1,    -1,   307,    -1,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   335,   336,   337,    -1,    -1,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,   373,
       3,     4,     5,     6,     7,    -1,    -1,   381,    -1,   382,
      13,    14,    15,    -1,   388,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      53,    54,    55,    56,    57,    -1,    -1,    -1,    -1,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    49,    -1,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    49,    -1,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      49,    -1,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,   324,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,    -1,   362,
      -1,   364,   365,   366,   367,   382,   369,   370,   371,   372,
     373,    -1,   375,   376,   377,   378,    -1,    -1,    -1,    -1,
     383,   384,    -1,   386,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
     323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   382,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     373,    -1,    -1,    -1,   377,   378,    -1,    -1,   381,    -1,
      -1,   382,   385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   382,    -1,    -1,    -1,
      -1,    -1,   373,    -1,    -1,    -1,   377,   378,    -1,    -1,
     381,    -1,    -1,    -1,   385,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,    -1,   380,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   373,    -1,    -1,    -1,   377,   378,
      -1,    -1,   381,    -1,    -1,     1,   385,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    -1,    49,    -1,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    -1,
      -1,    67,    68,    69,    70,    71,    72,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    49,    -1,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    -1,    -1,    67,    68,    69,    70,    71,    72,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    -1,    49,    -1,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    -1,    -1,    67,    68,    69,    70,    71,
      72,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    49,
      -1,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      -1,    61,    62,    63,    -1,    -1,    -1,    67,    68,    69,
      70,    71,    72,    -1,    -1,    -1,    -1,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,   323,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    49,    -1,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    -1,    61,    62,    63,
      -1,    -1,    -1,    67,    68,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,    -1,
      -1,   377,   378,    -1,    -1,   381,    -1,    -1,    -1,   385,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   380,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,    -1,    -1,   377,   378,    -1,    -1,   381,    -1,    -1,
      -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   323,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
      -1,   373,    -1,    -1,    -1,   377,   378,    -1,    -1,   381,
      -1,    -1,    -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   323,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,    -1,    -1,   377,   378,    -1,
      -1,   381,    -1,    -1,    -1,   385,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,    -1,    -1,   377,   378,    -1,    -1,   381,    -1,    -1,
       1,   385,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    49,    -1,
      51,    52,    53,    54,    55,    56,    57,    58,    -1,    -1,
      61,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      49,    -1,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    -1,    61,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    49,    -1,    51,    52,    53,    54,    55,    56,
      57,    58,    -1,    -1,    61,    62,    63,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    72,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    49,    -1,    51,    52,    53,    54,
      55,    56,    57,    58,    -1,    -1,    61,    62,    63,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,   323,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      49,    -1,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    -1,    61,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   373,    -1,    -1,    -1,   377,   378,    -1,    -1,
     381,    -1,    -1,    -1,   385,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   373,    -1,    -1,    -1,   377,   378,
      -1,    -1,   381,    -1,    -1,    -1,   385,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,    -1,    -1,
     377,   378,    -1,    -1,   381,    -1,    -1,    -1,   385,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,
      -1,    -1,   377,   378,    -1,    -1,   381,    -1,    -1,    -1,
     385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   373,    -1,    -1,    -1,   377,   378,
      -1,    -1,   381,    -1,    -1,     1,   385,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    -1,    49,    -1,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    -1,    61,    62,    63,    -1,    -1,
      -1,    67,    68,    69,    70,    71,    72,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    49,    -1,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    -1,    61,    62,    63,
      -1,    -1,    -1,    67,    68,    69,    70,    71,    72,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    -1,    49,    -1,    51,
      52,    53,    54,    55,    56,    57,    58,    -1,    -1,    61,
      62,    63,    -1,    -1,    -1,    67,    68,    69,    70,    71,
      72,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    49,
      -1,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      -1,    61,    62,    63,    -1,    -1,    -1,    67,    68,    69,
      70,    71,    72,    -1,    -1,    -1,    -1,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,   323,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    49,    -1,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    -1,    61,    62,    63,
      -1,    -1,    -1,    67,    68,    69,    70,    71,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,    -1,    -1,
      -1,   377,   378,    -1,    -1,   381,    -1,    -1,    -1,   385,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,    -1,    -1,   377,   378,    -1,    -1,   381,    -1,    -1,
      -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   373,    -1,    -1,    -1,   377,   378,    -1,    -1,   381,
      -1,    -1,    -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   323,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   373,    -1,    -1,    -1,   377,   378,    -1,
      -1,   381,    -1,    -1,    -1,   385,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   373,
      -1,    -1,    -1,   377,   378,    -1,    -1,   381,    -1,    -1,
       1,   385,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    49,    -1,
      51,    52,    53,    54,    55,    56,    57,    58,    -1,    -1,
      61,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      53,    54,    55,    56,    57,    -1,    -1,    -1,    -1,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    53,    54,    55,    56,
      57,    -1,   323,    -1,    -1,    62,    63,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   373,    -1,    -1,    -1,   377,   378,    -1,    -1,
     381,    -1,    -1,    -1,   385,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,
     359,    -1,    -1,   362,    -1,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,    -1,   375,    -1,   377,   378,
      -1,    -1,    -1,    -1,   383,   384,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   358,   359,    -1,    -1,   362,
      -1,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,    -1,   377,   378,    -1,    -1,    -1,    -1,
     383,   384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   323,   324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   358,    -1,    -1,    -1,   362,    -1,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,    -1,   375,    -1,
     377,   378,    -1,    -1,    -1,   382,   383,   384,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      53,    54,    55,    56,    57,    -1,    -1,    -1,    -1,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      53,    54,    55,    56,    57,    -1,    -1,    -1,    -1,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      53,    54,    55,    56,    57,    -1,    -1,    -1,    -1,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,    -1,   362,
      -1,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,    -1,   377,   378,    -1,    -1,    -1,   382,
     383,   384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,    -1,   362,
      -1,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,    -1,   377,   378,    -1,    -1,    -1,   382,
     383,   384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   358,    -1,   360,    -1,   362,
      -1,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,    -1,   377,   378,    -1,    -1,    -1,    -1,
     383,   384,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,
      -1,    -1,    -1,   362,    -1,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,    -1,   375,    -1,   377,   378,
      -1,    -1,    -1,    -1,   383,   384,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,
      -1,    -1,    -1,   362,    -1,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,    -1,   375,    -1,   377,   378,
      -1,    -1,    -1,    -1,   383,   384,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,
      -1,    -1,    -1,   362,    -1,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,    -1,   375,    -1,   377,   378,
      -1,    -1,    -1,    -1,   383,   384,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    53,    54,
      55,    56,    57,    -1,    -1,    -1,    -1,    62,    63,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    53,    54,
      55,    56,    57,    -1,    -1,    -1,    -1,    62,    63,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    53,    54,
      55,    56,    57,    -1,    -1,    -1,    -1,    62,    63,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   358,    -1,    -1,    -1,   362,    -1,   364,
     365,   366,   367,    -1,   369,   370,   371,   372,   373,    -1,
     375,    -1,   377,   378,    -1,    -1,    -1,    -1,   383,   384,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   358,    -1,    -1,    -1,   362,    -1,   364,
     365,   366,   367,    -1,   369,   370,   371,   372,   373,    -1,
     375,    -1,   377,   378,    -1,    -1,    -1,    -1,   383,   384,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   358,    -1,    -1,    -1,   362,    -1,   364,
     365,   366,   367,    -1,   369,   370,   371,   372,   373,    -1,
     375,    -1,   377,   378,    -1,    -1,    -1,    -1,   383,   384,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    53,    54,    55,    56,    57,    -1,    -1,    -1,
      -1,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    53,    54,    55,    56,    57,    -1,    -1,    -1,
      -1,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    53,    54,    55,    56,    57,    -1,    -1,    -1,
      -1,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,
      -1,   362,    -1,   364,   365,   366,   367,    -1,   369,   370,
     371,   372,   373,    -1,   375,    -1,   377,   378,    -1,    -1,
      -1,    -1,   383,   384,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,
      -1,   362,    -1,   364,   365,   366,   367,    -1,   369,   370,
     371,   372,   373,    -1,   375,    -1,   377,   378,    -1,    -1,
      -1,    -1,   383,   384,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,
      -1,   362,    -1,   364,   365,   366,   367,    -1,   369,   370,
     371,   372,   373,    -1,   375,    -1,   377,   378,    -1,    -1,
      -1,    -1,   383,   384,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    53,    54,    55,    56,
      57,    -1,    -1,    -1,    -1,    62,    63,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    53,    54,    55,    56,
      57,    -1,    -1,    -1,    -1,    62,    63,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    53,    54,    55,    56,
      57,    -1,    -1,    -1,    -1,    62,    63,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   323,   324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   358,    -1,    -1,    -1,   362,    -1,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,    -1,   375,    -1,
     377,   378,    -1,    -1,    -1,    -1,   383,   384,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   323,   324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   358,    -1,    -1,    -1,   362,    -1,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,    -1,   375,    -1,
     377,   378,    -1,    -1,    -1,    -1,   383,   384,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   323,   324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   358,    -1,    -1,    -1,   362,    -1,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,    -1,   375,    -1,
     377,   378,    -1,    -1,    -1,    -1,   383,   384,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      53,    54,    55,    56,    57,    -1,    -1,    -1,    -1,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      53,    54,    55,    56,    57,    -1,    -1,    -1,    -1,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    51,    52,
      53,    54,    55,    56,    57,    -1,    -1,    -1,    -1,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,    -1,   362,
      -1,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,    -1,   377,   378,    -1,    -1,    -1,    -1,
     383,   384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,    -1,   362,
      -1,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,    -1,   377,   378,    -1,    -1,    -1,    -1,
     383,   384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,    -1,   362,
      -1,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,    -1,   375,    -1,   377,   378,    -1,    -1,    -1,    -1,
     383,   384,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,
      -1,    -1,    -1,   362,    -1,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,    -1,   375,    -1,   377,   378,
      -1,    -1,    -1,    -1,   383,   384,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,
      -1,    -1,    -1,   362,    -1,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,    -1,   375,    -1,   377,   378,
      -1,    -1,    -1,    -1,   383,   384,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,
      -1,    -1,    -1,   362,    -1,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,    -1,   375,    -1,   377,   378,
      -1,    -1,    -1,    -1,   383,   384,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    53,    54,
      55,    56,    57,    -1,    -1,    -1,    -1,    62,    63,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    53,    54,
      55,    56,    57,    -1,    -1,    -1,    -1,    62,    63,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    -1,    51,    52,    53,    54,
      55,    56,    57,    -1,    -1,    -1,    -1,    62,    63,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   358,    -1,    -1,    -1,   362,    -1,   364,
     365,   366,   367,    -1,   369,   370,   371,   372,   373,    -1,
     375,    -1,   377,   378,    -1,    -1,    -1,    -1,   383,   384,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   358,    -1,    -1,    -1,   362,    -1,   364,
     365,   366,   367,    -1,   369,   370,   371,   372,   373,    -1,
     375,    -1,   377,   378,    -1,    -1,    -1,    -1,   383,   384,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,   324,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   358,    -1,    -1,    -1,   362,    -1,   364,
     365,   366,   367,    -1,   369,   370,   371,   372,   373,    -1,
     375,    -1,   377,   378,    -1,    -1,    -1,    -1,   383,   384,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    53,    54,    55,    56,    57,    -1,    -1,    -1,
      -1,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    53,    54,    55,    56,    57,    -1,    -1,    -1,
      -1,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    53,    54,    55,    56,    57,    -1,    -1,    -1,
      -1,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,
      -1,   362,    -1,   364,   365,   366,   367,    -1,   369,   370,
     371,   372,   373,    -1,   375,    -1,   377,   378,    -1,    -1,
      -1,    -1,   383,   384,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,
      -1,   362,    -1,   364,   365,   366,   367,    -1,   369,   370,
     371,   372,   373,    -1,   375,    -1,   377,   378,    -1,    -1,
      -1,    -1,   383,   384,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,
      -1,   362,    -1,   364,   365,   366,   367,    -1,   369,   370,
     371,   372,   373,    -1,   375,    -1,   377,   378,    -1,    -1,
      -1,    -1,   383,   384,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    53,    54,    55,    56,
      57,    -1,    -1,    -1,    -1,    62,    63,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    53,    54,    55,    56,
      57,    -1,    -1,    -1,    -1,    62,    63,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   323,   324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   358,    -1,    -1,    -1,   362,    -1,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,    -1,   375,    -1,
     377,   378,    -1,    -1,    -1,    -1,   383,   384,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   323,   324,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   358,    -1,    -1,    -1,   362,    -1,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,    -1,   375,    -1,
     377,   378,    -1,    -1,    -1,    -1,   383,   384,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,
      -1,    -1,    -1,   362,    -1,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,    -1,   375,    -1,   377,   378,
      -1,    -1,    -1,    -1,   383,   384,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    51,    52,    53,    54,    55,    56,
      57,    -1,    -1,    -1,    -1,    62,    63,    -1,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    -1,    -1,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    53,    54,    55,    56,    57,    -1,    -1,    -1,
      -1,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    49,    -1,    51,    52,
      53,    54,    55,    56,    57,    58,   323,   324,    61,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   358,    -1,    -1,    -1,   362,    -1,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,    -1,   375,    -1,
     377,   378,    -1,    -1,    -1,    -1,   383,   384,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,   324,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,
      -1,    -1,    -1,   362,    -1,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,    -1,   375,    -1,   377,   378,
      -1,    -1,    -1,    -1,   383,   384,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,
      -1,   362,    -1,   364,   365,   366,   367,    -1,   369,   370,
     371,   372,   373,    -1,   375,    -1,   377,   378,    -1,    -1,
      -1,    -1,   383,   384,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     373,    -1,    -1,    -1,   377,   378,    -1,    -1,   381,    -1,
      -1,   384,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    52,    53,    54,    55,    56,    57,    -1,    -1,    -1,
      -1,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    49,    -1,    51,    52,
      53,    54,    55,    56,    57,    58,    -1,    -1,    61,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    49,    -1,
      51,    52,    53,    54,    55,    56,    57,    58,    -1,    -1,
      61,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    49,    -1,
      51,    52,    53,    54,    55,    56,    57,    58,    -1,    -1,
      61,    62,    63,    -1,    -1,    -1,    67,    68,    69,    70,
      71,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   358,    -1,    -1,
      -1,   362,    -1,   364,   365,   366,   367,    -1,   369,   370,
     371,   372,   373,    -1,   375,    -1,   377,   378,    -1,    -1,
      -1,    -1,   383,   384,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     373,    -1,    -1,    -1,   377,   378,    -1,    -1,   381,    -1,
      -1,   384,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   373,    -1,    -1,    -1,   377,   378,    -1,    -1,
     381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   373,    -1,    -1,    -1,   377,   378,    -1,    -1,
     381
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    11,    18,    19,    39,    41,    43,    44,    45,
      46,    47,    48,    60,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   162,   163,   164,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   300,   301,   307,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   335,   336,   337,   373,   381,   388,   391,
     392,   393,   394,   395,   396,   397,   398,   410,   414,   419,
     421,   423,   424,   434,   435,   444,   338,   338,     1,   386,
       1,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,     1,   338,     1,   338,     1,   338,     1,   338,     1,
     338,     1,   338,     1,   338,     1,   338,     1,   338,     1,
     338,     1,   338,     1,   338,     1,   338,     1,   338,     1,
     338,     1,   338,     1,   338,     1,   338,     1,   338,     1,
     338,     1,   338,     1,   338,     1,   338,     1,   338,     1,
     338,     1,   338,     1,   338,     1,   338,     1,   338,     1,
     338,     1,   338,     1,   338,     1,   338,     1,   338,     1,
     338,     1,   338,     1,   338,   338,   338,   338,   338,   420,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,     1,   375,   383,     1,   375,   383,     1,
     338,   375,     1,   383,     1,   383,     1,   338,   375,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,     1,
     338,     1,   338,     1,   338,     1,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,     1,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   368,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,     1,   373,
     375,   411,   412,   413,     1,   413,   415,   416,     1,   375,
       1,   375,     1,   375,     0,     1,   393,    15,    16,   430,
     431,    17,   432,   433,    20,   438,   439,    21,   440,   441,
      22,   442,   443,   368,   386,   384,     1,   372,   372,   373,
     375,   429,     1,   372,     1,   372,     1,   372,     1,    91,
      92,    93,    94,   359,   402,     1,   372,     1,   358,   372,
     409,     1,   372,     1,   372,     1,   409,     1,   372,     1,
     372,     1,   372,     1,   372,     1,   373,     1,   375,     1,
     372,     1,   375,     1,   372,     1,   375,     1,   375,     1,
     375,     1,   375,     1,   375,     1,   372,   373,   374,   375,
     376,   383,   386,   399,   401,   402,   407,   408,   425,   426,
     427,   428,   458,   459,     1,   408,     1,   372,     1,   408,
       1,   372,     1,   372,     1,   372,   372,   372,   372,   409,
     409,   409,   409,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   372,   372,   375,   372,   372,   372,   372,   372,   372,
     372,   372,   372,     1,   409,     1,   372,     1,   375,     1,
     372,   338,     1,   372,     1,   372,     1,   372,     1,   372,
       1,   375,     1,   372,     1,   372,     1,   409,     1,   409,
       1,   409,     1,   409,     1,   409,     1,   409,     1,   409,
       1,   409,     1,   409,     1,   409,     1,   409,     1,   372,
       1,   372,     1,   375,     1,   375,     1,   372,   375,   375,
       1,   375,   375,   375,     1,   375,     1,   372,     1,   372,
       1,   372,     1,   372,     1,   372,     1,   372,     1,   372,
       1,   372,     1,   373,   375,     1,   373,   375,     1,   373,
     375,     1,   373,   375,     1,   373,   375,     1,   372,     1,
     372,     1,   372,     1,   372,     1,   372,     1,   372,     1,
     409,     1,   409,     1,   409,     1,   373,   375,     1,   372,
       1,   372,     1,   372,     1,   372,   426,     1,   428,     1,
     372,     1,   372,   372,   372,   372,   372,     1,   372,     1,
     372,     1,   372,     1,   372,     1,   372,     1,   372,     1,
     372,     1,   372,     1,   372,     1,   372,     1,   372,     1,
     372,     1,   372,     1,   372,     1,   372,     1,   409,     1,
     409,     1,   372,     1,   372,     1,   372,     1,   372,     1,
     372,     1,   255,   256,   257,   258,     1,   372,     1,   372,
       1,   372,     1,   372,     1,   375,     1,   375,     1,   375,
       1,   372,     1,   372,     1,   372,     1,   399,     1,   372,
       1,   372,     1,   372,     1,   372,     1,   372,     1,   372,
       1,   372,     1,   372,     1,   372,     1,   372,     1,   372,
       1,   372,     1,   372,     1,   372,     1,   372,     1,   373,
     375,     1,   372,   373,   372,     1,   372,     1,   372,     1,
     372,     1,   372,     1,   372,     1,   372,     1,   372,     1,
     375,     1,   372,     1,   372,     1,   372,     1,   372,     1,
     372,     1,   372,   302,   303,   304,   305,   306,   308,     1,
     409,   372,   372,     1,   409,     1,   409,     1,   372,     1,
     372,     1,   372,     1,   372,     1,   372,     1,   372,     1,
     375,     1,   375,   380,   389,   380,     1,   386,     1,   384,
       1,   386,   384,     1,   386,   384,     1,   386,   384,     1,
     386,    60,   372,   373,   422,   372,   436,   387,   372,   368,
     399,   400,   427,   389,   389,   408,   113,   114,   115,   358,
     368,   384,   380,   382,   380,   382,   380,   380,   338,   338,
     338,   338,   338,   338,   411,   372,   415,   429,     3,     4,
       5,     6,     7,     8,     9,    10,    12,    13,    14,    15,
      23,    24,    25,    26,    27,    28,    29,    30,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    42,    44,    49,
      51,    52,    53,    54,    55,    56,    57,    58,    61,    62,
      63,    67,    68,    69,    70,    71,    72,   323,   373,   377,
     378,   381,   460,   462,   463,   464,   468,   469,   477,   478,
     480,   481,   484,   485,   487,   491,   492,   493,   497,   429,
     462,   429,   462,   429,   462,   379,   338,   387,   462,     1,
     437,   372,   380,   382,   387,     1,   359,   372,   405,   401,
      91,    92,    93,    94,    95,    96,   399,   404,   375,     1,
     372,   458,     1,   458,   113,   114,   115,   165,   166,   381,
     417,   418,   375,   375,   375,   375,     1,   375,     1,   375,
       1,   375,     1,   375,     1,   375,     1,   375,   387,     1,
     383,     1,   383,     1,   383,     1,   383,     1,   383,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,   324,   358,   362,
     364,   365,   366,   367,   369,   370,   371,   375,   383,   384,
     409,   450,   451,   452,   453,   454,   455,   460,   472,   477,
     478,   479,   480,   482,   484,   485,   488,   489,   490,   383,
     490,   383,   490,     1,   383,     1,   383,     1,   383,   383,
       1,   383,     1,   383,     1,   383,     1,   383,     1,   383,
       1,   383,     1,   383,     1,   383,   383,     1,   383,     1,
     383,     1,   383,     1,   383,   383,   383,   383,   383,   383,
     383,   490,     1,   383,     1,   383,     1,   383,   383,   383,
     383,   383,     1,   490,   490,     1,   383,     1,   383,     1,
     383,     1,   383,     1,   383,     1,   494,     1,   381,     1,
     385,   463,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   373,   474,   475,   476,   338,   486,   381,     1,   383,
     381,   387,   385,   387,   385,   387,   385,   387,     1,   372,
     375,   368,   385,   384,   368,   400,   389,   114,   115,   389,
     389,   114,   338,   338,   338,   338,   338,   385,   417,   382,
     382,   380,   380,   384,     1,    64,   373,   375,   382,   425,
     457,     1,    64,   375,   425,   457,     1,    64,   375,   425,
     457,     1,    64,   375,   425,   457,     1,    64,   375,   425,
     457,     1,   346,   347,   348,   351,   352,   445,   447,   445,
     445,     1,   445,   473,     1,   490,     1,   490,     1,   490,
     383,   383,   383,     1,   382,   478,   480,   484,   485,   490,
     491,     1,   462,     1,   447,     1,   353,   354,   355,   356,
     445,   446,     1,   447,   476,     1,   490,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     448,   449,   382,   382,     1,   372,   375,     1,   375,     1,
     373,   490,   375,     1,   375,     1,   375,     1,   375,     1,
     375,     1,   372,     1,   372,   382,     1,   382,   409,   382,
       1,   375,     1,   375,     1,   375,     1,   375,   382,   382,
     382,     1,   372,   382,     1,   402,   384,   461,   463,     1,
     399,     1,   372,     1,   399,   402,   406,   382,   382,   382,
     382,   384,   461,     1,   375,     1,   375,   372,   413,   372,
     413,   372,   413,   383,   368,   386,   490,     1,   375,   477,
     478,   483,   485,   384,   384,   384,   384,   299,   299,   422,
     462,   372,   405,   375,   372,   399,   399,   402,     1,   372,
       1,   375,     1,   399,   402,     1,   372,   375,   409,   375,
     377,   409,   462,   382,   380,   382,   380,   382,   380,   382,
     358,   368,   380,   382,   382,   380,   382,   380,   382,   380,
     382,   380,   382,   382,   380,   382,   380,   382,   380,   382,
     380,   382,   382,   380,   382,   380,   382,   380,   382,   380,
     382,   382,   380,   382,   380,   382,   380,   382,   380,   382,
       1,   373,   490,     1,    91,    92,    93,    94,    95,    96,
     359,   403,   490,     1,   403,   490,     1,   450,   454,   373,
     470,   471,     1,   490,     1,   490,     1,   490,   382,   382,
     382,   385,   385,     1,    89,   490,     1,   490,     1,   490,
       1,    89,   372,   373,   425,   456,   457,   490,   386,     1,
     490,     1,   490,     1,   490,     1,   490,   490,   490,   490,
       1,   490,     1,   490,     1,   490,     1,   490,     1,   490,
       1,   490,     1,   490,   382,   380,   382,   382,   380,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   462,
      50,   382,   382,   382,   382,   382,   389,   389,   382,     1,
      59,    60,   385,   466,   467,   382,   380,   382,   382,   382,
     382,   382,   382,   382,   382,   490,   495,   496,   475,   387,
     380,   382,   476,   380,   462,   462,   462,   462,   375,   375,
     338,   385,   368,   114,   114,   115,   389,   389,   389,   389,
     389,   382,   382,   382,   382,   382,   385,    65,   372,   372,
     372,     1,   373,     1,   373,   372,    65,   372,   372,   372,
     372,    65,   372,   372,   372,   372,    65,   372,   372,   372,
     372,    65,   372,   372,   372,   372,   386,   368,   382,   382,
     382,   382,   382,   380,   360,   409,   375,   375,   385,   461,
       1,   405,   399,   385,     1,   360,   465,   490,   389,   385,
     466,   372,   490,   380,   382,   413,     1,   413,   385,   385,
     385,   385,   372,   375,   372,   375,   372,   372,   399,   405,
     399,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   375,   409,   470,   490,
       1,   372,   425,   387,   382,   382,   389,   389,     1,   465,
     389,   462,   382,   382,   496,   382,   382,   382,   114,   115,
     389,   389,   387,   387,   380,   405,   462,   389,   389,     1,
     462,   375,   372,   405,   490,   462,   462,   114,   382
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   390,   391,   392,   392,   392,   393,   393,   393,   393,
     393,   394,   393,   395,   393,   393,   396,   393,   397,   393,
     398,   393,   393,   393,   399,   399,   399,   400,   400,   401,
     401,   402,   402,   402,   402,   402,   403,   403,   403,   403,
     403,   403,   403,   404,   404,   404,   404,   404,   404,   405,
     405,   406,   406,   406,   406,   406,   407,   407,   407,   407,
     407,   408,   408,   409,   409,   410,   410,   411,   411,   412,
     412,   413,   413,   414,   414,   415,   415,   416,   417,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   417,   417,
     417,   417,   418,   418,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   420,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   419,
     419,   419,   419,   419,   419,   419,   419,   419,   419,   421,
     421,   422,   422,   422,   423,   423,   423,   423,   423,   423,
     423,   424,   424,   424,   424,   424,   424,   424,   424,   424,
     424,   424,   424,   424,   424,   424,   424,   424,   424,   424,
     424,   424,   424,   424,   425,   425,   426,   427,   428,   428,
     429,   429,   429,   430,   430,   431,   431,   431,   431,   432,
     433,   433,   433,   434,   434,   436,   435,   435,   435,   437,
     435,   435,   438,   439,   439,   439,   440,   441,   441,   441,
     442,   443,   443,   444,   444,   444,   444,   444,   444,   445,
     445,   445,   445,   446,   446,   446,   446,   447,   447,   448,
     448,   448,   448,   448,   448,   448,   449,   449,   449,   449,
     450,   450,   450,   451,   451,   451,   452,   452,   452,   452,
     452,   453,   453,   454,   454,   454,   455,   455,   455,   455,
     455,   455,   455,   455,   455,   455,   455,   455,   455,   455,
     455,   455,   455,   455,   455,   455,   455,   455,   455,   455,
     455,   455,   455,   455,   455,   456,   456,   456,   456,   457,
     457,   457,   457,   457,   458,   458,   458,   459,   459,   459,
     459,   459,   460,   461,   461,   462,   462,   462,   463,   463,
     463,   463,   463,   463,   463,   463,   464,   464,   465,   466,
     466,   466,   466,   466,   466,   466,   466,   466,   466,   466,
     467,   467,   468,   468,   468,   468,   469,   470,   470,   470,
     471,   471,   473,   472,   474,   474,   474,   474,   474,   474,
     474,   474,   474,   475,   476,   476,   477,   478,   479,   480,
     481,   481,   482,   482,   482,   483,   483,   483,   484,   485,
     486,   487,   487,   487,   488,   488,   488,   488,   488,   488,
     488,   488,   488,   488,   488,   488,   489,   489,   489,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     491,   492,   492,   492,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   493,   493,   493,   493,   493,   494,
     493,   493,   495,   495,   495,   496,   497,   497,   497,   497,
     497,   497,   497,   497,   497,   497
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     1,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     5,     3,     1,     3,     3,     5,
       3,     1,     2,     1,     2,     2,     2,     1,     3,     1,
       3,     1,     1,     2,     2,     1,     3,     1,     7,     5,
       5,     3,     3,     3,     3,     5,     7,     3,     3,     3,
       3,     1,     2,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     0,     6,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     5,
       6,     7,     9,     8,     9,    11,    10,    12,     5,     6,
       7,     8,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     5,
       5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
       5,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     1,     2,     1,
       1,     1,     1,     1,     5,     5,     7,     7,     5,     8,
       8,     2,     4,     6,     2,     2,     4,     6,     2,     2,
       2,     3,     3,     8,     8,     2,     8,     8,     8,     2,
       2,     2,     3,     3,     1,     1,     7,     1,     1,     3,
       1,     1,     1,     1,     1,     4,     7,     2,     2,     1,
       4,     7,     2,     1,     1,     0,     5,     2,     2,     0,
       8,     5,     1,     4,     7,     2,     1,     4,     7,     2,
       1,     7,     2,     2,     2,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     2,
       3,     3,     3,     2,     3,     3,     3,     3,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     3,     3,     2,     3,     3,     1,     3,     1,
       3,     3,     3,     3,     1,     1,     1,     1,     3,     3,
       3,     3,     1,     1,     3,     2,     1,     2,     2,     1,
       1,     1,     2,     2,     1,     2,     3,     5,     1,     4,
       5,     3,     4,     3,     2,     4,     5,     3,     4,     4,
       2,     1,     5,     4,     2,     5,     3,     1,     4,     4,
       3,     1,     0,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     2,     5,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     1,     1,     1,     1,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     4,
       2,     8,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     4,     4,     2,
       3,     1,     1,     1,     3,     4,     4,     4,     6,     6,
       6,     6,     6,     4,     2,     4,     4,     4,     4,     6,
       6,     6,     6,     6,     4,     2,     4,     4,     4,     4,
       6,     6,     6,     6,     6,     4,     2,     4,     4,     4,
       4,     6,     6,     6,     6,     6,     4,     2,     4,     4,
       4,     4,     6,     6,     6,     6,     6,     4,     2,     4,
       4,     6,     2,     4,     4,     4,     2,     4,     4,     2,
       4,     4,     2,     6,     6,     6,     4,     2,     6,     2,
       4,     4,     4,     2,     4,     4,     4,     2,     4,     4,
       2,     4,     4,     2,     4,     4,     2,     4,     3,     2,
       4,     3,     2,     4,     3,     4,     2,     4,     4,     2,
       4,     4,     2,     4,     4,     2,     4,     4,     2,     4,
       4,     2,     4,     3,     1,     3,     1,     3,     1,     4,
       3,     1,     4,     4,     4,     4,     4,     2,     4,     4,
       2,     4,     4,     2,     3,     1,     3,     1,     3,     1,
       3,     1,     6,     6,     2,     4,     4,     2,     4,     0,
       5,     2,     0,     3,     1,     1,     3,     2,     1,     3,
       2,     1,     1,     3,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 671 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5468 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 672 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5474 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 673 "core/cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 5480 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 681 "core/cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 5486 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 682 "core/cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 5492 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 684 "core/cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 5498 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 685 "core/cfg.y" /* yacc.c:1646  */
    {rt=ONSEND_ROUTE;}
#line 5504 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 686 "core/cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 5510 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 691 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].ipaddr)){
			tmp=ip_addr2a((yyvsp[0].ipaddr));
			if (tmp==0) {
				LM_CRIT("cfg. parser: bad ip address.\n");
				(yyval.strval)=0;
			} else {
				i_tmp=strlen(tmp)+1;
				(yyval.strval)=pkg_malloc(i_tmp);
				if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
				} else {
					strncpy((yyval.strval), tmp, i_tmp);
				}
			}
		}
	}
#line 5532 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 708 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
		if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
		} else {
				i_tmp=strlen((yyvsp[0].strval))+1;
				strncpy((yyval.strval), (yyvsp[0].strval), i_tmp);
		}
	}
#line 5546 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 717 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
			} else {
					i_tmp=strlen((yyvsp[0].strval))+1;
					strncpy((yyval.strval), (yyvsp[0].strval), i_tmp);
			}
		}
	}
#line 5562 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 732 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), SI_IS_MHOMED); }
#line 5568 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 733 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[-2].strval), SI_IS_MHOMED);
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[0].name_l);
									}
#line 5576 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 739 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=(yyvsp[-1].name_l); }
#line 5582 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 740 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), 0); }
#line 5588 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 744 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5594 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 745 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5600 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 746 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5606 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 747 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5612 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 748 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5618 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 751 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5624 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 752 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5630 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 753 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5636 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 754 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5642 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 755 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WS; }
#line 5648 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 756 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WSS; }
#line 5654 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 757 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5660 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 760 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5666 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 761 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5672 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 762 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5678 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 763 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5684 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 764 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WS; }
#line 5690 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 765 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WSS; }
#line 5696 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 769 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 5702 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 770 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5708 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 773 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), 0, 0); }
#line 5714 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 774 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), 0, (yyvsp[0].intval)); }
#line 5720 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 775 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 5726 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 776 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5732 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 777 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5738 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 781 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), 0, 0); }
#line 5744 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 782 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), 0, (yyvsp[0].intval)); }
#line 5750 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 783 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), (yyvsp[-2].intval), 0); }
#line 5756 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 784 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5762 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 785 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5768 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 789 "core/cfg.y" /* yacc.c:1646  */
    {  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 5774 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 790 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[-1].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 5780 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 794 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 5786 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 798 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("flag list expected\n"); }
#line 5792 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 804 "core/cfg.y" /* yacc.c:1646  */
    { if (register_flag((yyvsp[0].strval),-1)<0)
								yyerror("register flag failed");
						}
#line 5800 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 807 "core/cfg.y" /* yacc.c:1646  */
    {
						if (register_flag((yyvsp[-2].strval), (yyvsp[0].intval))<0)
								yyerror("register flag failed");
										}
#line 5809 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 813 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5815 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 814 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5821 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 819 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("avpflag list expected\n"); }
#line 5827 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 826 "core/cfg.y" /* yacc.c:1646  */
    {
		if (register_avpflag((yyvsp[0].strval))==0)
			yyerror("cannot declare avpflag");
	}
#line 5836 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 832 "core/cfg.y" /* yacc.c:1646  */
    {
			tmp_sa.bindproto = (yyvsp[-4].intval);
			tmp_sa.bindaddr.s = (yyvsp[-2].strval);
			tmp_sa.bindaddr.len = strlen(tmp_sa.bindaddr.s);
			tmp_sa.bindport = (yyvsp[0].intval);
		}
#line 5847 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 838 "core/cfg.y" /* yacc.c:1646  */
    {
			tmp_sa.bindaddr.s = (yyvsp[-2].strval);
			tmp_sa.bindaddr.len = strlen(tmp_sa.bindaddr.s);
			tmp_sa.bindport = (yyvsp[0].intval);
		}
#line 5857 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 843 "core/cfg.y" /* yacc.c:1646  */
    {
			tmp_sa.bindproto = (yyvsp[-2].intval);
			tmp_sa.bindaddr.s = (yyvsp[0].strval);
			tmp_sa.bindaddr.len = strlen(tmp_sa.bindaddr.s);
		}
#line 5867 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 848 "core/cfg.y" /* yacc.c:1646  */
    {
			tmp_sa.bindaddr.s = (yyvsp[0].strval);
			tmp_sa.bindaddr.len = strlen(tmp_sa.bindaddr.s);
		}
#line 5876 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 852 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5882 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 853 "core/cfg.y" /* yacc.c:1646  */
    {
			tmp_sa.sockname.s = (yyvsp[0].strval);
			tmp_sa.sockname.len = strlen(tmp_sa.sockname.s);
		}
#line 5891 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 857 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5897 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 858 "core/cfg.y" /* yacc.c:1646  */
    {
			tmp_sa.useaddr.s = (yyvsp[-2].strval);
			tmp_sa.useaddr.len = strlen(tmp_sa.useaddr.s);
			tmp_sa.useport = (yyvsp[0].intval);
		}
#line 5907 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 863 "core/cfg.y" /* yacc.c:1646  */
    {
			tmp_sa.useproto = (yyvsp[-4].intval);
			tmp_sa.useaddr.s = (yyvsp[-2].strval);
			tmp_sa.useaddr.len = strlen(tmp_sa.useaddr.s);
			tmp_sa.useport = (yyvsp[0].intval);
		}
#line 5918 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 869 "core/cfg.y" /* yacc.c:1646  */
    { tmp_sa.workers=(yyvsp[0].intval); }
#line 5924 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 870 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5930 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 871 "core/cfg.y" /* yacc.c:1646  */
    { if((yyvsp[0].intval)!=0) { tmp_sa.sflags |= SI_IS_VIRTUAL; } }
#line 5936 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 872 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5942 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 873 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5948 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 876 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5954 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 877 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5960 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 880 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.debug=(yyvsp[0].intval); }
#line 5966 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 881 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 5972 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 882 "core/cfg.y" /* yacc.c:1646  */
    { dont_fork= ! (yyvsp[0].intval); }
#line 5978 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 883 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5984 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 884 "core/cfg.y" /* yacc.c:1646  */
    { set_fork_delay((yyvsp[0].intval)); }
#line 5990 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 885 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5996 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 886 "core/cfg.y" /* yacc.c:1646  */
    { set_modinit_delay((yyvsp[0].intval)); }
#line 6002 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 887 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6008 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 888 "core/cfg.y" /* yacc.c:1646  */
    { if (!config_check)  /* if set from cmd line, don't overwrite from yyparse()*/
					if(log_stderr == 0) log_stderr=(yyvsp[0].intval);
				   }
#line 6016 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 891 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6022 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 892 "core/cfg.y" /* yacc.c:1646  */
    {
		if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	}
#line 6033 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 898 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 6039 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 899 "core/cfg.y" /* yacc.c:1646  */
    { log_name=(yyvsp[0].strval); }
#line 6045 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 900 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6051 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 901 "core/cfg.y" /* yacc.c:1646  */
    { log_color=(yyvsp[0].intval); }
#line 6057 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 902 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6063 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 903 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_fmt=(yyvsp[0].strval); }
#line 6069 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 904 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6075 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 905 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_mode=(yyvsp[0].intval); }
#line 6081 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 906 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6087 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 907 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_type=(yyvsp[0].strval); }
#line 6093 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 908 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6099 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 909 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_data=(yyvsp[0].strval); }
#line 6105 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 910 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6111 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 911 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_params.len=strlen((yyvsp[0].strval));
		}
#line 6119 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 914 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6125 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 915 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_fields.s=(yyvsp[0].strval);
			_ksr_xavp_via_fields.len=strlen((yyvsp[0].strval));
		}
#line 6133 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 918 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6139 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 919 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_reply_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_reply_params.len=strlen((yyvsp[0].strval));
		}
#line 6147 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 922 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6153 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 923 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 6159 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 924 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6165 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 925 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 6171 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 926 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6177 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 927 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_try_ipv6=(yyvsp[0].intval); }
#line 6183 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 928 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6189 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 929 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[0].intval)); }
#line 6195 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 930 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6201 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 931 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[0].intval)); }
#line 6207 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 932 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6213 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 933 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[0].intval));}
#line 6219 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 934 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6225 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 935 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[0].intval));}
#line 6231 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 936 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6237 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 937 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[0].intval));}
#line 6243 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 938 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6249 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 939 "core/cfg.y" /* yacc.c:1646  */
    {
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[0].intval)); }
#line 6256 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 941 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6262 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 942 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_time=(yyvsp[0].intval); }
#line 6268 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 943 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6274 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 944 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_slow_query_ms=(yyvsp[0].intval); }
#line 6280 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 945 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6286 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 946 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_no=(yyvsp[0].intval); }
#line 6292 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 947 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6298 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 948 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_servers_no=(yyvsp[0].intval); }
#line 6304 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 949 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6310 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 950 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_list=(yyvsp[0].intval); }
#line 6316 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 951 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6322 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 952 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_fmatch=(yyvsp[0].intval); }
#line 6328 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 953 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6334 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 954 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_naptr_ignore_rfc=(yyvsp[0].intval); }
#line 6340 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 955 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6346 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 956 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_cache_init=(yyvsp[0].intval)); }
#line 6352 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 957 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6358 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 958 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[0].intval)); }
#line 6364 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 959 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6370 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 960 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[0].intval));}
#line 6376 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 961 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6382 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 962 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[0].intval)); }
#line 6388 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 963 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6394 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 964 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[0].intval)); }
#line 6400 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 965 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6406 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 966 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[0].intval)); }
#line 6412 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 967 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6418 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 968 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[0].intval)); }
#line 6424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 969 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6430 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 970 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[0].intval)); }
#line 6436 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 971 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6442 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 972 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_timer_interval=(yyvsp[0].intval)); }
#line 6448 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 973 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6454 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 974 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[0].intval)); }
#line 6460 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 975 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6466 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 976 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_rec_pref=(yyvsp[0].intval)); }
#line 6472 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 977 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6478 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 978 "core/cfg.y" /* yacc.c:1646  */
    {IF_AUTO_BIND_IPV6(auto_bind_ipv6 = (yyvsp[0].intval));}
#line 6484 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 979 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6490 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 980 "core/cfg.y" /* yacc.c:1646  */
    {
		ksr_ipv6_hex_style.s = (yyvsp[0].strval);
		if(ksr_ipv6_hex_style.s[0]!='a' && ksr_ipv6_hex_style.s[0]!='A'
				&& ksr_ipv6_hex_style.s[0]!='c') {
			yyerror("expected \"a\", \"A\" or \"c\" value");
		}
		ksr_ipv6_hex_style.len = strlen(ksr_ipv6_hex_style.s);
	}
#line 6503 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 988 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6509 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 989 "core/cfg.y" /* yacc.c:1646  */
    {sr_bind_ipv6_link_local = (yyvsp[0].intval);}
#line 6515 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 990 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6521 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 991 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLOCKLIST(dst_blocklist_init=(yyvsp[0].intval)); }
#line 6527 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 992 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6533 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 993 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.use_dst_blocklist=(yyvsp[0].intval));
	}
#line 6541 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 996 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6547 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 997 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_max_mem=(yyvsp[0].intval));
	}
#line 6555 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1000 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6561 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1001 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_timeout=(yyvsp[0].intval));
	}
#line 6569 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1004 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6575 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1005 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLOCKLIST(blst_timer_interval=(yyvsp[0].intval));}
#line 6581 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1006 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6587 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1007 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_udp_imask=(yyvsp[0].intval));
	}
#line 6595 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1010 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6601 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1011 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_tcp_imask=(yyvsp[0].intval));
	}
#line 6609 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1014 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6615 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1015 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_tls_imask=(yyvsp[0].intval));
	}
#line 6623 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1018 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6629 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1019 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_sctp_imask=(yyvsp[0].intval));
	}
#line 6637 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1022 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6643 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1023 "core/cfg.y" /* yacc.c:1646  */
    { _sr_ip_free_bind=(yyvsp[0].intval); }
#line 6649 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1024 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6655 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1025 "core/cfg.y" /* yacc.c:1646  */
    { port_no=(yyvsp[0].intval); }
#line 6661 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1026 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6667 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1027 "core/cfg.y" /* yacc.c:1646  */
    { maxbuffer=(yyvsp[0].intval); }
#line 6673 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1028 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6679 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1029 "core/cfg.y" /* yacc.c:1646  */
    { maxsndbuffer=(yyvsp[0].intval); }
#line 6685 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1030 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6691 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1031 "core/cfg.y" /* yacc.c:1646  */
    { sql_buffer_size=(yyvsp[0].intval); }
#line 6697 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1032 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6703 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1033 "core/cfg.y" /* yacc.c:1646  */
    { ksr_msg_recv_max_size=(yyvsp[0].intval); }
#line 6709 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1034 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6715 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1035 "core/cfg.y" /* yacc.c:1646  */
    { ksr_tcp_msg_read_timeout=(yyvsp[0].intval); }
#line 6721 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1036 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6727 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1037 "core/cfg.y" /* yacc.c:1646  */
    { ksr_tcp_msg_data_timeout=(yyvsp[0].intval); }
#line 6733 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1038 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6739 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1039 "core/cfg.y" /* yacc.c:1646  */
    { ksr_tcp_accept_iplimit=(yyvsp[0].intval); }
#line 6745 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1040 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6751 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1041 "core/cfg.y" /* yacc.c:1646  */
    { ksr_tcp_check_timer=(yyvsp[0].intval); }
#line 6757 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1042 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6763 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1043 "core/cfg.y" /* yacc.c:1646  */
    { children_no=(yyvsp[0].intval); }
#line 6769 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1044 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6775 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1045 "core/cfg.y" /* yacc.c:1646  */
    { ksr_stats_namesep=(yyvsp[0].strval); }
#line 6781 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1046 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6787 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1047 "core/cfg.y" /* yacc.c:1646  */
    {
				memset(&tmp_sa, 0, sizeof(socket_attrs_t));
			}
#line 6795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1049 "core/cfg.y" /* yacc.c:1646  */
    {
				if(add_listen_socket(&tmp_sa)<0) {
					LM_ERR("failed to add listen socket\n");
					yyerror("failed to add listen socket");
					ksr_exit(-1);
				}
	}
#line 6807 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1056 "core/cfg.y" /* yacc.c:1646  */
    { socket_workers=(yyvsp[0].intval); }
#line 6813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1057 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6819 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1058 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_workers((yyvsp[0].intval)); }
#line 6825 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1059 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6831 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1060 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_usleep((yyvsp[0].intval)); }
#line 6837 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1061 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6843 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1062 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_nonblock((yyvsp[0].intval)); }
#line 6849 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1063 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6855 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1064 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_workers_group((yyvsp[0].strval)); }
#line 6861 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1065 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 6867 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1066 "core/cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 6873 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1067 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6879 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1068 "core/cfg.y" /* yacc.c:1646  */
    { phone2tel=(yyvsp[0].intval); }
#line 6885 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1069 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6891 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1070 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memlog=(yyvsp[0].intval); }
#line 6897 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1071 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6903 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1072 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memdbg=(yyvsp[0].intval); }
#line 6909 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1073 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6915 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1074 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_summary=(yyvsp[0].intval); }
#line 6921 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1075 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6927 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1076 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_safety=(yyvsp[0].intval); }
#line 6933 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1077 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6939 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1078 "core/cfg.y" /* yacc.c:1646  */
    { ksr_mem_add_size=(yyvsp[0].intval); }
#line 6945 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1079 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6951 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1080 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_join=(yyvsp[0].intval); }
#line 6957 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1081 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6963 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1082 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_status_mode=(yyvsp[0].intval); }
#line 6969 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1083 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6975 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1084 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.sip_parser_log_oneline=(yyvsp[0].intval); }
#line 6981 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1085 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6987 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1086 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.sip_parser_log=(yyvsp[0].intval); }
#line 6993 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1087 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6999 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1088 "core/cfg.y" /* yacc.c:1646  */
    { ksr_sip_parser_mode=(yyvsp[0].intval); }
#line 7005 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1089 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 7011 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1090 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.corelog=(yyvsp[0].intval); }
#line 7017 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1091 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 7023 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1092 "core/cfg.y" /* yacc.c:1646  */
    { sip_warning=(yyvsp[0].intval); }
#line 7029 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1093 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7035 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1094 "core/cfg.y" /* yacc.c:1646  */
    { version_table.s=(yyvsp[0].strval);
			version_table.len=strlen(version_table.s);
	}
#line 7043 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1097 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7049 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1098 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 7061 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1105 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 7073 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1112 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7079 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1113 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 7085 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1114 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 7091 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1115 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7097 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1116 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 7103 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1117 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 7109 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1118 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7115 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1119 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 7121 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1120 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 7127 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1121 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7133 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1122 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 7139 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1123 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 7145 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1124 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7151 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1125 "core/cfg.y" /* yacc.c:1646  */
    { mhomed=(yyvsp[0].intval); }
#line 7157 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1126 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7163 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1127 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7175 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1134 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7181 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1135 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7193 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1142 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7199 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1143 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_accept_unique=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7211 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1150 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7217 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1151 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_connection_match=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1158 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1159 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_cfg_children_no=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7247 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1166 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1167 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1174 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7271 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1175 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1182 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1183 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if ((yyvsp[0].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7304 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1193 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7310 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1194 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7329 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1208 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7348 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1222 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 7354 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1223 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7366 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1230 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7372 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1231 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_max_connections=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7384 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1238 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7390 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1239 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7402 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1246 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7408 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1247 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 7422 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1256 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv4 address expected"); }
#line 7428 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1257 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
				if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 7442 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1266 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv6 address expected"); }
#line 7448 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1267 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7460 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1274 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7466 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1275 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7478 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1282 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7484 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1283 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7496 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1290 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7502 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1291 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7514 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1298 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7520 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1299 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7532 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1306 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7538 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1307 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7550 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1314 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7556 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1315 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7568 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1322 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7574 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1323 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7586 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1330 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7592 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1331 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7604 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1338 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7610 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1339 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7622 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1346 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7628 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1347 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7640 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1354 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected");}
#line 7646 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1355 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7658 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1362 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1363 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7676 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1370 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7682 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1371 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7694 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1378 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7700 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1379 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7712 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1386 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7718 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1387 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_no_cl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7730 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1394 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7736 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1395 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_hep3=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7748 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1402 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7754 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1403 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_haproxy=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7766 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1410 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7772 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1411 "core/cfg.y" /* yacc.c:1646  */
    {
         #ifdef USE_TCP
             tcp_default_cfg.close_rst=(yyvsp[0].intval);
         #else
             warn("tcp support not compiled in");
         #endif
     }
#line 7784 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1418 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7790 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1420 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_set_clone_rcvbuf((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7802 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1427 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7808 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1428 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
		#ifdef SO_REUSEPORT
			tcp_default_cfg.reuse_port=(yyvsp[0].intval);
		#else
			warn("support for SO_REUSEPORT not compiled in");
		#endif
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7824 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1439 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7830 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1440 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.wait_data_ms=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7842 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1447 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7848 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1448 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_script_mode=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7860 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1455 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7866 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1456 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7878 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1463 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7884 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1464 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[0].intval));
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7896 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1471 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7902 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1472 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			ksr_tls_threads_mode = (yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7914 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1479 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 7920 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1480 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_log=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7932 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1487 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 7938 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1488 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7950 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1495 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7956 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1496 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7968 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1503 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7980 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1510 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7992 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1517 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 8004 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1524 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 8016 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1531 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 8028 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1538 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8034 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1539 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[0].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	}
#line 8046 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1546 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8052 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1547 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 8064 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1554 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 8070 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1555 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 8082 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1562 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 8088 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1563 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 8100 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1570 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 8106 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1571 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 8118 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1578 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8124 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1579 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 8136 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1586 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8142 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1587 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 8154 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1594 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8160 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1595 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[0].intval)<=1)?!(yyvsp[0].intval):(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 8172 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1602 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean or number expected"); }
#line 8178 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1603 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 8190 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1610 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8196 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1611 "core/cfg.y" /* yacc.c:1646  */
    { server_signature=(yyvsp[0].intval); }
#line 8202 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1612 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8208 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1613 "core/cfg.y" /* yacc.c:1646  */
    { server_hdr.s=(yyvsp[0].strval);
			server_hdr.len=strlen(server_hdr.s);
	}
#line 8216 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1616 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 8222 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1617 "core/cfg.y" /* yacc.c:1646  */
    { user_agent_hdr.s=(yyvsp[0].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	}
#line 8230 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1620 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 8236 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1621 "core/cfg.y" /* yacc.c:1646  */
    { _sr_uri_host_extra_chars=(yyvsp[0].strval); }
#line 8242 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1622 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 8248 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1623 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_hname_extra_chars=(unsigned char*)(yyvsp[0].strval); }
#line 8254 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1624 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 8260 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1625 "core/cfg.y" /* yacc.c:1646  */
    { reply_to_via=(yyvsp[0].intval); }
#line 8266 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1626 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8272 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1627 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 8289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1639 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-1].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_iface(   lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-1].sockid));
        }
#line 8307 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1652 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 8324 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1664 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-3].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
                        lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto, (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-3].sockid));
        }
#line 8342 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1677 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									PROTO_NONE, (yyvsp[-2].strval), (yyvsp[0].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 8360 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1690 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-6].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-4].intval), (yyvsp[-2].strval), (yyvsp[0].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-6].sockid));
	}
#line 8378 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 1703 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-5].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface( lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        PROTO_NONE, (yyvsp[-3].strval), (yyvsp[-1].intval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-5].sockid));
        }
#line 8397 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1717 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-6].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									PROTO_NONE, (yyvsp[-4].strval), (yyvsp[-2].intval), (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-6].sockid));
	}
#line 8415 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1730 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-8].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-6].intval), (yyvsp[-4].strval), (yyvsp[-2].intval), (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-8].sockid));
	}
#line 8433 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1743 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-7].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        PROTO_NONE, (yyvsp[-5].strval), (yyvsp[-3].intval), (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-7].sockid));
        }
#line 8452 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1757 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-9].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-7].intval), (yyvsp[-5].strval), (yyvsp[-3].intval), (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-9].sockid));
        }
#line 8471 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1771 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									PROTO_NONE, (yyvsp[0].strval), 0,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 8489 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1784 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-3].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface( lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        PROTO_NONE, (yyvsp[-1].strval), 0,
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-3].sockid));
        }
#line 8508 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1798 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									PROTO_NONE, (yyvsp[-2].strval), 0, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 8526 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1811 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-5].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        PROTO_NONE, (yyvsp[-3].strval), 0, (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-5].sockid));
        }
#line 8545 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1825 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ip address, interface name or"
									" hostname expected"); }
#line 8552 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1827 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 8568 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1838 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected"); }
#line 8574 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1839 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 8590 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1850 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected"); }
#line 8596 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1851 "core/cfg.y" /* yacc.c:1646  */
    { sr_auto_aliases=(yyvsp[0].intval); }
#line 8602 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1852 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8608 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 1853 "core/cfg.y" /* yacc.c:1646  */
    { sr_auto_aliases=(yyvsp[0].intval); }
#line 8614 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1854 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8620 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 1855 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			default_global_address.s=(yyvsp[0].strval);
			default_global_address.len=strlen((yyvsp[0].strval));
		}
	}
#line 8631 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 1861 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 8637 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 1862 "core/cfg.y" /* yacc.c:1646  */
    {
		tmp=int2str((yyvsp[0].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			PKG_MEM_CRITICAL;
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	}
#line 8652 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 1872 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 8658 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 1873 "core/cfg.y" /* yacc.c:1646  */
    { disable_core_dump=(yyvsp[0].intval); }
#line 8664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 1874 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8670 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 1875 "core/cfg.y" /* yacc.c:1646  */
    { open_files_limit=(yyvsp[0].intval); }
#line 8676 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 1876 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8682 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 1877 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized()) {
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		} else if (shm_mem_size == 0 || shm_mem_size == SHM_MEM_POOL_SIZE) {
			/* safety check for upper limit of 16TB */
			if((yyvsp[0].intval) <= 0 || (yyvsp[0].intval) > 16L * 1024 * 1024) {
				LM_ERR("out of limits shmem size number: %ld\n", (long int)(yyvsp[0].intval));
				yyerror("invalid config option");
				YYABORT;
			}
			shm_mem_size=(yyvsp[0].intval) * 1024 * 1024;
		}
	}
#line 8701 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 1891 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8707 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 1892 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[0].intval);
	}
#line 8719 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 1899 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8725 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 1900 "core/cfg.y" /* yacc.c:1646  */
    { mlock_pages=(yyvsp[0].intval); }
#line 8731 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1901 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8737 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1902 "core/cfg.y" /* yacc.c:1646  */
    { real_time=(yyvsp[0].intval); }
#line 8743 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 1903 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8749 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 1904 "core/cfg.y" /* yacc.c:1646  */
    { rt_prio=(yyvsp[0].intval); }
#line 8755 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 1905 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8761 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 1906 "core/cfg.y" /* yacc.c:1646  */
    { rt_policy=(yyvsp[0].intval); }
#line 8767 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 1907 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8773 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 1908 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_prio=(yyvsp[0].intval); }
#line 8779 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 1909 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8785 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 1910 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_policy=(yyvsp[0].intval); }
#line 8791 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 1911 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8797 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1912 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_prio=(yyvsp[0].intval); }
#line 8803 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 1913 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8809 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 1914 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_policy=(yyvsp[0].intval); }
#line 8815 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 1915 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8821 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 1916 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8833 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 1923 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8839 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 1924 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8851 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1931 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8857 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 1932 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8869 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 1939 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8881 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1946 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8887 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1947 "core/cfg.y" /* yacc.c:1646  */
    { tos=(yyvsp[0].intval); }
#line 8893 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 1948 "core/cfg.y" /* yacc.c:1646  */
    { if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
			tos=IPTOS_LOWDELAY;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
			tos=IPTOS_THROUGHPUT;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
			tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
			tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
			tos=IPTOS_LOWCOST;
#endif
		} else {
			yyerror("invalid tos value - allowed: "
				"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
				"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
				",IPTOS_LOWCOST"
#endif
#if !defined(IPTOS_MINCOST)
				",IPTOS_MINCOST"
#endif
				"\n");
		}
	}
#line 8925 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 1975 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8931 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 1976 "core/cfg.y" /* yacc.c:1646  */
    { pmtu_discovery=(yyvsp[0].intval); }
#line 8937 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 1977 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8943 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 1978 "core/cfg.y" /* yacc.c:1646  */
    { ser_kill_timeout=(yyvsp[0].intval); }
#line 8949 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 1979 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8955 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 1980 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.max_while_loops=(yyvsp[0].intval); }
#line 8961 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1981 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8967 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 1982 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_size((yyvsp[0].intval)); }
#line 8973 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 1983 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8979 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 1984 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_slots((yyvsp[0].intval)); }
#line 8985 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 1985 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8991 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 1986 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_limit=(yyvsp[0].intval); }
#line 8997 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 1987 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9003 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 1988 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_action=(yyvsp[0].intval); }
#line 9009 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 1989 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9015 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 1990 "core/cfg.y" /* yacc.c:1646  */
    { http_reply_parse=(yyvsp[0].intval); }
#line 9021 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 1991 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 9027 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 1992 "core/cfg.y" /* yacc.c:1646  */
    { ksr_verbose_startup=(yyvsp[0].intval); }
#line 9033 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 1993 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 9039 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 1994 "core/cfg.y" /* yacc.c:1646  */
    { ksr_route_locks_size=(yyvsp[0].intval); }
#line 9045 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 1995 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9051 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 1996 "core/cfg.y" /* yacc.c:1646  */
    { ksr_wait_worker1_mode=(yyvsp[0].intval); }
#line 9057 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 1997 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9063 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 1998 "core/cfg.y" /* yacc.c:1646  */
    { ksr_wait_worker1_time=(yyvsp[0].intval); }
#line 9069 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 1999 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9075 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2000 "core/cfg.y" /* yacc.c:1646  */
    { ksr_wait_worker1_usleep=(yyvsp[0].intval); }
#line 9081 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2001 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9087 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2002 "core/cfg.y" /* yacc.c:1646  */
    { server_id=(yyvsp[0].intval); }
#line 9093 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2003 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9099 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2004 "core/cfg.y" /* yacc.c:1646  */
    { ksr_return_mode=(yyvsp[0].intval); }
#line 9105 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2005 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9111 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2006 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_request_route_callback.s = (yyvsp[0].strval);
			kemi_request_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_request_route_callback.len==0) {
				yyerror("empty name for request route callback function");
			}
		}
#line 9123 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2013 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9129 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2014 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_onsend_route_callback.s = (yyvsp[0].strval);
			kemi_onsend_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_onsend_route_callback.len==4
					&& strcasecmp(kemi_onsend_route_callback.s, "none")==0) {
				kemi_onsend_route_callback.s = "";
				kemi_onsend_route_callback.len = 0;
			}
		}
#line 9143 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2023 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9149 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2024 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_reply_route_callback.s = (yyvsp[0].strval);
			kemi_reply_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_reply_route_callback.len==4
					&& strcasecmp(kemi_reply_route_callback.s, "none")==0) {
				kemi_reply_route_callback.s = "";
				kemi_reply_route_callback.len = 0;
			}
		}
#line 9163 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2033 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9169 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2034 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_event_route_callback.s = (yyvsp[0].strval);
			kemi_event_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_event_route_callback.len==4
					&& strcasecmp(kemi_event_route_callback.s, "none")==0) {
				kemi_event_route_callback.s = "";
				kemi_event_route_callback.len = 0;
			}
		}
#line 9183 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2043 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9189 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2044 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_received_route_callback.s = (yyvsp[0].strval);
			kemi_received_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_received_route_callback.len==4
					&& strcasecmp(kemi_received_route_callback.s, "none")==0) {
				kemi_received_route_callback.s = "";
				kemi_received_route_callback.len = 0;
			}
		}
#line 9203 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2053 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9209 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2054 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_pre_routing_callback.s = (yyvsp[0].strval);
			kemi_pre_routing_callback.len = strlen((yyvsp[0].strval));
			if(kemi_pre_routing_callback.len==4
					&& strcasecmp(kemi_pre_routing_callback.s, "none")==0) {
				kemi_pre_routing_callback.s = "";
				kemi_pre_routing_callback.len = 0;
			}
		}
#line 9223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2063 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2064 "core/cfg.y" /* yacc.c:1646  */
    { ksr_evrt_received_mode=(yyvsp[0].intval); }
#line 9235 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2065 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 9241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2066 "core/cfg.y" /* yacc.c:1646  */
    { set_max_recursive_level((yyvsp[0].intval)); }
#line 9247 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2067 "core/cfg.y" /* yacc.c:1646  */
    { sr_dst_max_branches = (yyvsp[0].intval); }
#line 9253 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2068 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_log=(yyvsp[0].intval); }
#line 9259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2069 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 9265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2070 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_cfg_log=(yyvsp[0].intval); }
#line 9271 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2071 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 9277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2072 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_db=(yyvsp[0].intval); }
#line 9283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2073 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 9289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2074 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_action=(yyvsp[0].intval); }
#line 9295 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2075 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 9301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2076 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_cfg=(yyvsp[0].intval); }
#line 9307 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2077 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 9313 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2078 "core/cfg.y" /* yacc.c:1646  */
    { ksr_rpc_exec_delta=(yyvsp[0].intval); }
#line 9319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2079 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 9325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2080 "core/cfg.y" /* yacc.c:1646  */
    { sr_msg_time=(yyvsp[0].intval); }
#line 9331 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2081 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 9337 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2082 "core/cfg.y" /* yacc.c:1646  */
    { onsend_route_reply=(yyvsp[0].intval); }
#line 9343 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2083 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 9349 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2084 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu=(yyvsp[0].intval); }
#line 9355 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2085 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9361 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2086 "core/cfg.y" /* yacc.c:1646  */
    { ksr_udp_receiver_mode=(yyvsp[0].intval); }
#line 9367 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2087 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9373 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2089 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.force_rport=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 9379 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2090 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 9385 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2091 "core/cfg.y" /* yacc.c:1646  */
    { ksr_local_rport=(yyvsp[0].intval); }
#line 9391 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2092 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 9397 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2094 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu_try_proto=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 9403 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2096 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("TCP, TLS, SCTP or UDP expected"); }
#line 9409 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2097 "core/cfg.y" /* yacc.c:1646  */
    { IF_RAW_SOCKS(default_core_cfg.udp4_raw=(yyvsp[0].intval)); }
#line 9415 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2098 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9421 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2099 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_mtu=(yyvsp[0].intval));
	}
#line 9429 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2102 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9435 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2103 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_ttl=(yyvsp[0].intval));
	}
#line 9443 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2106 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 9449 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2108 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 9455 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2112 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 9461 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2116 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 9467 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2117 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("cfg var field name - use of number or reserved token not allowed: %s",
				yy_number_str);
		YYERROR;
	}
#line 9477 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2125 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 9487 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2130 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 9497 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2135 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].intval), 0, 0, (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 9507 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2140 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 9517 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2145 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("number or string expected");
	}
#line 9525 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2148 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_int((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].intval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 9535 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2153 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_string((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 9545 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2161 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (ksr_load_module((yyvsp[0].strval), NULL)!=0) {
				yyerror("failed to load module");
			}
	}
#line 9556 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2167 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s\n", (yyvsp[-1].strval));
			if (ksr_load_module((yyvsp[-1].strval), NULL)!=0) {
				yyerror("failed to load module");
			}
	}
#line 9567 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2173 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s opts %s\n", (yyvsp[-3].strval), (yyvsp[-1].strval));
			if (ksr_load_module((yyvsp[-3].strval), (yyvsp[-1].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 9578 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2179 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9584 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2180 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (ksr_load_modulex((yyvsp[0].strval), NULL)!=0) {
				yyerror("failed to load module");
			}
	}
#line 9595 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2186 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s\n", (yyvsp[-1].strval));
			if (ksr_load_modulex((yyvsp[-1].strval), NULL)!=0) {
				yyerror("failed to load module");
			}
	}
#line 9606 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2192 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s opts %s\n", (yyvsp[-3].strval), (yyvsp[-1].strval));
			if (ksr_load_modulex((yyvsp[-3].strval), (yyvsp[-1].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 9617 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2198 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9623 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2199 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 9638 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2209 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9644 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2210 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 9659 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2220 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9665 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2221 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9679 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2230 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9693 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2239 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 9699 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2240 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9713 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2249 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9727 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2258 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_VAR, (void*)(yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9741 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2267 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 9747 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2268 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 9758 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2274 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9764 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2275 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 9775 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2281 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9781 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2285 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9787 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2286 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9793 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2289 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[-6].intval)>255) || ((yyvsp[-6].intval)<0) ||
				((yyvsp[-4].intval)>255) || ((yyvsp[-4].intval)<0) ||
				((yyvsp[-2].intval)>255) || ((yyvsp[-2].intval)<0) ||
				((yyvsp[0].intval)>255) || ((yyvsp[0].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[-6].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[-4].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[-2].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[0].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	}
#line 9825 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2318 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		}
	}
#line 9843 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2333 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9849 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2334 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 9855 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2338 "core/cfg.y" /* yacc.c:1646  */
    {
					tmp=int2str((yyvsp[0].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
					routename = tmp;
						}
#line 9871 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2349 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 9877 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2350 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 9883 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2354 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9889 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2355 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9895 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2359 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[DEFAULT_RT]);
	}
#line 9907 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2366 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&main_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[i_tmp]);
	}
#line 9928 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2382 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 9934 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2383 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  request_route  statement"); }
#line 9940 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2386 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9946 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2389 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[DEFAULT_RT]);
	}
#line 9958 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2396 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&failure_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[i_tmp]);
	}
#line 9979 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2412 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 9985 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2416 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9991 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2417 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9997 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2422 "core/cfg.y" /* yacc.c:1646  */
    {rt=CORE_ONREPLY_ROUTE;}
#line 10003 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2422 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
	}
#line 10015 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2429 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 10021 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2430 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 10027 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2432 "core/cfg.y" /* yacc.c:1646  */
    {rt=(*(yyvsp[-1].strval)=='0' && (yyvsp[-1].strval)[1]==0)?CORE_ONREPLY_ROUTE:TM_ONREPLY_ROUTE;}
#line 10033 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2433 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (*(yyvsp[-5].strval)=='0' && (yyvsp[-5].strval)[1]==0){
			/* onreply_route[0] {} is equivalent with onreply_route {}*/
			push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
		}else{
			i_tmp=route_get(&onreply_rt, (yyvsp[-5].strval));
			if (i_tmp==-1){
				yyerror("internal error");
				YYABORT;
			}
			if (onreply_rt.rlist[i_tmp]){
				yyerror("duplicate route");
				YYABORT;
			}
			push((yyvsp[-1].action), &onreply_rt.rlist[i_tmp]);
		}
	}
#line 10059 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2454 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("invalid onreply_route statement");
	}
#line 10067 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2459 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 10073 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2462 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[DEFAULT_RT]);
	}
#line 10085 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2469 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&branch_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[i_tmp]);
	}
#line 10106 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2485 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 10112 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2488 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 10118 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2491 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[DEFAULT_RT]);
	}
#line 10130 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2498 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&onsend_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[i_tmp]);
	}
#line 10151 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2514 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onsend_route statement"); }
#line 10157 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2517 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 10163 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2520 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&event_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &event_rt.rlist[i_tmp]);
	}
#line 10184 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2537 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 10190 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2540 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_subst_add((yyvsp[0].strval))<0) YYERROR; }
#line 10196 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2541 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid subst preprocess statement"); }
#line 10202 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2542 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), KSR_PPDEF_NORMAL)<0) YYERROR; }
#line 10208 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2543 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdef preprocess statement"); }
#line 10214 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2544 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), KSR_PPDEF_QUOTED)<0) YYERROR; }
#line 10220 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2545 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdefs preprocess statement"); }
#line 10226 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2567 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 10232 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2568 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 10238 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2569 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 10244 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2570 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 10250 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2573 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 10256 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2574 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 10262 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2575 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 10268 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2576 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 10274 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2579 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 10280 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2580 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 10286 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2586 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_EQ_OP; }
#line 10292 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2587 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_DIFF_OP; }
#line 10298 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2588 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IEQ_OP; }
#line 10304 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2589 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IDIFF_OP; }
#line 10310 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2590 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STREQ_OP; }
#line 10316 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2591 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STRDIFF_OP; }
#line 10322 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2592 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_MATCH_OP; }
#line 10328 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2595 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GT_OP; }
#line 10334 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2596 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LT_OP; }
#line 10340 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2597 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GTE_OP; }
#line 10346 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 2598 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LTE_OP; }
#line 10352 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 2605 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=URI_O;}
#line 10358 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2606 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=FROM_URI_O;}
#line 10364 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2607 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=TO_URI_O;}
#line 10370 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2614 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDPORT_O; }
#line 10376 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2615 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=TOPORT_O; }
#line 10382 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2616 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDAF_O; }
#line 10388 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2620 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCPORT_O; }
#line 10394 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 2621 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTPORT_O; }
#line 10400 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2622 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=AF_O; }
#line 10406 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2623 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=MSGLEN_O; }
#line 10412 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2629 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; }
#line 10418 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2630 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("to_ip");  (yyval.intval)=TOIP_O; }
#line 10424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2633 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCIP_O; }
#line 10430 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2634 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTIP_O; }
#line 10436 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2642 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)= mk_elem((yyvsp[-1].intval), METHOD_O, 0, RVE_ST, (yyvsp[0].rv_expr));}
#line 10442 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2644 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), METHOD_O, 0, STRING_ST,(yyvsp[0].strval)); }
#line 10448 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2645 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string expected"); }
#line 10454 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2647 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); }
#line 10460 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2649 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr)); }
#line 10466 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2651 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 10472 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2653 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string or MYSELF expected"); }
#line 10478 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2655 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); }
#line 10484 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2656 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 10490 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2658 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 10496 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2659 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 10502 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2660 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 10508 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2661 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); }
#line 10514 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2663 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 10520 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2665 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 10526 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2667 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 10532 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2669 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 10538 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2671 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 10544 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2673 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 10550 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2674 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST, (yyvsp[0].ipnet)); }
#line 10556 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2675 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[0].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[0].rv_expr));
				if (i_tmp==RV_LONG)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[0].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					/* warn("non constant rvalue in ip comparison") */;
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST,
								mk_new_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
			}
		}
#line 10597 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2712 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, STRING_ST, (yyvsp[0].strval)); }
#line 10603 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2714 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 10609 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2716 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); }
#line 10615 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2718 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");}
#line 10621 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2721 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 10627 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2723 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 10633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2725 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("URI, SRCIP or DSTIP expected"); }
#line 10639 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2726 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); }
#line 10645 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2730 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net((yyvsp[-2].ipaddr), (yyvsp[0].ipaddr)); }
#line 10651 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2731 "core/cfg.y" /* yacc.c:1646  */
    {
		if (((yyvsp[0].intval)<0) || ((yyvsp[0].intval)>(yyvsp[-2].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_new_net_bitlen((yyvsp[-2].ipaddr), (yyvsp[0].intval));
		/*
			$$=mk_new_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	}
#line 10667 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2742 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8); }
#line 10673 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2743 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); }
#line 10679 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2747 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 10685 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2748 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10705 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2763 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10725 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2778 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 10731 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2779 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 10737 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2784 "core/cfg.y" /* yacc.c:1646  */
    {
			/* get string version */
			i_tmp = strlen(yy_number_str);
			(yyval.strval)=pkg_malloc(i_tmp + 1);
			if ((yyval.strval)==0) {
				PKG_MEM_ERROR;
			} else {
				memcpy((yyval.strval), yy_number_str, i_tmp);
				(yyval.strval)[i_tmp] = '\0';
			}
		}
#line 10753 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2798 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 10759 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2799 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10779 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2814 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10799 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2829 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 10806 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2831 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 10813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2838 "core/cfg.y" /* yacc.c:1646  */
    {
		/* check if allowed */
		if ((yyvsp[0].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[0].action)->type) {
				case DROP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE0_T:
				case MODULE1_T:
				case MODULE2_T:
				case MODULE3_T:
				case MODULE4_T:
				case MODULE5_T:
				case MODULE6_T:
				case MODULEX_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[0].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[0].action);
		}
	}
#line 10850 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2880 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 10856 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2881 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 10862 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2884 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 10868 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2885 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 10874 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2886 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command"); }
#line 10880 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2889 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 10886 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2890 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 10892 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2891 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 10898 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2892 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 10904 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2893 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 10910 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2894 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 10916 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2895 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 10922 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2896 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 10928 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2899 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 10941 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2907 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-3].rv_expr) && rval_expr_int_check((yyvsp[-3].rv_expr))>=0){
			warn_ct_rve((yyvsp[-3].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-3].rv_expr), ACTIONS_ST, (yyvsp[-2].action), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 10954 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2917 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.rv_expr)=0;
			if ((yyvsp[0].rv_expr) && !rve_is_constant((yyvsp[0].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_LONG){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[0].rv_expr);
		}
#line 10974 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2934 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10986 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2941 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 1, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10998 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2948 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 11010 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2955 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 11022 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2962 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 11032 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2967 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 11042 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2972 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 11048 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2973 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 11054 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2974 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 11060 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2975 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 11066 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 2976 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror ("bad case body"); }
#line 11072 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2979 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[-1].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[0].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	}
#line 11086 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 2988 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[0].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	}
#line 11096 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 2995 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((yyvsp[-3].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[-1].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-3].rv_expr), CASE_ST, (yyvsp[-1].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 11126 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 3020 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[-2].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-2].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 11147 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 3036 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror ("bad expression in switch(...)"); }
#line 11153 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 3038 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror ("bad switch body"); }
#line 11159 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 3042 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[-1].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	}
#line 11174 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 3061 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[0].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[0].strval));
		sel.n++;
	}
#line 11188 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 3070 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[-1].intval);
		sel.n++;
	}
#line 11205 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 3082 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-1].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-1].strval));
		sel.n++;
	}
#line 11223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 3101 "core/cfg.y" /* yacc.c:1646  */
    { sel.n = 0; sel.f[0] = 0; }
#line 11229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 3101 "core/cfg.y" /* yacc.c:1646  */
    {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	}
#line 11242 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 3111 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM; }
#line 11248 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 3112 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO; }
#line 11254 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 3113 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; }
#line 11260 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 3114 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; }
#line 11266 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 3115 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; }
#line 11272 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 3116 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; }
#line 11278 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 3117 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; }
#line 11284 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 3118 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; }
#line 11290 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3119 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; }
#line 11296 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 3122 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[0].strval); s_attr->name.s.len = strlen ((yyvsp[0].strval)); }
#line 11302 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3129 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else { memset(s_attr, 0, (sizeof(struct avp_spec))); }
	}
#line 11312 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3136 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.attr) = s_attr; }
#line 11318 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3139 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[-1].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[-1].intval)<0?-(yyvsp[-1].intval):(yyvsp[-1].intval));
		(yyval.attr) = s_attr;
	}
#line 11328 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3146 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	}
#line 11337 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3168 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[0].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[0].lval));
	}
#line 11354 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3180 "core/cfg.y" /* yacc.c:1646  */
    {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[0].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	}
#line 11381 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3204 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
			pv_spec=pv_cache_get(&s_tmp);
			if (!pv_spec) {
				yyerror("Can't get from cache: %s", (yyvsp[0].strval));
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		}
#line 11395 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3215 "core/cfg.y" /* yacc.c:1646  */
    {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen(s_tmp.s);
				lval_tmp->lv.pvs = pv_cache_get(&s_tmp);
				if (lval_tmp->lv.pvs==NULL){
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambiguous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			}
#line 11421 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3246 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = ASSIGN_T; }
#line 11427 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3250 "core/cfg.y" /* yacc.c:1646  */
    {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[0].attr);
					pkg_free((yyvsp[0].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				}
#line 11442 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3260 "core/cfg.y" /* yacc.c:1646  */
    {
					if (!pv_is_w((yyvsp[0].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[0].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=(yyvsp[0].pvar);
					(yyval.lval)=lval_tmp;
				}
#line 11461 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3274 "core/cfg.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].lval))->type==LV_PVAR){
						if (!pv_is_w((yyvsp[0].lval)->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[0].lval)->lv.pvs->trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[0].lval);
				}
#line 11476 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3286 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_LONG, (void*)(yyvsp[0].intval)); }
#line 11482 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3287 "core/cfg.y" /* yacc.c:1646  */
    {	s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); }
#line 11489 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3289 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[0].attr)); pkg_free((yyvsp[0].attr)); }
#line 11495 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3290 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].pvar)); }
#line 11501 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3291 "core/cfg.y" /* yacc.c:1646  */
    {
							switch((yyvsp[0].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[0].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[0].lval)); /* not needed anymore */
						}
#line 11520 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3305 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[0].select)); pkg_free((yyvsp[0].select)); }
#line 11526 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3306 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[0].action)); }
#line 11532 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3307 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[0].expr)); }
#line 11538 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3308 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 11544 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3309 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad command block"); }
#line 11550 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3310 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 11556 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3311 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11562 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3315 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_LNOT_OP; }
#line 11568 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3316 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_BNOT_OP; }
#line 11574 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3317 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_UMINUS_OP; }
#line 11580 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3330 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[0].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									}
#line 11591 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3336 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1((yyvsp[-1].intval), (yyvsp[0].rv_expr)); }
#line 11597 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3337 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_LONG_OP, (yyvsp[0].rv_expr)); }
#line 11603 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3338 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[0].rv_expr)); }
#line 11609 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3339 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11615 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3340 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11621 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3341 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11627 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3342 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3343 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11639 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3344 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr)); }
#line 11645 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3345 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 11651 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3346 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BXOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 11657 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3347 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BLSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 11663 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3348 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BRSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 11669 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3349 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2( (yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 11675 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3350 "core/cfg.y" /* yacc.c:1646  */
    {
			/* comparing with $null => treat as defined or !defined */
			if((yyvsp[0].rv_expr) != NULL && (yyvsp[0].rv_expr)->op==RVE_RVAL_OP && (yyvsp[0].rv_expr)->left.rval.type==RV_PVAR
					&& (yyvsp[0].rv_expr)->left.rval.v.pvs.type==PVT_NULL) {
				if((yyvsp[-1].intval)==RVE_DIFF_OP || (yyvsp[-1].intval)==RVE_IDIFF_OP
						|| (yyvsp[-1].intval)==RVE_STRDIFF_OP) {
					DBG("comparison with $null switched to notdefined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[-2].rv_expr));
				} else {
					DBG("comparison with $null switched to defined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_NOTDEFINED_OP, (yyvsp[-2].rv_expr));
				}
				/* free rve struct for $null */
				rve_destroy((yyvsp[0].rv_expr));
			} else {
				(yyval.rv_expr)=mk_rve2((yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));
			}
		}
#line 11698 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3368 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 11704 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3369 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 11710 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3370 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[-1].rv_expr);}
#line 11716 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3371 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[-1].rv_expr));}
#line 11722 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3372 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[-1].rv_expr));}
#line 11728 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3373 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[0].rv_expr));}
#line 11734 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3374 "core/cfg.y" /* yacc.c:1646  */
    {
				rve_tmp=mk_rve2(RVE_SELVALOPT_OP, (yyvsp[-3].rv_expr), (yyvsp[-1].rv_expr));
				if(rve_tmp == NULL) {
					(yyval.rv_expr)=0;
					yyerror("failed to create tenary target expression");
				}
				(yyval.rv_expr)=mk_rve2(RVE_SELVALEXP_OP, (yyvsp[-5].rv_expr), rve_tmp);
		}
#line 11747 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3382 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11753 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3383 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11759 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3384 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11765 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3385 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11771 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3386 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11777 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 3387 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11783 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 828:
#line 3388 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11789 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 829:
#line 3389 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 3390 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11801 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3391 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11807 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3393 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3395 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11819 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 3396 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11825 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 3397 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11831 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3398 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11837 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 3399 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11843 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 3400 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11849 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 839:
#line 3401 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11855 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 840:
#line 3404 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action((yyvsp[-1].intval), 2, LVAL_ST, (yyvsp[-2].lval),
														 	  RVE_ST, (yyvsp[0].rv_expr));
											set_cfg_pos((yyval.action));
										}
#line 11864 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 3422 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 1; }
#line 11870 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 3423 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 0; }
#line 11876 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3424 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = -1; }
#line 11882 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3427 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11888 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 3428 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11894 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 846:
#line 3429 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11900 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3430 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11906 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 3431 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11912 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 3432 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11918 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 850:
#line 3433 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11924 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 851:
#line 3434 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11930 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 852:
#line 3435 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11936 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 3436 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11942 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 3437 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11948 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 855:
#line 3438 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward argument"); }
#line 11954 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 856:
#line 3439 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11960 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 857:
#line 3440 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11966 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 858:
#line 3441 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11972 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 859:
#line 3442 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11978 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 860:
#line 3443 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11984 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 861:
#line 3444 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11990 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 862:
#line 3445 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11996 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 863:
#line 3446 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12002 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 864:
#line 3447 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 12008 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 3448 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12014 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 866:
#line 3449 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_udp argument"); }
#line 12020 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 3450 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 12026 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 868:
#line 3451 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 12032 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 869:
#line 3452 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 12038 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 870:
#line 3453 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12044 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 3454 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12050 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 872:
#line 3455 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12056 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 873:
#line 3456 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 12062 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 874:
#line 3457 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12068 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 875:
#line 3458 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 12074 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 876:
#line 3459 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12080 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 877:
#line 3460 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_tcp argument"); }
#line 12086 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 878:
#line 3461 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 12099 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 879:
#line 3469 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 12112 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 880:
#line 3477 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 12125 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 881:
#line 3485 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 12138 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 882:
#line 3493 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 12151 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 883:
#line 3501 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					}
#line 12164 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 884:
#line 3509 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 12177 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 885:
#line 3517 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 12190 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 886:
#line 3525 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 12203 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 887:
#line 3533 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12209 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 888:
#line 3534 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_tls argument"); }
#line 12216 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 889:
#line 3536 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 890:
#line 3544 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12242 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 891:
#line 3552 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12255 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 3560 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12269 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 893:
#line 3569 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 894:
#line 3578 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					}
#line 12297 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 895:
#line 3587 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12310 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 896:
#line 3595 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12324 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 897:
#line 3604 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 12337 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 898:
#line 3612 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12343 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 899:
#line 3613 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_sctp argument"); }
#line 12350 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 900:
#line 3615 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[-1].strval));
									set_cfg_pos((yyval.action)); }
#line 12358 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 901:
#line 3618 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[-3].intval), STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12364 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 902:
#line 3619 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12370 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 903:
#line 3620 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log argument"); }
#line 12376 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 904:
#line 3621 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 12388 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 905:
#line 3628 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 12400 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 906:
#line 3635 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 12406 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 907:
#line 3636 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 12417 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 908:
#line 3642 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 12429 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 909:
#line 3649 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 12435 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 910:
#line 3650 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 12446 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 911:
#line 3656 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 12458 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 912:
#line 3663 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 12464 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 913:
#line 3664 "core/cfg.y" /* yacc.c:1646  */
    {
		i_tmp=get_avpflag_no((yyvsp[-1].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[-3].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[-5].intval));
		set_cfg_pos((yyval.action));
	}
#line 12475 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 914:
#line 3670 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing flag name");
	}
#line 12483 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 915:
#line 3673 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	}
#line 12491 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 916:
#line 3676 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad parameters"); }
#line 12497 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 917:
#line 3677 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 12503 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 918:
#line 3678 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[-3].strval), STRING_ST, (yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
	}
#line 12511 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 919:
#line 3681 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12517 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 920:
#line 3682 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error argument"); }
#line 12523 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 921:
#line 3683 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr)) {
			(yyval.action) = mk_action(ROUTE_T, 1, RVE_ST, (void*)(yyvsp[-1].rv_expr));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 12537 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 922:
#line 3692 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].strval)) {
			(yyval.action) = mk_action(ROUTE_T, 1, STRING_ST, (void*)(yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 12551 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 923:
#line 3701 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12557 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 924:
#line 3702 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route argument"); }
#line 12563 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 925:
#line 3703 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12569 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 926:
#line 3704 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12575 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 927:
#line 3705 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12581 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 928:
#line 3706 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12587 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 929:
#line 3707 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12593 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 930:
#line 3708 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12599 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 931:
#line 3709 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12605 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 932:
#line 3710 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12611 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 933:
#line 3711 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12617 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 934:
#line 3712 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12623 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 935:
#line 3713 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12629 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 936:
#line 3714 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12635 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 937:
#line 3715 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12641 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 938:
#line 3716 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); }
#line 12647 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 939:
#line 3717 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12653 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 940:
#line 3718 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
	}
#line 12662 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 941:
#line 3722 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 0);
			set_cfg_pos((yyval.action));
	}
#line 12671 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 942:
#line 3726 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12677 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 943:
#line 3727 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12683 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 944:
#line 3728 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(CLEAR_BRANCHES_T, 0); set_cfg_pos((yyval.action)); }
#line 12689 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 945:
#line 3729 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12695 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 946:
#line 3730 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12701 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 947:
#line 3731 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12707 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 948:
#line 3732 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12713 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 949:
#line 3733 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12719 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 950:
#line 3734 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12725 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 951:
#line 3735 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12731 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 952:
#line 3736 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12737 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 953:
#line 3737 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12743 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 954:
#line 3738 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12749 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 955:
#line 3739 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12755 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 956:
#line 3740 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12761 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 957:
#line 3741 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12767 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 958:
#line 3742 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12773 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 959:
#line 3743 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12779 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 960:
#line 3744 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12785 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 961:
#line 3745 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12791 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 962:
#line 3746 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12797 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 963:
#line 3747 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 12803 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 964:
#line 3748 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 12809 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 965:
#line 3749 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12815 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 966:
#line 3750 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12821 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 967:
#line 3751 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12827 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 968:
#line 3752 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12833 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 969:
#line 3753 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12846 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 970:
#line 3761 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12859 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 971:
#line 3769 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12872 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 972:
#line 3777 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12878 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 973:
#line 3779 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12884 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 974:
#line 3781 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); }
#line 12890 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 975:
#line 3782 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			str_tmp->s=(yyvsp[-1].strval);
			str_tmp->len=(yyvsp[-1].strval)?strlen((yyvsp[-1].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	}
#line 12906 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 976:
#line 3793 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12912 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 977:
#line 3794 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12918 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 978:
#line 3795 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		tmp=int2str((yyvsp[-1].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	}
#line 12939 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 979:
#line 3811 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12945 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 980:
#line 3812 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12951 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 981:
#line 3813 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[-1].sockid));
		set_cfg_pos((yyval.action));
	}
#line 12960 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 982:
#line 3817 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	}
#line 12968 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 983:
#line 3820 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12974 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 984:
#line 3821 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12982 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 985:
#line 3824 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12990 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 986:
#line 3827 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12998 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 987:
#line 3830 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 13006 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 988:
#line 3833 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 13014 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 989:
#line 3836 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 13022 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 990:
#line 3839 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 13030 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 991:
#line 3842 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 13038 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 992:
#line 3845 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
	}
#line 13046 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 993:
#line 3848 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), RVE_ST, (yyvsp[-1].rv_expr)); set_cfg_pos((yyval.action));
	}
#line 13054 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 994:
#line 3851 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 13060 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 995:
#line 3852 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string and number expected"); }
#line 13066 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 996:
#line 3853 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_RESET_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action));
	}
#line 13074 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 997:
#line 3856 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 13080 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 998:
#line 3857 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string expected"); }
#line 13086 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 999:
#line 3858 "core/cfg.y" /* yacc.c:1646  */
    {
		if (mod_func_action != NULL) {
			LM_ERR("function used inside params of another function: %s\n", (yyvsp[0].strval));
			yyerror("use of function execution inside params not allowed\n");
			ksr_exit(-1);
		}
		mod_func_action = mk_action(MODULE0_T, 2, MODEXP_ST, NULL, NUMBER_ST, 0);
		}
#line 13099 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 3865 "core/cfg.y" /* yacc.c:1646  */
    {
		mod_func_action->val[0].u.data =
			find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, rt);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, 0) ) {
					LM_ERR("misused command %s\n", (yyvsp[-4].strval));
					yyerror("Command cannot be used in the block\n");
			} else {
				LM_ERR("cfg. parser: failed to find command %s (params %ld)\n",
						(yyvsp[-4].strval), mod_func_action->val[1].u.number);
				yyerror("unknown command, missing loadmodule?\n");
			}
			free_mod_func_action(mod_func_action);
			mod_func_action=0;
		}else{
			if (mod_func_action && mod_f_params_pre_fixup(mod_func_action)<0) {
				/* error messages are printed inside the function */
				/* free_mod_func_action(mod_func_action); */
				mod_func_action = 0;
				YYERROR;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
		mod_func_action = NULL;
	}
#line 13130 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 3891 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("'('')' expected (function call)");}
#line 13136 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 3895 "core/cfg.y" /* yacc.c:1646  */
    { }
#line 13142 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 3896 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 13148 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 3899 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].rv_expr) && mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				RVE_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.data =
				(yyvsp[0].rv_expr);
			mod_func_action->val[1].u.number++;
		} else if ((yyvsp[0].rv_expr)) {
			yyerror("Too many arguments\n");
			YYERROR;
		} else {
			YYERROR;
		}
	}
#line 13167 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 3916 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 13176 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 3920 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 13185 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 3924 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 13194 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 3928 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 13204 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 3933 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 13213 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 3937 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 13223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 3942 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 13232 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 3946 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 13241 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1014:
#line 3950 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	}
#line 13250 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 1015:
#line 3954 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	}
#line 13259 "core/cfg.tab.c" /* yacc.c:1646  */
    break;


#line 13263 "core/cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3960 "core/cfg.y" /* yacc.c:1906  */


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
	pos->rname=(routename!=0)?routename:default_routename;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_WARN("warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_WARN("warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_CRIT("parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_CRIT("parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_CRIT("parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
	if(ksr_all_errors==0) {
		ksr_exit(-1);
	}
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;

	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_LONG && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct name_lst));
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;

	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;

	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;

	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/** fixes the parameters and the type of a module function call.
 * It is done here instead of fix action, to have quicker feedback
 * on error cases (e.g. passing a non constant to a function with a
 * declared fixup)
 * The rest of the fixup is done inside do_action().
 * @param a - filled module function call (MODULE*_T) action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 * @return 0 on success, -1 on error (it will also print the error msg.).
 *
 */
static int mod_f_params_pre_fixup(struct action* a)
{
	ksr_cmd_export_t* cmd_exp;
	action_u_t* params;
	int param_no;
	struct rval_expr* rve;
	struct rvalue* rv;
	int r;
	str s;

	cmd_exp = a->val[0].u.data;
	param_no = a->val[1].u.number;
	params = &a->val[2];

	switch(cmd_exp->param_no) {
		case 0:
			a->type = MODULE0_T;
			break;
		case 1:
			a->type = MODULE1_T;
			break;
		case 2:
			a->type = MODULE2_T;
			break;
		case 3:
			a->type = MODULE3_T;
			break;
		case 4:
			a->type = MODULE4_T;
			break;
		case 5:
			a->type = MODULE5_T;
			break;
		case 6:
			a->type = MODULE6_T;
			break;
		case VAR_PARAM_NO:
			a->type = MODULEX_T;
			break;
		default:
			yyerror("function %s: bad definition"
					" (invalid number of parameters)", cmd_exp->name);
			return -1;
	}

	if ( cmd_exp->fixup) {
		if (is_fparam_rve_fixup(cmd_exp->fixup))
			/* mark known fparam rve safe fixups */
			cmd_exp->fixup_flags  |= FIXUP_F_FPARAM_RVE;
		else if (!(cmd_exp->fixup_flags & FIXUP_F_FPARAM_RVE) &&
				 cmd_exp->free_fixup == 0) {
			/* v0 or v1 functions that have fixups and no corresp. fixup_free
			   functions, need constant, string params.*/
			for (r=0; r < param_no; r++) {
				rve=params[r].u.data;
				if (!rve_is_constant(rve)) {
					yyerror_at(&rve->fpos, "function %s: parameter %d is not"
								" constant\n", cmd_exp->name, r+1);
					return -1;
				}
				if ((rv = rval_expr_eval(0, 0, rve)) == 0 ||
						rval_get_str(0, 0, &s, rv, 0) < 0 ) {
					/* out of mem or bug ? */
					rval_destroy(rv);
					yyerror_at(&rve->fpos, "function %s: bad parameter %d"
									" expression\n", cmd_exp->name, r+1);
					return -1;
				}
				rval_destroy(rv);
				rve_destroy(rve);
				params[r].type = STRING_ST; /* asciiz */
				params[r].u.string = s.s;
				params[r].u.str.len = s.len; /* not used right now */
			}
		}
	}/* else
		if no fixups are present, the RVEs can be transformed
		into strings at runtime, allowing seamless var. use
		even with old functions.
		Further optimizations -> in fix_actions()
		*/
	return 0;
}



/** frees a filled module function call action structure.
 * @param a - filled module function call action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 */
static void free_mod_func_action(struct action* a)
{
	action_u_t* params;
	int param_no;
	int r;

	param_no = a->val[1].u.number;
	params = &a->val[2];

	for (r=0; r < param_no; r++)
		if (params[r].u.data)
			rve_destroy(params[r].u.data);
	pkg_free(a);
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/
